Attribute VB_Name = "GLOB_Prozeduren"
Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:.
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   GLOB_Prozeduren
' Effekt:
'   Das Modul enthlt alle Funktionen, die in Add-Ins verwendet werden.
' Restriktionen:
'   Das Modul mit den sprachabhngigen Texten GLOB_sss muss vorhanden sein. Dabei ist sss die
'   Sprache.
' Entwicklung und Test:
'   siehe Dokumentation
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   23.01.2002  von allen drei Add-Ins genutzte Funktionen nach PDF_Global.bas ausgelagert
'   09.05.2002  Erweitert um Parameter oneslideflag, onetable_flag und psfiledel_flag sowie die
'               zugehrige Verarbeitung
'   09.05.2002  Neue Funktion fbDatei_pruefen_loeschen
'   17.05.2002  Prozentzeichen % darf nicht in Dateinamen vorkommen, Ghostscript kann damit nicht
'               umgehen
'   18.05.2002  Auf UserForm umgestellt , Parametersteuerung je Add-In
'   23.06.2002  Defaults beim Lesen aus der Registry erweitert
'   01.07.2002  Formal berarbeitet
'   19.07.2002  Komplett umgebaut fr Version 2.40
'   25.08.2002  Erweitert fr Version 2.41
'   04.09.2002  Erweitert fr Version 2.42
'   30.11.2002  Erweitert um Parameter ghostscript_shellswitch, ghostscript_parameter und
'               logfiledel_flag sowie die zugehrige Verarbeitung
'   05.10.2003  Erweitert fr Ghostscript 8.11
'   05.10.2003  Erweitert fr Rahmen in Powerpoint
'   05.10.2003  Erweitert um Protokollierung aller nderungen in der Konfiguration
'   15.05.2004  Erweitert fr Ghostscript 8.13 und 8.14
'   02.04.2005  Erweitert fr Ghostscript 8.50 und 8.15
'   21.05.2005  Erweitert fr Ghostscript 8.51
'   19.02.2006  Erweitert fr Ghostscript 8.53
'   15.02.2006  Fehlermeldungen wenn Problem mit Installationsverzeichnis

' Die folgenden Eintrge werden in der Registry fr alle drei Add-Ins gemeinsam gespeichert
'------------------------------------------------------------------------------------------
'[HKEY_CURRENT_USER\Software\VB and VBA Program Settings\WordMakros von J.W.Schmitz-Huebsch\Gs4Word]
    'Registry-Pfad fr die in allen drei Add-Ins gleichen Eintrge.
'"debug_flag"
    'Dieser Eintrag steuert, ob die Statements "On Error GoTo Fehler_aufgetreten:" aktiviert sind
    'und ob in einer spteren Version Debug-Informationen in die Datei debug.txt geschrieben werden.
    'Hier alle Mglichkeiten:
    'Falsch =  0 = Debug ausgeschaltet.
    'Wahr   = -1 = Debug angeschaltet.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry Falsch
    'angenommen.
'"doku_aufruf"
    'Aufruf des Browsers mit der HTML-Dokumentation von Gs4Word.
    'Der Eintrag wird immer verwendet.
    'Hier zwei Muster:
    '"c:\\programme\\netscape\\netscape.exe c:\\programme\\Gs4Word\\Dokumentation.html"
    '""
    'Der Eintrag wird vom Word-Add-In Gs4WordInstallation.dot angelegt.
    'Wenn der Eintrag in der Registry fehlt oder leer ist, kann die Dokumentation nicht angezeigt
    'werden.
'"inst_dir"
    'Pfad zum Installationsverzeichnis.
    'Der Eintrag wird immer verwendet.
    'Hier ein Muster:
    '"c:\\programme\\Gs4Word_240ger.dot\\"
    'Der Eintrag wird vom Word-Add-In Gs4WordInstallation.dot angelegt.
    'Wenn der Eintrag in der Registry fehlt, kann Gs4Word nicht konfiguriert werden.
'"inst_logbuch"
    'Pfad und Programmname des Installations-Logbuchs.
    'Der Eintrag wird immer verwendet.
    'Hier ein Muster:
    '"c:\\programme\\Gs4Word_300\\Installation_RECHNERXYZ.txt"
    'Wenn der Eintrag in der Registry fehlt, wird als Pfad inst_dir und die Datei
    'Installation_RECHNERXYZ.txt eingetragen. Dabei ist RECHNERXYZ der Name des Rechners.
'"language_switch"
    'Dieser Eintrag enthlt die Einstellung fr die Sprache.
    'Die Werte werden in den Konstanten sSPRACHSWITCH_... festgelegt.
    'Hier alle Mglichkeiten:
    '""     keine Auswahl
    '"de"   Deutsch
    '"en"   Englisch
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "de" angenommen.
'"ghostscript_name"
    'Pfad und Programmname von Ghoststcript.
    'Der Eintrag wird immer verwendet.
    'Hier ein Muster:
    '"c:\\programme\\gs\\gs7.00\\bin\\gswin32c.exe"
    'Wenn der Eintrag in der Registry fehlt, werden im Modul TECH_Konfiguration fr die Versionen
    'Programms 8.53, 8.51, 8.50, 8.15, 8.14, 8.13, 8.11, 8.00, 7.07, 7.06, 7.05, 7.04, 7.03 und 7.00 von Ghostscript je fnf Versuche zur Ermittlung des
    '"gswin32c.exe" unternommen.
    '   (1) Die Ghostscript-DLL in der Registry suchen
    '       ("HKEY_LOCAL_MACHINE\SOFTWARE\AFPL Ghostscript\9.99", Key "GS_DLL")
    '       ("HKEY_LOCAL_MACHINE\SOFTWARE\GNU Ghostscript\9.99", Key "GS_DLL")
    '       und prfen, ob dort auch das Programm steht.
    '   (2) Prfen, ob das Programm in "C:\gs\gs9.99\bin\" steht.
    '       Dieses Verzeichnis wird bei der Installation vorgeschlagen.
    '   (3) Prfen ob das Programm im Standard-Programmverzeichnis
    '       ("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion", Key "ProgramFilesDir")
    '       unter "\gs\gs9.99\bin\" steht.
    '   (4) Prfen, ob das Programm im Installationsverzeichnis von Gs4Word unter "\gs\gs9.99\bin\"
    '       steht.
    '   (5) Prfen, ob das Programm parallel zum Installationsverzeichnis von Gs4Word unter
    '       "\gs\gs9.99\bin\" steht.
'"ghostscript_paramkonf"
    'Pfad und Programmname der Konfigurations-Parameter von Ghoststcript.
    'Der Eintrag wird immer verwendet.
    'Hier ein Muster:
    '"c:\\programme\\Gs4Word_300\\Konfiguration\\GsParam_80x.txt"
    'Wenn der Eintrag in der Registry fehlt, wird fr Ghostscript 8.1x als Pfad inst_dir und die
    'Datei Konfiguration\\GsParam_81x.txt eingetragen. Fr Ghostscript 8.0x wird als Pfad inst_dir
    'Datei Konfiguration\\GsParam_80x.txt eingetragen. Ansonsten wird als Pfad inst_dir und die
    'Datei Konfiguration\\GsParam_70x.txt eingetragen.
'"ghostscript_shellswitch"
    'Dieser Eintrag enthlt die Einstellung fr Anzeige von Ghostscript.
    'Die Werte werden in den Konstanten sGSSHELLSWITCH_... festgelegt.
    'Hier alle Mglichkeiten:
    '"0"    Das Fenster ist ausgeblendet, und das ausgeblendete Fenster erhlt den Fokus.
    '"1"    Das Fenster hat den Fokus, und die ursprngliche Gre und Position wird wiederhergestellt.
    '"2"    Das Fenster wird als Symbol mit Fokus angezeigt.
    '"3"    Das Fenster wird maximiert mit Fokus angezeigt.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "1" angenommen.
'"mailto_name"
    'Pfad und Programmnamen des MailProgramms. Zur Zeit funktioniert nur Outlook 97/98/2000 (nicht
    'Outlook Express)
    'Hier einige Muster:
    'sLEER wenn der Eintrag in der Registry fehlt
    '"c:\programme\Microsoft Office\Office\OUTLOOK.EXE" fr Outlook 97/98/2000
    '"c:\programme\Netscape...\netscape.exe" fr Netscape 4.xx
    'Wenn der Eintrag in der Registry fehlt, wird im Modul DOC_Konfiguration das Programm aus der
    'dem Registry-Eintrag "HKEY_LOCAL_MACHINE\SOFTWARE\classes\mailto\shell\open\command" mit dem
    'Key sLEER verwendet.
'"mailto_parameter"
    'Parameter zum Mail-Programm.
    'Wenn der Eintrag in der Registry fehlt, wird im Modul DOC_Konfiguration ein Standard-Eintrag
    'verwendet. Dabei reprsentiert das Prozentzeichen (%) der Name der PDF-Datei:
    '   "/c ipm.note /A %" fr Outlook 97/98/2000
    '   "-compose -%" fr fr Netscape 4.xx
'"max_wartezeit"
    'Dieser Eintrag enthlt die Anzahl Sekunden, die auf diesem Rechner MAXIMAL gewartet werden
    'muss, um einen Prozess zu starten und die Verarbeitung zu beginnen.
    'Rckgabewert:
    '   Prozessortakt in MHZ >=533 >=266 >=200  ansonsten
    '   MaxRechnerWartezeit      6    12    18     24
    'Der Eintrag steht nur deshalb in der Registry, weil System.PrivateProfileString in Excel97
    'nicht funktioniert. Er kann im Dialog NICHT gendert werden.
    'Wenn der Eintrag in der Registry fehlt, wird beim Lesen aus der Registry "0" angenommen.
    'Der Wert wird wird jedesmal neu berechnet, wenn Konfigurieren aufgerufen wird.
'"path_separator"
    'Dieser Eintrag enthlt den Pfad-Separator.
    'Hier alle Mglichkeiten:
    '"\"
    'Der Eintrag steht nur deshalb in der Registry, weil OFFEN in Excel97 nicht funktioniert.
    'Er kann im Dialog NICHT gendert werden.
    'Wenn der Eintrag in der Registry fehlt, wird beim Lesen aus der Registry sLEER angenommen.
    'Der Wert wird wird jedesmal neu ermittelt, wenn Konfigurieren aufgerufen wird.
'"print2file_flag"
    'Nach dem Erstellen der Postscript-Datei auf dem Drucker aus "printer_name" ist die Word-
    'Einstellung "Ausgabe in Datei umleiten" immer angeschaltet. Dieser Eintrag steuert, er nach dem
    'Erstellen der Postscript-Datei wieder ausgeschaltet werden soll. Dazu werden noch einmal 0
    'Seiten auf dem Postscript-Drucker gedruckt. Deshalb darf der Port dieses Druckers nicht "FILE:"
    'sein.
    'Hier alle Mglichkeiten:
    'Falsch =  0 = "Ausgabe in Datei umleiten" nicht ausschalten.
    'Wahr   = -1 = "Ausgabe in Datei umleiten" immer ausschalten.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry Wahr angenommen.
    'Bei der Installation und als Standard beim Konfigurieren wird Falsch gesetzt, wenn RedMon
    'installiert ist; ansonten wird Wahr gesetzt.
'"printer_name"
    'Name des Postscript-Druckers, mit dem die Postscript-Datei erzeugt wird.
    'Der Eintrag wird immer verwendet.
    'Gs4Word stellt sicher, dass der Druckertreiber nicht auf den Drucker, sondern in eine Datei
    'druckt.
    'Hier ein Muster:
    '"Generic PostScript Printer" Das ist der Postscript-Druckertreiber von der Adobe Homepage.
    'Bei der konfiguration wird einer der folgenden Drucker vorgeschlagen
    '   (1) Wenn es einen Drucker "Generic PostScript Printer CMYK" gibt, wird dieser verwendet.
    '   (2) Wenn es einen Drucker "Generic Colour PostScript" gibt, wird dieser verwendet.
    '   (3) Wenn es einen Drucker "Gs4Word PostScript Printer" gibt, wird dieser verwendet.
    '   (4) Wenn es einen Drucker "Adobe PostScript Printer" gibt, wird dieser verwendet.
    '   (5) Wenn es einen Drucker "Generic PostScript Printer" gibt, wird dieser verwendet.
    '   (6) Wenn es einen Drucker "HP Color LaserJet 5/5M PS" gibt, wird dieser verwendet.
    '   (7) Wenn es einen Drucker "HP Color LaserJet 8500 PS" gibt, wird dieser verwendet.
    '   (8) Wenn es einen Drucker "HP CLJ 8500 - PS" gibt, wird dieser verwendet.
    '   (9) Wenn es einen Drucker "Xerox DocuTech 135 PS2" gibt, wird dieser verwendet.
'"viewer_name"
    'Pfad und Programmnamen des PDF-Betrachters.
    'Der Eintrag wird nur verwendet, wenn "viewer_flag"="1" ist.
    'Hier einige Muster:
    '"c:\\programme\\adobe\\acrobat 4.0\\reader\\AcroRd32.exe"
    '   Den Adobe Reader habt wohl jeder. Bei jedem Aufruf wird die gleiche Instanz des Programms
    '   verwendet.
    '"c:\\programme\\ghostgum\\gsview\\gsview32.exe"
    '   Ghostgum als PDF-Betrachter ist eine echte Alternative. Bei jedem Aufruf wird eine neue
    '   Instanz des Programms gestartet.
    '"c:\\programme\\gs\\gs7.00\\bin\\gswin32c.exe -dBATCH -f"
    '   Auch Ghostscript kann (ganz umstndlich) als PDF-Betrachter verwendet werden.
    '   Zum Blttern muss im gleichzeitig geffneten DOS-Fenster eine Taste gedrckt werden.
    '   "-dBATCH -f" ist erforderlich und kann nur durch direkte nderung der Registry eingetragen
    '   werden.
    'Wenn der Eintrag in der Registry fehlt, wird im Modul DOC_Konfiguration das Programm aus der
    'Verknpfung mit sPDF verwendet. Der Verweis {VERWEIS} steht in der Registry unter
    '"HKEY_LOCAL_MACHINE\SOFTWARE\classes\.pdf" im Key sLEER. Der Programmname steht dann in
    '"HKEY_LOCAL_MACHINE\SOFTWARE\classes\{VERWEIS}\shell\open\command" im Key sLEER.

'[HKEY_CURRENT_USER\Software\VB and VBA Program Settings\WordMakros von J.W.Schmitz-Huebsch\
'   Gs4Word Ghostscript]
    'Registry-Pfad fr die in allen drei Add-Ins gleichen Eintrge fr Ghostscript.
'Je Ausgabemedium gibt es einem Eintrag mit dem Namen des Ausgabemediums.
'Als Wert wird der Parameterstring zum Aufruf von Ghostscript gespeichert.

' Die folgenden Eintrge werden in der Registry fr alle drei Add-Ins getrennt gespeichert
'------------------------------------------------------------------------------------------
'Registry-Pfade fr die in allen drei Add-Ins unterschiedlichen Eintrge.
'[HKEY_CURRENT_USER\Software\VB and VBA Program Settings\WordMakros von J.W.Schmitz-Huebsch\
'   Gs4Word Microsoft Word]
'[HKEY_CURRENT_USER\Software\VB and VBA Program Settings\WordMakros von J.W.Schmitz-Huebsch\
'   Gs4Word Microsoft Excel]
'[HKEY_CURRENT_USER\Software\VB and VBA Program Settings\WordMakros von J.W.Schmitz-Huebsch\
'   Gs4Word Microsoft Powerpoint]

'"button_flag"
    'Dieser Eintrag steuert, ob in der Symbolleiste 'Standard' ein PDF-Button angezeigt wird.
    'Hier alle Mglichkeiten:
    'Falsch =  0 = Keinen PDF-Button anzeigen.
    'Wahr   = -1 = PDF-Button anzeigen.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry Wahr angenommen.
'"dialog_flag"
    'Dieser Eintrag steuert, ob das Ausgabe-Medium im Dialog ausgewhlt oder fest vorgegeben ist.
    'Hier alle Mglichkeiten:
    'Falsch =  0 = Keinen Auswahl-Dialog anzeigen und die PDF-Datei fr das Ausgabe-Medium aus
    '              "media_switch" erzeugen.
    'Wahr   = -1 = Auswahl-Dialog anzeigen. Dabei als Voreinstellung das Ausgabe-Medium aus
    '              "media_switch" verwenden.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry Falsch
    'angenommen.
'"mailto_switch"
    'Dieser Eintrag steuert, ob ein Mailprogramm vorhanden ist, das eine PDF-Datei als Anhang
    'senden kann und wie die Verarbeitung stattfinden soll. Welche Mailprogramme verwendbar sind,
    'wird im Registry-Eintrag "mailto_name" beschrieben. Im Menu "PDF" wird der Eintrag "Mailen"
    'aktiv oder inaktiv angezeigt.
    'Hier alle Mglichkeiten:
    '"0"    Kein nutzbares Mailprogramm vorhanden. Im Menu "PDF" wird der Eintrag "Mailen" inaktiv
    '       angezeigt.
    '"1"    Die letzte erzeugte PDF-Datei wird als Mailanhang gesendet. Im Menu "PDF" wird der
    '       Eintrag "Mailen" aktiv angezeigt.
    '"2"    Es wird eine neue PDF-Datei erzeugt und als als Mailanhang gesendet. Im Menu "PDF" wird
    '       der Eintrag "Mailen" aktiv angezeigt.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "0" angenommen.
    'Bei der Installation und als Standard beim Konfigurieren wird "0" gesetzt, wenn
    'mailto_parameter leer ist; ansonsten wird "1" gesetzt.
'"media_switch"
    'Dieser Eintrag enthlt die Einstellung fr das Ausgabe-Medium.
    'Die Werte werden in den Konstanten sAUSGABEMEDIUM_... festgelegt.
    'Hier alle Mglichkeiten:
    '"0"    Standardeinstellung
    '"1"    fr den Bildschirm
    '"2"    fr einen Drucker
    '"3"    fr eine Publikation
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "2" angenommen.
'"pdfmark_flag"
    'Dieser Eintrag steuert, ob in der erzeugten Postscript-Datei pdfmarks verwendet werden sollen.
    'Hier alle Mglichkeiten:
    'Falsch =  0 = Keine pdfmarks erzeugen.
    'Wahr   = -1 = pdfmarks erzeugen.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry Wahr angenommen.
'"pdfpagelayout_switch"
    'Dieser Eintrag steuert, wie die PDF-Datei angezeigt werden soll.
    'Die Werte werden in den Konstanten sPDFPAGELAYOUTSWITCH_... festgelegt.
    'Hier alle Mglichkeiten:
    '"0"    ""                  = "Unverndert" im AdobeReader nicht ndern
    '"1"    "/SinglePage"       = "Einzelne Seite" im AdobeReader-Men
    '"2"    "/OneColumn"        = "Fortlaufend" im AdobeReader-Men
    '"3"    "/TwoColumnRight"   = "Fortlaufend Doppelseiten" im AdobeReader-Men (ungerade rechts)
    '"4"    "/TwoColumLeft"     = NICHT im AdobeReader-Men (Fortlaufend Doppelseiten ungerade links)
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "0"
    'angenommen.
'"pdfpagemode_switch"
    'Dieser Eintrag steuert, wie die PDF-Datei angezeigt werden soll.
    'Die Werte werden in den Konstanten sPDFVIWESWITCH_... festgelegt.
    'Hier alle Mglichkeiten:
    'Wert                   Word                Excel               Powerpoint
    '---------------------- ------------------- ------------------- -------------------
    '"0"    "/UseNone"      kein Navigationsf.  kein Navigationsf.  kein Navigationsf.
    '"1"    "/UseOutlines"  Lesezeichen         -                   -
    '"2"    "/UseThumbs"    Minitauransichten   Minitauransichten   Minitauransichten
    '"3"    "/FullScreen"   Vollbild            Vollbild            Vollbild
    '"4"    "/UseNone" oder
    '       "/UseOutlines"  Automatisch         -                   -
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "0"
    'angenommen. Abweichend davon wird bei der Installation wird fr Word "4" angenommen.
'"pdfview_switch"
    'Dieser Eintrag steuert, wie die PDF-Datei angezeigt werden soll.
    'Die Werte werden in den Konstanten sPDFVIWESWITCH_... festgelegt.
    'Hier alle Mglichkeiten:
    '"0"    "/View /XYZ 0 0 0"                      = "Unverndert" im AdobeReader nicht ndern
    '"1"    "/View /XYZ 4 PageHeight+4 1"           = "Originalgre" im AdobeReader-Men
    '"2"    "/View /Fit"                            = "Ganze Seite" im AdobeReader-Men
    '"3"    "/View /FitH -32768"                    = "Fensterbreite" im AdobeReader-Men
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "0"
    'angenommen.
'"pdfout_switch"
    'Dieser Eintrag legt fest, ob Lesezeichen in die PDF-Datei aufgenommen werden.
    'Der Eintrag wird zur Zeit nur in Word verwendet.
    'Die Werte werden in den Konstanten sPDFOUTWITCH_... festgelegt.
    'Hier alle Mglichkeiten:
    'Wert   Word
    '------ ---------------------------------------
    '"0"    Keine Lesezeichen
    '"1"    Alle Verzeichnisse als Lesezeichen
    '"2"    Inhaltsverzeichniss als Lesezeichen
    '"3"    Alle berschriften als Lesezeichen
    '"4"    Nur berschriften bis Ebene 8 als Lesezeichen
    '"5"    Nur berschriften bis Ebene 7 als Lesezeichen
    '"6"    Nur berschriften bis Ebene 6 als Lesezeichen
    '"7"    Nur berschriften bis Ebene 5 als Lesezeichen
    '"8"    Nur berschriften bis Ebene 4 als Lesezeichen
    '"9"    Nur berschriften bis Ebene 3 als Lesezeichen
    '"10"   Nur berschriften bis Ebene 2 als Lesezeichen
    '"11"   Nur berschriften bis Ebene 1 als Lesezeichen
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "3" angenommen.
'"print_switch"
    'Dieser Eintrag steuert, welcher Umfang des Dokumentes, der Arbeitsmappe oder Prsentation
    'ausgewhlt wird.
    'Die Werte werden in den Konstanten sPRINTSWITCH_... festgelegt.
    'Hier alle Mglichkeiten:
    'Wert   Word                Excel               Powerpoint
    '------ ------------------- ------------------- -------------------
    '"0"    Dokument            Arbeitsmappe        Prsentation
    '"1"    Aktuelle Seite      Aktuelle Tabelle    Aktuelle Folie
    '"2"    Markierte Seiten    Markierte Tabellen  Markierte Folien
    '"3"    Dokumenteneigensch. -                   -
    '"4"    Kommentare          -                   -
    '"5"    Formatvorlagen      -                   -
    '"6"    AutoText-Eintrge   -                   -
    '"7"    Tastenbelegung      -                   -
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "0"
    'angenommen.
'"type_switch"
    'Dieser Eintrag enthlt im Powerpoint den Type der ausgewhlten Elemente.
    'Er wird nur in Powerpount verwendet
    'Die Werte werden in den Konstanten sTYPESWITCH_... festgelegt.
    'Hier alle Mglichkeiten:
    '"0"    Angezeigter Typ
    '"1"    Folien
    '"2"    Handzettel (2 Folien je Seite)
    '"3"    Handzettel (3 Folien je Seite)
    '"4"    Handzettel (6 Folien je Seite)
    '"5"    Notizseiten
    '"6"    Gliederungsansicht
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "0" angenommen.
'"rahmen_flag"
    'Dieser Eintrag enthlt im Powerpoint den Schalter fr den Rahmen um Folien,
    'Handzettel und Notizseiten.
    'Er wird nur in Powerpount verwendet.
    'Hier alle Mglichkeiten:
    'Falsch =  0 = Ohne Rahmen
    'Wahr   = -1 = Mit Rahmen
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry Falsch angenommen.
'"logfiledel_flag"
    'Dieser Eintrag steuert, ob die Log-Datei nach dem Erzeugen der PDF-Datei gelscht wird.
    'Hier alle Mglichkeiten:
    'Falsch =  0 = Log-Datei nach dem Erzeugen der PDF-Datei nicht lschen.
    'Wahr   = -1 = Log-Datei nach dem Erzeugen der PDF-Datei lschen.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry Wahr angenommen.
'"psfiledel_flag"
    'Dieser Eintrag steuert, ob die PS-Datei nach dem Erzeugen der PDF-Datei gelscht wird.
    'Hier alle Mglichkeiten:
    'Falsch =  0 = PS-Datei nach dem Erzeugen der PDF-Datei nicht lschen.
    'Wahr   = -1 = PS-Datei nach dem Erzeugen der PDF-Datei lschen.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry Wahr angenommen.
'"symb_filename"
    'Symbolischer Dateiname der Postscript- und PDF-Datei ohne .ps oder .pfd . Die symbolischen
    'Namensteile sind in der Konstanten sTEXT_IBSYMBDATEINAME beschrieben.
    'Der Eintrag wird immer verwendet.
    'Hier einige Mglichkeiten:
    '"<name>"   Die PDF-Datei genauso heissen soll, und im gleichen Verzeichnis liegen, wie das
    '           Word-Dokument.
    '"C:\Eigene Dateien\pdf\<yyyy><mm><dd>_<name>"  Alle PDF-Dateien liegen in einem PDF-
    '           Verzeichnis. An jedem Tag wird fr jedes Word-Dokument maximal eine PDF-Datei
    '           gespeichert.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry "<name>"
    'angenommen.
'"viewer_flag"
    'Dieser Eintrag steuert, ob die erzeugte PDF-Datei sofort in einem PDF-Betrachter angezeigt
    'werden soll.
    'Hier alle Mglichkeiten:
    'Falsch =  0 = Erzeugte PDF-Datei nicht anzeigen.
    'Wahr   = -1 = Erzeugte PDF-Datei mit dem Betrachter aus "viewer_name" anzeigen.
    'Wenn der Eintrag in der Registry fehlt, wird schon beim Lesen aus der Registry Wahr angenommen.

'===================================================================================================
'Deklarationen
'===================================================================================================

' Die folgenden Konstanen werden berall verwendet
'-------------------------------------------------
Public Const sADDIN_NAME As String = "Gs4Word" 'Name des Add-Ins.
Public Const sADDIN_VERSION As String = "3.31" 'Version des Add-Ins (9.99 oder 9.99x)
    'Wird zur Anzeige und zum Ermitteln des Zip-Archiv-Namens verwendet.
Public Const sSPRACHCODE_DEUTSCH As String = "de"
Public Const sSPRACHCODE_ENGLISCH As String = "en"
Public Const sSPRACHCODE_WEITERESPRACHE As String = "xx"

' Allgemeine Konstante
'---------------------
Public Const sLEER As String = ""
Public Const sSPACE As String = " "
Public Const sLOG As String = ".log"
Public Const sPDF As String = ".pdf"
Public Const sPS As String = ".ps"
Public Const sTXT As String = ".txt"
Public Const sDOC As String = ".doc"
Public Const sDOT As String = ".dot"

' Die folgenden Konstanen beschreiben alle Verzeichnisse und Dateien von Gs4Word
'--------------------------------------------------------------------------------
Public Const sKONFIGDIR As String = "Konfiguration\"
Public Const sLIZENZDIR As String = "Lizenzen\"
Public Const sSOURCEDIR As String = "Sourcen\"
Public Const sRUNTIMEDIR As String = "Runtime\"
Public Const sDOKDIR As String = "Html\"
Public Const sSAVDIR As String = "_sav\"

Public Const sINSTALLATIONS_ADDIN As String = "Installation.dot"
Public Const sKONFIGURATIONS_ADDIN As String = "Konfiguration.dot"

Public Const sDOKUMENTATIONSMUSTER As String = "(&1=InstVerz)Html\Gs4Word_(&2=Sprache)\(&3=HtmlDatei)"
Public Const sDOKU_ANFANG As String = "gs4word.html"
Public Const sDOKU_DEINSTALLATION As String = "gs4word_deinstallation.html"
Public Const sDOKU_INSTALLATION As String = "gs4word_installation2.html"
Public Const sDOKU_KONFIGURATION As String = "gs4word_konfiguration.html"
Public Const sDOKU_WORD As String = "gs4word_word.html"
Public Const sDOKU_EXCEL As String = "gs4word_excel.html"
Public Const sDOKU_POWERPOINT As String = "gs4word_powerpoint.html"

' Die folgenden Konstanen sind die zulssigen Werte von sTaskName und gsTaskName
'-------------------------------------------------------------------------------
Public Const sTASKNAME_WORD As String = "MICROSOFT WORD"
    'Name der Applikationen aus Application.Tasks
Public Const sTASKNAME_EXCEL As String = "MICROSOFT EXCEL"
    'Name der Applikationen aus Application.Tasks
Public Const sTASKNAME_POWERPOINT As String = "MICROSOFT POWERPOINT"
    'Name der Applikationen aus Application.Tasks

' Die folgenden Konstanen sind die zulssigen Werte von sKonfigurationsMakro in fbKonfigurieren
'----------------------------------------------------------------------------------------------
Public Const sWORDKONFIGURATIONISTAENDERBAR = "KONF_Schnittstellen.WordKonfigurierenVorlageIstAenderbar"
Public Const sWORDKONFIGURATIONNICHTAENDERBAR = "KONF_Schnittstellen.WordKonfigurierenVorlageNichtAendern"
Public Const sEXCELKONFIGURATION = "KONF_Schnittstellen.ExcelKonfigurieren"
Public Const sPOWERPOINTKONFIGURATION = "KONF_Schnittstellen.PowerpointKonfigurieren"

' Die folgenden Konstanen werden in der Funktion fbInfo_anzeigen und fbXXXErzeugen verwendet
'-------------------------------------------------------------------------------------------
Public Const sVORLAGE_COPYRIGHT As String = "(C) 2001-2005 J.W.Schmitz-Hbsch"
Public Const sVORLAGE_HTTPADRESSE As String = "http://www.schmitz-huebsch.net/gs4word/"
Public Const sVORLAGE_LIZENZ As String = "GNU General Public License"

' Die folgenden Konstanen werden in der Funktion fbVorlageAnpassen verwendet
'---------------------------------------------------------------------------
Public Const sVORLAGE_SYMBOLLEISTE As String = "Standard"

' Die folgenden Konstanen werden in den Funktionen fbKonfiguration_lesen,
' fbKonfiguration_schreiben und fbKonfiguration_loeschen verwendet
'------------------------------------------------------------------------
Public Const sREGISTRY_VBANAME As String = "Software\VB and VBA Program Settings\"
    'Die Konstante muss public sein, denn sie wird auch in INST_Prozeduren verwendet
Public Const sREGISTRY_APPNAME As String = "WordMakros von J.W.Schmitz-Huebsch"
    'Die Konstante muss public sein, denn sie wird auch in INST_Prozeduren verwendet
Public Const sREGISTRY_SECTION As String = "Gs4Word"
    'Die Konstante muss public sein, denn sie wird auch in INST_Prozeduren verwendet
Public Const sREGISTRY_SECTION_GHOSTSCRIPT As String = "Gs4Word Ghostscript"
    'Die Konstante muss public sein, denn sie wird auch in INST_Prozeduren verwendet

Private Const sREGISTRY_KEY_DEBUGFLAG As String = "debug_flag"
Private Const sREGISTRY_KEY_DOKUAUFRUF As String = "doku_aufruf"
Private Const sREGISTRY_KEY_GSPARAMKONF As String = "ghostscript_paramkonf"
Private Const sREGISTRY_KEY_GSPROGRAMM As String = "ghostscript_name"
Private Const sREGISTRY_KEY_GSSHELLSWITCH As String = "ghostscript_shellswitch"
Private Const sREGISTRY_KEY_INSTVERZEICHNIS As String = "inst_dir"
Private Const sREGISTRY_KEY_INSTLOGBUCH As String = "inst_logbuch"
Private Const sREGISTRY_KEY_SPRACHE As String = "language_switch"
Private Const sREGISTRY_KEY_MAILTOPARAMETER As String = "mailto_parameter"
Private Const sREGISTRY_KEY_MAILTOPROGRAMM As String = "mailto_name"
Private Const sREGISTRY_KEY_MAXRECHNERWARTEZEIT As String = "max_wartezeit"
Private Const sREGISTRY_KEY_DATEIUMLEITUNGSFLAG As String = "print2file_flag"
Private Const sREGISTRY_KEY_PSDRUCKERNAME As String = "printer_name"
Private Const sREGISTRY_KEY_PATHSEPARATOR As String = "path_separator"
Private Const sREGISTRY_KEY_PDFPROGRAMM As String = "viewer_name"

Private Const sREGISTRY_KEY_BUTTONFLAG As String = "button_flag"
Private Const sREGISTRY_KEY_DIALOGFLAG As String = "dialog_flag"
Private Const sREGISTRY_KEY_MAILTOSWITCH As String = "mailto_switch"
Private Const sREGISTRY_KEY_AUSGABEMEDIUM As String = "media_switch"
Private Const sREGISTRY_KEY_PDFMARKFLAG As String = "pdfmark_flag"
Private Const sREGISTRY_KEY_PDFPAGELAYOUTSWITCH As String = "pdfpagelayout_switch"
Private Const sREGISTRY_KEY_PDFPAGEMODESWITCH As String = "pdfpagemode_switch"
Private Const sREGISTRY_KEY_PDFVIEWSWITCH As String = "pdfview_switch"
Private Const sREGISTRY_KEY_PDFOUTSWITCH As String = "pdfout_switch"
Private Const sREGISTRY_KEY_PRINTSWITCH As String = "print_switch"
Private Const sREGISTRY_KEY_TYPESWITCH As String = "type_switch"
Private Const sREGISTRY_KEY_RAHMENFLAG As String = "rahmen_flag"
Private Const sREGISTRY_KEY_LOGDATEILOESCHENFLAG As String = "logfiledel_flag"
Private Const sREGISTRY_KEY_PSDATEILOESCHENFLAG As String = "psfiledel_flag"
Private Const sREGISTRY_KEY_SYMBDATEINAME As String = "symb_filename"
Private Const sREGISTRY_KEY_PDFBETRACHTERFLAG As String = "viewer_flag"

Public Const bDEFAULT_BUTTONFLAG As Boolean = True
Public Const bDEFAULT_DIALOGFLAG As Boolean = False
Public Const sDEFAULT_MAILTOSWITCH_NEIN As String = "0" 'Keine Mails senden
Public Const sDEFAULT_MAILTOSWITCH_JA As String = "1" 'Mails senden
Public Const sDEFAULT_GSSHELLSWITCH As String = "1"
Public Const sDEFAULT_AUSGABEMEDIUM As String = "3"
Public Const bDEFAULT_PDFMARKFLAG As Boolean = True
Public Const sDEFAULT_PDFPAGELAYOUTSWITCH As String = "0"
Public Const sDEFAULT_PDFPAGEMODESWITCH_WORD As String = "4"
Public Const sDEFAULT_PDFPAGEMODESWITCH As String = "0"
Public Const sDEFAULT_PDFVIEWSWITCH As String = "0"
Public Const sDEFAULT_PDFOUTSWITCH As String = "3"
Public Const sDEFAULT_PRINTSWITCH As String = "0"
Public Const sDEFAULT_TYPESWITCH As String = "0"
Public Const bDEFAULT_RAHMENFLAG As Boolean = False
Public Const sDEFAULT_LOGDATEILOESCHENFLAG As Boolean = True
Public Const sDEFAULT_PSDATEILOESCHENFLAG As Boolean = True
Public Const sDEFAULT_SYMBDATEINAME As String = "<name>"
Public Const sDEFAULT_PDFBETRACHTERFLAG As Boolean = True
Public Const sDEFAULT_SPRACHSWITCH As String = "de"

' Die folgende Deklaration wird von fbWarten verwendet
'-----------------------------------------------------
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMS As Long)

'===================================================================================================
'Alle ffentlichen Variablen fr alle Module
'===================================================================================================
'Registry-Eintrge
'-----------------
Public gsAusgabeMedium As String
Public gbButtonFlag As Boolean
Public gsSymbDateiName As String
Public gbPdfmarkFlag As Boolean
Public gsPdfPageLayoutSwitch As String
Public gsPdfPageModeSwitch As String
Public gsPdfViewSwitch As String
Public gsPdfOutSwitch As String
Public gsPrintSwitch As String
Public gsTypeSwitch As String
Public gbRahmenFlag As Boolean
Public gbDialogFlag As Boolean
Public gbDebugFlag As Boolean
Public gsPSDruckerName As String
Public gbLogDateiLoeschenFlag As Boolean
Public gbPSDateiLoeschenFlag As Boolean
Public gbDateiumleitungsFlag As Boolean 'ist nur fr Word erforderlich
Public gsDokuAufruf As String
Public gsGSShellSwitch As String
Public gsGSParamKonfName As String
Public gsGSProgrammName As String
Public gsInstVerzeichnis As String
Public gsInstLogbuch As String
Public gsDeInstLogbuch As String
Public gsMailtoParameter As String
Public gsMailtoProgrammName As String
Public gsMailToSwitch As String
Public gsPDFProgrammName As String
Public gbPDFBetrachterFlag As Boolean
Public giMaxRechnerWartezeit As Integer
Public gsPathSeparator As String
Public gsSprachSwitch As String
Public gvAusgabeMedienTabelle As Variant
    ' Das erste Element der Tabelle muss 0 sein

'Sonstige Globale Variable
'-------------------------
Public giDialogEffekt As String 'Effekt der Dialoge wird in allen UserForms verwendet
    ' 0 = False = Abbrechen
    '-1 = True  = OK
    '-2         = Lschen
Public gsBasisDateiName As String
    'Name der PS- und PDF-Datei ohne Extension mit absolutem Pfad. Diese Variable muss Public sein,
    'weil der BasisDateiName in Excel und Powerpoint im Dialog verndert werden kann.
Public gsMailtoDateiName As String
    'Name der PDF-Datei mit absolutem Pfad fr den Aufruf des Mailprogramms. Wenn die Variable
    'gleich sLEER ist, kann keine PDF-Datei gemailt kann.
Public giGsWartezeit As Integer 'Wartezeit beim letzten Start von Ghostscript
'Die folgenden Listen mssen Public sein, weil sie in den UserForms verwendet werden
Public gsMailToSwitchListe(2) As String 'Alle zulssigen Namen fr gsMailToSwitch
Public gsPdfPageLayoutSwitchListe() As String 'Alle zulssigen Namen fr gsPdfPageLayoutSwitch
Public gsPdfPageModeSwitchListe() As String 'Alle zulssigen Namen fr gsPdfPageModeSwitch
Public gsPdfViewSwitchListe() As String 'Alle zulssigen Namen fr gsPdfViewSwitch
Public gsPdfOutSwitchListe() As String 'Alle zulssigen Namen fr gsPdfOutSwitch
Public gsPrintSwitchListe() As String 'Alle zulssigen Namen fr gsPrintSwitch
Public gsTypeSwitchListe() As String 'Alle zulssigen Namen fr gsTypeSwitch
Public gsSprachSwitchListe() As String 'Alle zulssigen Namen fr gsSprachSwitch

'===================================================================================================
''Men "PDF > Mailen"
'===================================================================================================
Sub MAILEN()
    'Die Prozedur ruft das Mailprogramm auf, wenn gsMailToSwitch gesetzt ist. Dabei wird
    'gsMailtoDateiName als Dateianhang verwendet.
    'Global:
    '   gsMailToSwitch wird gelesen
    '   gsMailtoDateiName wird gelesen
    '   gsMailtoProgrammName wird gelesen
    '   gsMailtoParameter wird gelesen
    'Effekt
    '   Ggf. wurde ein Mail-Client geffnet.
    '   Ggf. wurde stattdessen eine Fehlermeldung angezeigt.
    
    On Error GoTo Fehler_aufgetreten:
    
    Const sPlatzhalter As String = "%"
    Dim vtaskId As Variant 'Task-ID eines mit Shell aufgerufenen Programms
    Dim lPos As Long 'Hilfsvariable
    Dim sMailtoParameter

    Select Case gsMailToSwitch
    Case sMAILTOSWITCH_AUS
        Exit Sub
    Case sMAILTOSWITCH_NEUERZEUGEN
        Call ERZEUGEN
    End Select
        
    If gsMailtoDateiName = sLEER Then
        MsgBox fsText(sMSG_KEINEGUELTIGEPDFDATEI) _
            , vbExclamation, sTITEL_ERZEUGEN
        Exit Sub
    End If
        
    If gsMailtoProgrammName = sLEER Then
        MsgBox fsText(sMSG_KEINMAILPROGRAMM) _
            , vbExclamation, sTITEL_ERZEUGEN
        Exit Sub
    End If
        
    If Dir(gsMailtoProgrammName, vbNormal) = sLEER Then
        MsgBox fsText(sMSG_MAILPROGRAMMUNBEKANNT, gsMailtoProgrammName) _
            , vbExclamation, sTITEL_ERZEUGEN
        Exit Sub
    End If
    lPos = 1
    lPos = InStr(lPos, gsMailtoParameter, sPlatzhalter, vbTextCompare)
    If lPos > 0 Then
        sMailtoParameter = Left(gsMailtoParameter, lPos - 1) & gsMailtoDateiName _
            & Mid(gsMailtoParameter & sSPACE, lPos + Len(sPlatzhalter))
    Else
        MsgBox fsText(sMSG_MAILTOPROZENTFEHLT, gsMailtoParameter) _
            , vbExclamation, sTITEL_ERZEUGEN
        Exit Sub
    End If
        
'    MsgBox "Der Aufruf des Mailprogramms ist: " _
'        & vbCr & Chr(34) & gsMailtoProgrammName & Chr(34) & sSPACE & sMailtoParameter _
'        , vbOKOnly, "Beta-Test - GS4Word - Mail"
        
    vtaskId = Shell(Chr(34) & gsMailtoProgrammName & Chr(34) & sSPACE & sMailtoParameter, 4)
    If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
        'Shell wird asynchron verarbeitet, deshalb zuerst solange warten, bis das Programm gestartet
        'ist. Das dauert maximal so lange, wie der Start von Ghostscript gedauert hat.
        Call fbWarten(giGsWartezeit)
    End If
    On Error Resume Next
    AppActivate vtaskId
        'Wenn Acrobat Reader schon geffnet ist, erzeugt AppActivate einen Laufzeitfehler 5
    On Error GoTo 0
        
    Exit Sub
        
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , "GLOB_Prozeduren" _
        , "MAILEN" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER

End Sub

'===================================================================================================
''Men "PDF > Konfigurieren"
'===================================================================================================
Sub KONFIGURIEREN()
    'Die Prozedur ruft das Konfigurations-AddIn auf.
    'Effekt
    '   Ggf. wurde die Konfigration gendert.
    
    On Error GoTo Fehler_aufgetreten:
    
    Call fbKonfigurieren(sLEER)
    
    Exit Sub
        
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , "GLOB_Prozeduren" _
        , "KONFIGURIEREN" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER

End Sub
                   
'===================================================================================================
''Men "PDF > Dokumentation"
'===================================================================================================
Sub DOKU_ANFANG()
    Call DOKUMENTATION(sDOKU_ANFANG)
End Sub

Sub DOKUMENTATION(Optional sParameter As String = sLEER)
    'Die Prozedur ruft die HTML-Dokumentation auf.
    'Falls die angeforderte Html-Seite in der Sprache gsSprachSwitch nicht vorhanden ist, wird die
    'Anfangs-Seite der Html-Dokumentation in der gleichen Sprache gesucht und angezeigt.
    'Effekt
    '   Ggf. wurde die Dokumentation aufgerufen.
    
    Dim vtaskId As Variant 'Task-ID eines mit Shell aufgerufenen Programms
    Dim sHtmlDatei As String
    Dim sDokuDatei  As String
    
    On Error GoTo Fehler_aufgetreten:
    
    sHtmlDatei = sParameter
    If sHtmlDatei = sLEER Then
        Select Case UCase(Application.Name)
        Case sTASKNAME_WORD
            sHtmlDatei = sDOKU_WORD
        Case sTASKNAME_EXCEL
            sHtmlDatei = sDOKU_EXCEL
        Case sTASKNAME_POWERPOINT
            sHtmlDatei = sDOKU_POWERPOINT
        Case Else
            MsgBox fsText(sMSG_CASEELSE _
                , "DOKUMENTATION") _
                , vbExclamation, sTITEL_ERZEUGEN
            Error 51
        End Select
    End If
       
    sDokuDatei = fsText(sDOKUMENTATIONSMUSTER, gsInstVerzeichnis, _
        fsSprachSwitch_konvertieren(gsSprachSwitch), sHtmlDatei)
    If Dir(sDokuDatei, vbNormal) = sLEER Then
        sDokuDatei = fsText(sDOKUMENTATIONSMUSTER, gsInstVerzeichnis, _
            fsSprachSwitch_konvertieren(gsSprachSwitch), sDOKU_ANFANG)
    End If
       
    vtaskId = Shell(fsText(gsDokuAufruf, sDokuDatei), 3)
    If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
        'Shell wird asynchron verarbeitet, deshalb zuerst solange warten, bis das Programm
        'gestartet ist. Das dauert maximal so lange, wie der Start von Ghostscript gedauert htte.
        Call fbWarten(giGsWartezeit)
    End If
    On Error Resume Next
    AppActivate vtaskId
        'Wenn der Browser schon geffnet ist, erzeugt AppActivate einen Laufzeitfehler 5
    On Error GoTo 0
    
    Exit Sub
        
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , "GLOB_Prozeduren" _
        , "DOKUMENTATION" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER

End Sub

'===================================================================================================
'Alle Funktionen und Subroutinen, die nur von der Subroutine ERZEUGEN verwendet werden.
'===================================================================================================
Function fbDatei_loeschen(sDateiname As String) As Boolean
    'Die Funktion lscht eine normale, nicht gesperrte Datei. Wenn das nicht mglich ist, wird eine
    'Meldung angezeigt. Scheibgeschtzte Dateien, versteckte Dateien, Systemdateien oder
    'Verzeichnisse werden nicht gelscht.
    'Argumente:
    '   sDateiname = Name der Datei
    'Rckgabewert:
    '   False = Datei sDateiname konnte nicht gelscht werden.
    '   True = Datei sDateiname ist nicht mehr vorhanden.
    'Effekt
    '   Entweder ist die Datei sDateiname nicht mehr vorhanden
    '   oder es wurde eine Fehlermeldung angezeigt.
    
    Dim iDateiAttribute As Integer 'Attribute der Datei in sDateiname
    Dim iFehlerNummer As Integer 'Fehlernumer aus GetAttr()
    
    On Error Resume Next
    iDateiAttribute = GetAttr(sDateiname)
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then 'Datei vorhanden
        If iDateiAttribute And vbReadOnly Then
            MsgBox fsText(sMSG_DATEIISTSCHREIBGESCHUETZT _
                , sDateiname) _
                , vbExclamation, sTITEL_ERZEUGEN
            fbDatei_loeschen = False
            Exit Function
        ElseIf iDateiAttribute And vbHidden Then 'wird mit Dir(sDateiname) nicht gefunden
            MsgBox fsText(sMSG_DATEIISTVERSTECKT _
                , sDateiname) _
                , vbExclamation, sTITEL_ERZEUGEN
            fbDatei_loeschen = False
            Exit Function
        ElseIf iDateiAttribute And vbSystem Then
            MsgBox fsText(sMSG_DATEIISTSYSTEMDATEI _
                , sDateiname) _
                , vbExclamation, sTITEL_ERZEUGEN
            fbDatei_loeschen = False
            Exit Function
        ElseIf iDateiAttribute And vbDirectory Then
            MsgBox fsText(sMSG_DATEIISTVERZEICHNIS _
                , sDateiname) _
                , vbExclamation, sTITEL_ERZEUGEN
            fbDatei_loeschen = False
            Exit Function
        Else
            On Error Resume Next
            Kill sDateiname
            On Error GoTo 0
        End If
    End If
    
    If Dir(sDateiname, vbNormal) = sLEER Then 'Datei ist nicht mehr vorhanden
        fbDatei_loeschen = True
    Else
        MsgBox fsText(sMSG_DATEIISTGESPERRT _
            , sDateiname) _
            , vbExclamation, sTITEL_ERZEUGEN
        fbDatei_loeschen = False
    End If
    
End Function

Function fbPDFDatei_erzeugen(sLogDateiName, sPSDateiName As String, sPDFDateiName As String, _
sAusgabeMedium As String) As Boolean
    'Die Funktion erzeugt aus der Postscript-Datei in sPSDateiName die PDF-Datei sPDFDateiName.
    'Dazu wird der Name des Ghostscript-Programms aus der Registry gelesen.
    'Wenn das nicht mglich ist, wird eine Meldung angezeigt.
    'Die Funktion wartet solange, bis die Postscript-Datei nicht mehr gesperrt ist und die PDF-Datei
    'nicht mehr gesperrt ist, wenn eine PDF-datei existiert.
    'Global:
    '   gsGSProgrammName wird gelesen
    '   gsGSShellSwitch wird gelesen
    '   gbDebugFlag wird gelesen
    'Argumente:
    '   sLogDateiName = Dateiname der Log-Datei
    '   sPSDateiName = Dateiname der Postscript-Datei
    '   sPDFDateiName = Dateiname der PDF-Datei
    '   sAusgabeMedium = "default", "screen", "printer" oder "prepress"
    'Rckgabewert:
    '   False = PDF-Datei sPDFDateiName konnte nicht erzeugt werden.
    '   True = PDF-Datei sPDFDateiName wurde erzeugt.
    'Effekt
    '   Entweder wurde eine PDF-Datei erzeugt
    '   oder eine Fehlermeldung angezeigt.
    
    Static siMaxGsWartezeit As Integer
        'maximale Wartezeit beim Start von Ghostscript seit dem Start des Programms. Diese Zeit wird
        'nur fr die Fehlersuche gespeichert.
    Dim sAufrufVonGhostscript As String 'nomen est omen
    Dim vtaskId As Variant 'Task-ID eines mit Shell aufgerufenen Programms
    Dim bLogDateiLocked As Boolean
    Dim bPSDateiLocked As Boolean
    Dim bPDFDateiLocked As Boolean
    Dim iLogDateiNummer As Integer
    Dim iPSDateiNummer As Integer
    Dim iPDFDateiNummer As Integer
    
    If Dir(gsGSProgrammName, vbNormal) = sLEER Then
        MsgBox fsText(sMSG_GSPROGRAMMUNBEKANNT _
            , gsGSProgrammName) _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPDFDatei_erzeugen = False
        Exit Function
    End If
    
    sAufrufVonGhostscript = fsGhostscriptParameter_ermitteln(sLogDateiName, sPSDateiName, _
        sPDFDateiName, sAusgabeMedium)
    If gbDebugFlag = True Then
        If MsgBox(Chr(34) & gsGSProgrammName & Chr(34) & vbCr & Trim(sAufrufVonGhostscript), _
        vbOKCancel + vbInformation, sTITEL_DEBUGMODUS) <> vbOK Then
            fbPDFDatei_erzeugen = False
            Exit Function
        End If
    End If
    If sAufrufVonGhostscript = sLEER Then 'keine Parameter ermittelt
        fbPDFDatei_erzeugen = False
    Else
        sAufrufVonGhostscript = Chr(34) & gsGSProgrammName & Chr(34) & sAufrufVonGhostscript
        vtaskId = Shell(sAufrufVonGhostscript, gsGSShellSwitch)
        If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
            'Shell wird asynchron verarbeitet, deshalb zuerst solange warten, bis Ghostscript
            'gestartet ist und die PDF-Datei geffnet hat. Das wird einmal je Sekunde berprft.
            'Wie lange darauf maximal gewartet wird, ist je Rechner (Prozessortakt) unterschiedlich.
            'Dann solange warten, bis weder die Postscript-Datei noch die PDF-Datei gesperrt ist.
            'Auch das wird einmal je Sekunde berprft.
            'Wer eine bessere Idee hat, soll sich bitte melden!
            
            'Erstes Warten bis die PDF-Datei  existiert
            For giGsWartezeit = 1 To giMaxRechnerWartezeit Step 1
                Call fbWarten(1)  'In der Schleife immer eine Sekunde warten
                
                'Lngste Wartezeit seit dem Start des Programms merken, um sie bei einem Fehler
                'anzuzeigen
                If giGsWartezeit > siMaxGsWartezeit Then
                    siMaxGsWartezeit = giGsWartezeit
                End If
                'Prfen ob die PDF-Datei schon existiert
                If Dir(sPDFDateiName, vbNormal) <> sLEER Then
                    Exit For
                End If
            Next giGsWartezeit
                        
            'Zweites Warten bis Log-Datei, Ps-Datei und PDF-Datei nicht mehr gesperrt sind
            Do
                Call fbWarten(1)  'In der Schleife immer eine Sekunde warten

                'Prfen ob die Log-Datei noch gesperrt ist
                On Error Resume Next
                iLogDateiNummer = FreeFile
                Open sLogDateiName For Input Lock Read Write As #iLogDateiNummer
                If Err.Number = 0 Then
                    Close #iLogDateiNummer
                    bLogDateiLocked = False
                Else
                    'In einem Multiuser-System kann ein anderer Prozess die LogDatei wieder lschen.
                    'Oder die Datei knnte gar nicht erzeugt worden sein.
                    'Hier entstnde eine Endlosschleife.
                    If Dir(sLogDateiName, vbNormal) = sLEER Then
                        bLogDateiLocked = False
                    Else
                        bLogDateiLocked = True
                    End If
                End If
                'Prfen ob die Postscript-Datei noch gesperrt ist
                On Error Resume Next
                iPSDateiNummer = FreeFile
                Open sPSDateiName For Input Lock Read Write As #iPSDateiNummer
                If Err.Number = 0 Then
                    Close #iPSDateiNummer
                    bPSDateiLocked = False
                Else
                    'In einem Multiuser-System kann ein anderer Prozess die PSDatei wieder lschen.
                    'Hier entstnde eine Endlosschleife.
                    If Dir(sPSDateiName, vbNormal) = sLEER Then
                        bPSDateiLocked = False
                    Else
                        bPSDateiLocked = True
                    End If
                End If
                'Prfen ob die PFD-Datei noch gesperrt ist
                On Error Resume Next
                iPDFDateiNummer = FreeFile
                Open sPDFDateiName For Input Lock Read Write As #iPDFDateiNummer
                If Err.Number = 0 Then
                    Close #iPDFDateiNummer
                    bPDFDateiLocked = False
                Else
                    'Wenn Ghostscript mit fehlerhaften Parametern aufgerufen wird,
                    'kann es vorkommen, dass keine PDF-Datei angelegt wird.
                    'Beispiel: sAufrufVonGhostscript = gsGSProgrammName & " xxxxx" _
                    '   & fsGhostscriptParameter_ermitteln(sPSDateiName, sPDFDateiName, ausgabeMedium)
                    If Dir(sPDFDateiName, vbNormal) = sLEER Then
                        bPDFDateiLocked = False
                    Else
                        bPDFDateiLocked = True
                    End If
                End If
                On Error GoTo 0
            Loop While bLogDateiLocked Or bPSDateiLocked Or bPDFDateiLocked
        End If
                
        If Dir(sPDFDateiName, 0) <> sLEER Then 'PDF-Datei erzeugt
            fbPDFDatei_erzeugen = True
        Else
            MsgBox fsText(sMSG_PDFDATEINICHTERZEUGT _
                , sPDFDateiName _
                , sAufrufVonGhostscript _
                , CStr(giMaxRechnerWartezeit) _
                , CStr(siMaxGsWartezeit) _
                , CStr(giGsWartezeit)) _
                , vbExclamation, sTITEL_ERZEUGEN
            fbPDFDatei_erzeugen = False
        End If
        
    End If
    
End Function

Function fsGhostscriptParameter_ermitteln(sLogDateiName, sPSDateiName As String, sPDFDateiName As String, _
sAusgabeMedium As String) As String
    'Ermittelt die Parameter fr den Aufruf von Ghostscript.
    'Wenn das nicht mglich ist, wird eine Meldung angezeigt.
    'Argumente:
    '   sLogDateiName = Dateiname der Log-Datei
    '   sPSDateiName = Dateiname der Postscript-Datei
    '   sPDFDateiName = Dateiname der PDF-Datei
    '   sAusgabeMedium = "default", "screen", "printer" oder "prepress"
    'Global:
    '   gsGSProgrammName wird gelesen
    '   gvAusgabeMedienTabelle wird gelesen
    'Rckgabewert:
    '   sLEER = Es knnen keine Aufrufparameter ermittelt werden
    '   xx..xx = Aufrufparameter fr Ghostscipt
    'Effekt
    '   Ggf. wurde eine Fehlermeldung angezeigt.
    
    Dim iZaehler As Integer
    Dim iNr As Integer
    
    For iZaehler = LBound(gvAusgabeMedienTabelle, 1) To UBound(gvAusgabeMedienTabelle, 1)
        If gvAusgabeMedienTabelle(iZaehler, 0) = sAusgabeMedium Then
            Exit For
        End If
    Next iZaehler
    
    If gvAusgabeMedienTabelle(iZaehler, 0) <> sAusgabeMedium Then
        MsgBox fsText(sMSG_AUSGABEMEDIUMUNBEKANNT _
            , sAusgabeMedium) _
            , vbExclamation, sTITEL_ERZEUGEN
        fsGhostscriptParameter_ermitteln = sLEER
        Exit Function
    End If
    
    fsGhostscriptParameter_ermitteln = sSPACE & gvAusgabeMedienTabelle(iZaehler, 1)
    
    'Patch fr HP Color LaserJet PS
    'Die Seitengre muss gesetzt werden.
    Select Case gsPSDruckerName
    Case "HP Color LaserJet PS"
        fsGhostscriptParameter_ermitteln = fsGhostscriptParameter_ermitteln & " -sPAPERSIZE=a4"
        ' fest auf A4 setzen
    End Select
    
    'Beide Input control Switche mssen als letzte gesetzt werden!
    fsGhostscriptParameter_ermitteln = fsGhostscriptParameter_ermitteln _
    & " -sOutputFile=" & Chr(34) & sPDFDateiName & Chr(34) _
    & " -c .setpdfwrite -f" _
    & " -f " & Chr(34) & sPSDateiName & Chr(34) _
    & " -sstdout=" & Chr(34) & sLogDateiName & Chr(34)
    'Dateinamen in Anfhrungszeichen setzen, weil sie Leerzeichen enthalten knnen
    '-sstdout muss der letzte Eintrag sein, da mit die Anzeige auch am Bildschirm erscheint
    
End Function

Function fbPSDateiPdfmark_ergaenzen(sPSDateiName As String, _
sAuthor As String, sCreationDate As String, sCreator As String, sTitle As String, _
sSubject As String, sKeywords As String, sModDate As String, lTablesOfContents As Long, _
bUeberschriften As Boolean, sPageHeight As Single, PageWidth As Single) As Boolean
    'Die Funktion ergnzt die Postscriptdatei sPSDateiName um Dokumenteigenschaften und Lesezeichen
    'Global:
    '   gsPdfOutSwitch wird gelesen
    '   gsPdfViewSwitch wird gelesen
    '   gsPdfPageLayoutSwitch wird gelesen
    'Argumente:
    '   siehe XXX_Prozeduren.fbPSDatei_ergaenzen
    'Rckgabewert:
    '   True = Postscript-Datei sPSDateiName wurde ergnzt.
    '   False = Es ist ein fehler aufgetreten.
    'Effekt
    '   Die Postscript-Datei wurde verndert.
    
    Dim sPageMode As String
    Dim sView As String
    Dim iPSDateiNummer As Integer
        
    fbPSDateiPdfmark_ergaenzen = True
    iPSDateiNummer = FreeFile
    Open sPSDateiName For Append Access Write Lock Read Write As #iPSDateiNummer
    'Schutzmassnamen fr den Ausdruck aus: Die PostScript & PDF-Bibel, Kapitel 11.2.2
    Print #iPSDateiNummer, "/pdfmark where {pop} {userdict /pdfmark /cleartomark load put} ifelse"
    Print #iPSDateiNummer, "/languagelevel where {pop languagelevel}{1} ifelse"
    Print #iPSDateiNummer, "2 lt {"
    Print #iPSDateiNummer, "  userdict (<<) cvn ([) cvn load put"
    Print #iPSDateiNummer, "  userdict (>>) cvn (]) cvn load put"
    Print #iPSDateiNummer, "} if"
    'DOCINFO
    Print #iPSDateiNummer, "[ /Author (" & fsPostscriptString_erzeugen(sAuthor) & ")" 'Autor
    If sCreationDate <> sLEER Then
        Print #iPSDateiNummer, "/CreationDate (D:" & sCreationDate & ")"
    End If
    Print #iPSDateiNummer, "/Creator (" & fsPostscriptString_erzeugen(sCreator) & ")"
    Print #iPSDateiNummer, "/Producer (Ghostscript via Gs4Word)"
    Print #iPSDateiNummer, "/Title (" & fsPostscriptString_erzeugen(sTitle) & ")"
    Print #iPSDateiNummer, "/Subject (" & fsPostscriptString_erzeugen(sSubject) & ")"
    Print #iPSDateiNummer, "/Keywords (" & fsPostscriptString_erzeugen(sKeywords) & ")"
    If sModDate <> sLEER Then
        Print #iPSDateiNummer, "/ModDate (D:" & sModDate & ")"
    End If
    Print #iPSDateiNummer, "/DOCINFO pdfmark"
    
    'PDF-Fenster
    Select Case gsPdfPageModeSwitch
    Case sPDFPAGEMODESWITCH_AUTO ' = "Automatisch"
        If ((gsPdfOutSwitch = sPDFOUTSWITCH_WORD_ALLEVERZEICHNISSE _
        Or gsPdfOutSwitch = sPDFOUTSWITCH_WORD_NURINHALTSVERZEICHNIS) _
        And lTablesOfContents >= 1) _
        Or (gsPdfOutSwitch = sPDFOUTSWITCH_WORD_ALLEVERZEICHNISSE _
        And lTablesOfContents >= 1) _
        Or (gsPdfOutSwitch = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS1 _
        And bUeberschriften = True) _
        Or (gsPdfOutSwitch = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS2 _
        And bUeberschriften = True) _
        Or (gsPdfOutSwitch = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS3 _
        And bUeberschriften = True) _
        Or (gsPdfOutSwitch = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS4 _
        And bUeberschriften = True) _
        Or (gsPdfOutSwitch = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS5 _
        And bUeberschriften = True) _
        Or (gsPdfOutSwitch = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS6 _
        And bUeberschriften = True) _
        Or (gsPdfOutSwitch = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS7 _
        And bUeberschriften = True) _
        Or (gsPdfOutSwitch = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS8 _
        And bUeberschriften = True) _
        Or (gsPdfOutSwitch = sPDFOUTSWITCH_WORD_ALLEUEBERSCHRIFTEN _
        And bUeberschriften = True) _
        Then
            sPageMode = "/UseOutlines" 'mit Lesezeichen
        Else
            sPageMode = "/UseNone" 'Standardeinstellung ohne Lesezeichen und Thumbnails
        End If
    Case sPDFPAGEMODESWITCH_USENONE ' = "Kein Navigationsfenster"
        sPageMode = "/UseNone" 'Standardeinstellung ohne Lesezeichen und Thumbnails
    Case sPDFPAGEMODESWITCH_USEOUTLINES ' = "Lesezeichen"
        sPageMode = "/UseOutlines" 'mit Lesezeichen
    Case sPDFPAGEMODESWITCH_USETHUMBS ' = "Miniaturansichten"
        sPageMode = "/UseThumbs" 'mit Thumbnails
    Case sPDFPAGEMODESWITCH_FULLSCREEN ' = "Vollbild"
        sPageMode = "/FullScreen" 'Vollbild
    Case Else
        MsgBox fsText(sMSG_PDFPAGEMODESWITCHUNBEKANNT _
            , gsPdfPageModeSwitch) _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDateiPdfmark_ergaenzen = False
        Exit Function
    End Select

    'PDF-Anzeige
    'Koordinaten im PDF-Dokument:
    '   Seitenursprung ist unten links
    '   Masseinheit 1 Punkt = 1/72 Zoll = 25,4/72 mm = 0,3528 mm
    '   bei [/XYZ links oben zoom] bedeutet
    '       links oben den Anstand vom Seitenursprung zur oberen linken Ecke des Fensters
    '       zoom den Zoomfaktor der Seite
    '   Der Wert null in einer der Elemente bedeutet 'keine nderung'
    Select Case gsPdfViewSwitch
    Case sPDFVIEWSWITCH_XYZ ' = "Unverndert" = Einstellungen im AdobeReader nicht ndern
        sView = "/View [/XYZ null null null]"
    Case sPDFVIEWSWITCH_100 ' = "Originalgre" im AdobeReader-Men
        sView = "/View [/XYZ 4 " & Int(sPageHeight + 4) & " 1]"
    Case sPDFVIEWSWITCH_FIT ' = "Ganze Seite" im AdobeReader-Men
        sView = "/View [/Fit]"
    Case sPDFVIEWSWITCH_FITH ' = "Fensterbreite" im AdobeReader-Men
        sView = "/View [/FitH -32768]"
    Case Else
        MsgBox fsText(sMSG_PDFVIEWSWITCHUNBEKANNT _
            , gsPdfViewSwitch) _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDateiPdfmark_ergaenzen = False
        Exit Function
    End Select
    
    'DOCVIEW
    Print #iPSDateiNummer, "[ /PageMode " & sPageMode & " /Page 1 " & sView & " /DOCVIEW pdfmark"
    'Teststatement (funktioniert nicht)
        'Print #iPSDateiNummer, "[ /_objdef {MyAction} /type /dict /OBJ pdfmark"
        'Print #iPSDateiNummer, "[ {MyAction} << /Subtype /Named /N /GeneralInfo >>  /PUT pdfmark"
        'Print #iPSDateiNummer, "[ {Catalog} << /OpenAction {MyAction} >> /PUT pdfmark"
    'Teststatement (funktioniert nicht)
        'Print #iPSDateiNummer, "[ {Catalog} << /Subtype /Named /N /LastPage >> /PUT pdfmark"
    'Teststatement (funktioniert nicht)
        'Print #iPSDateiNummer, "[ /Rect [ 50 500 150 600 ] /Action << /Subtype /Named /N /LastPage >>  /Color [ .7 0 0 ] /Subtype /Link /ANN /pdfmark"
    'Teststatement (funktioniert nicht)
        'Print #iPSDateiNummer, "[ {Catalog} << /PageLayout /TwoColumnRight >> /PUT pdfmark"
    
    'PDF-Layout
    Select Case gsPdfPageLayoutSwitch
    Case sPDFPAGELAYOUTSWITCH_DEFAULT ' = "Unverndert"
        'nichts tuen
    Case sPDFPAGELAYOUTSWITCH_SP ' = "Einzelne Seite"
        Print #iPSDateiNummer, "[ {Catalog} << /PageLayout /SinglePage >> /PUT pdfmark"
    Case sPDFPAGELAYOUTSWITCH_OC ' = "Fortlaufend"
        Print #iPSDateiNummer, "[ {Catalog} << /PageLayout /OneColumn >> /PUT pdfmark"
    Case sPDFPAGELAYOUTSWITCH_TCR ' = "Fortlaufend Doppelseiten (rechts)"
        Print #iPSDateiNummer, "[ {Catalog} << /PageLayout /TwoColumnRight >> /PUT pdfmark"
    Case sPDFPAGELAYOUTSWITCH_TCL ' = "Fortlaufend Doppelseiten (links)"
        Print #iPSDateiNummer, "[ {Catalog} << /PageLayout /TwoColumLeft >> /PUT pdfmark"
    Case Else
        MsgBox fsText(sMSG_PDFPAGELAYOUTSWITCHUNBEKANNT _
            , gsPdfPageLayoutSwitch) _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDateiPdfmark_ergaenzen = False
        Exit Function
    End Select

    Close #iPSDateiNummer
        
    fbPSDateiPdfmark_ergaenzen = True
    
End Function

Function fsPostscriptString_erzeugen(sString As String) As String
    'Die Funktion erzeugt aus sString einen gltigen Postscript-String.
    'Das runden Klammern ( und ) und der Backslash mssen in Postscript-Strings mit einem Backslash
    '\ escaped werden.
    'Nicht darstellbare Sonderzeichen aus dem Men "Einfgen > Sonderzeichen > Auswahl 2" werden
    'in ASCII-Zeichen umgesetzt.
    'Argumente:
    '   sString = String der in eine Postscript-Datei eingefgt werden soll
    'Rckgabewert:
    '   xx..xx = erweiterter String, der in eine Postscript-Datei eingefgt werden kann
    'Effekt
    '   keiner

    'Const sUMZUSETZENDEZEICHEN As String = "()\" ' Alle Zeichen, die mit \ escaped werden mssen.
    Dim lStringPos, lUmzZeichenPos As Long 'Zhler
    Dim sEinZeichen As String
    
    fsPostscriptString_erzeugen = sLEER
    For lStringPos = 1 To Len(sString)
        sEinZeichen = Mid(sString, lStringPos, 1)
        Select Case Asc(sEinZeichen)
            Case 40, 41, 92
                ' 40 = ( Runde Klammer auf
                ' 41 = ) Runde Klammer zu
                ' 92 = \ Backslash
                'Diese Zeichen escapen
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & "\" & sEinZeichen
            Case 32 To 126
                '  32 bis 126 sind die ASCII-Zeichen
                '  32 = Em Abstand ist schon ein Leerzeichen
                '  32 = En Abstand ist schon Leerzeichen
                ' Bedingter Trennstrich
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & sEinZeichen
            Case 128
                ' 128 =  Euro-Zeichen
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & "E"
            Case 160
                ' 160 = Geschtztes Leerzeichen
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & sSPACE
            Case 169, 174, 167, 182
                ' 169 =  Copyright
                ' 174 =  Eingetragenes Warenzeichen
                ' 167 =  Paragraphenzeichen
                ' 182 =  Absatz
                ' werden schon richtig erzeugt Es ist OFFEN, ob das berall funktioniert
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & sEinZeichen
            Case 150, 151, 152
                ' 150 =  Gedankenstrich
                ' 151 =  Langer Gedankeinstrich
                ' 152 =  Geschtzter Bindestrich
                'Dabei sind Gedankenstrich und Geschtzter Bindestrich gleich
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & "-"
            Case 153
                ' 153 =  Warenzeichen
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & "TM"
            Case 133
                ' 133 =  Auslassungszeichen
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & "..."
            Case 145, 146
                ' 145 =  Einfaches ffnendes Anfhrungszeichen
                ' 146 =  Einfaches schliessendes Anfhrungszeichen
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & "'"
            Case 147, 148
                ' 214 =  ffnendes Anfhrungszeichen
                ' 223 =  Schlieendes Anfhrungszeichen
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & """"
           Case Else
                'Ich glaube nicht, dass die Umsetzung hier immer richtig erfolgt
                'Siehe: VBA Onlinehilfe - Zeichensatz
                fsPostscriptString_erzeugen = fsPostscriptString_erzeugen & sEinZeichen
                'Debug.Print "### " & Asc(sEinZeichen) & "=" & sEinZeichen & sSpace & sString
        End Select
    Next lStringPos

End Function

Function fbPDFDatei_anzeigen(sPDFDateiName As String) As Boolean
    'Die Funktion zeigt die PFD-Datei sPDFDateiName an, wenn gbPDFBetrachterFlag gesetzt ist.
    'Global:
    '   gbPDFBetrachterFlag wird gelesen
    '   gsPDFProgrammName wird gelesen
    'Argumente:
    '   sPDFDateiName = Dateiname der PDF-Datei
    'Rckgabewert:
    '   False = PDF-Datei sPDFDateiName wurde nicht angezeigt.
    '   True = PDF-Datei sPDFDateiName wurde angezeigt.
    'Effekt
    '   Ggf. wurde ein PDF-Betrachter mit der PDF-Datei geffnet.
    '   Ggf. wurde stattdessen eine Fehlermeldung angezeigt.
    
    Dim vtaskId As Variant 'Task-ID eines mit Shell aufgerufenen Programms

    If gbPDFBetrachterFlag = True Then ' PDF-Betrachter aufrufen
        If Dir(gsPDFProgrammName, vbNormal) = sLEER Then
            MsgBox fsText(sMSG_PDFPROGRAMMUNBEKANNT _
                , gsPDFProgrammName) _
                , vbExclamation, sTITEL_ERZEUGEN
            fbPDFDatei_anzeigen = False
            Exit Function
        End If
        vtaskId = _
        Shell(Chr(34) & gsPDFProgrammName & Chr(34) & sSPACE & Chr(34) & sPDFDateiName & Chr(34), 3)
        'PDF-Datei mit Pfad angeben, denn sonst finden Adobe Acrobat die Datei nicht, wenn Acrobat
        'schon geffnet ist und schon eine andere PDF-Datei aus einem anderen Verzeichnis angezeigt
        'wird.
        If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
            'Shell wird asynchron verarbeitet, deshalb zuerst solange warten, bis das Programm
            'gestartet ist. Das dauert maximal so lange, wie der Start von Ghostscript gedauert hat.
            Call fbWarten(giGsWartezeit)
        End If
        On Error Resume Next
        AppActivate vtaskId
            'Wenn Acrobat Reader schon geffnet ist, erzeugt AppActivate einen Laufzeitfehler 5
        On Error GoTo 0
    End If
    
    fbPDFDatei_anzeigen = True
    
End Function

Function fbWarten(iAnzahlSekunden As Integer) As Boolean
    'Die Funktion wartet die angegeben Anzahl Sekunden.
    'siehe http://www.aboutvb.de/kom/artikel/komsleeper.htm
    'Argumente:
    '   nAnzahlSekunden = Anzahl Sekunden, die gewartet werden soll
    'Rckgabewert:
    '   True = ausreichend lange gewartet
    'Effekt
    '   Die Anwendung hat die angegebene Anzahl Sekunden nichts mehr gemacht.
    '   Wenn zwischenzeitlich ein Fenster einer anderen Anwendung ein Fenster dieser schlafenden Anwendung berdeckt hat
    '   und vor deren Aufwachen wieder verschwindet, wird die Darstellung des schlafenden Fensters nicht aktualisiert.
    
    Sleep iAnzahlSekunden * 1000
    fbWarten = True
    
End Function

'===================================================================================================
'Alle ffentlichen Funktionen, die auch von XXX_Konfigurieren verwendet werden.
'===================================================================================================

Function fbKonfigurieren(sTaskName As String) As Boolean
    'Die Prozedur erzeugt eine Word-Instanz. Es lt in dieser Instanz Instanz das Konfigurations-
    'Add-In Gs4WordKonfiguration.dot installieren. Danach kann es in dieser Instanz das passende
    'Konfigurations-Makro fr Word, Excel oder Powerpoint aus den geladenen Konfigurations-Add-In
    'aufrufen. Zuletzt deinstalliert es das Konfigurations-Makro und beendet die Word-Instanz
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Effekt
    '   Es wurde eine neue Word-Instanz erzeugt
    '   In der neuen Word-Instanz wurde das Konfigurations-Add-In installiert.
    '   Im Konfigurations-Add-In wurde das passende Konfigrations-Makro aufgerufen
    '   Im Konfigurations-Makro wurde die Konfiguration aus der Registry gelesen, der
    '       Konfigurations-Dialog aufgerufen und ggf. die Konfiguration gendert in die Registry
    '       zurckgeschrieben.
    '   Im Konfigurations-Add-In wurde das KKonfigurations-Add-In deinstalliert.
    '   Die neue Word-Instanz wurde beendet.
        
    Dim iFehlerNummer As Integer
    Dim sKonfigProgrammName As String
    Dim sKonfigurationsMakro As String
    Dim bButtonFlag As Boolean 'speichert den Originalwert von gbButtonFlag
    Dim bMailToSwitch As String 'speichert den Originalwert von gbMailToSwitch
    Dim sDokuAufruf As String 'speichert den Originalwert von gsDokuAufruf
    Dim sSprachSwitch As String 'speichert den Originalwert von sSprachSwitch
    'Dim oWord As Word.Application 'Bei diesem Dim ist der Verweis auf Microsoft Word x.x Object
    '   Library erforderlich.
    Dim oWord As Object 'Es ist kein Verweis auf die Library erforderlich. Der Code luft langsamer.
    
    fbKonfigurieren = True
    
    If sTaskName = sLEER Then
        sTaskName = UCase(Application.Name)
    End If
    
    'Konfigurations-Makro ermitteln
    sKonfigProgrammName = gsInstVerzeichnis & sKONFIGURATIONS_ADDIN
    Select Case sTaskName
    Case sTASKNAME_WORD
        If fbVorlageIstAenderbar = True Then
            sKonfigurationsMakro = sWORDKONFIGURATIONISTAENDERBAR
        Else
            sKonfigurationsMakro = sWORDKONFIGURATIONNICHTAENDERBAR
        End If
    Case sTASKNAME_EXCEL
        sKonfigurationsMakro = sEXCELKONFIGURATION
    Case sTASKNAME_POWERPOINT
        sKonfigurationsMakro = sPOWERPOINTKONFIGURATION
    Case Else
        MsgBox fsText(sMSG_CASEELSE _
            , "fbKonfigurieren") _
            , vbExclamation, sTITEL_ERZEUGEN
        Error 51
    End Select
    
    'Sichtbare Einstellungen (Erzeugen-Button und Mailen-Meneintrag) merken
    Call fbKonfiguration_lesen(UCase(Application.Name))
    bButtonFlag = gbButtonFlag 'merken, ob der PDF-Button in der Symbolleiste angezeigt wird
    bMailToSwitch = gsMailToSwitch 'merken, ob die PDF-Datei gemailt werden kann
    sDokuAufruf = gsDokuAufruf 'merken, ob die Dokumentation aufgerufen werden kann
    sSprachSwitch = gsSprachSwitch 'Aktuelle Sprache merken

    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox fsText(sMSG_KEINEVERBINDUNGZUWORD) _
            , vbExclamation, sTITEL_KONFIGURATION
        fbKonfigurieren = False
        Exit Function
    End If
    
    'Konfigurations-Add-In laden
    On Error Resume Next
    oWord.AddIns.Add FileName:=sKonfigProgrammName, Install:=True
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer <> 0 Then
        MsgBox fsText(sMSG_KONFIGURATIONSADDINFEHLT _
            , sKonfigProgrammName) _
            , vbExclamation, sTITEL_KONFIGURATION
        fbKonfigurieren = False
    Else
        'Konfigurations-Add-In ausfhren
        oWord.Visible = True 'Word Applikation anzeigen, bei False sieht man nichts!
        On Error Resume Next
        oWord.Run MacroName:=sKonfigurationsMakro
        iFehlerNummer = Err.Number
        On Error GoTo 0
        If iFehlerNummer <> 0 Then
            MsgBox fsText(sMSG_KONFIGURATIONSMAKROFEHLT _
                , sKonfigProgrammName _
                , sKonfigurationsMakro) _
                , vbExclamation, sTITEL_KONFIGURATION
            fbKonfigurieren = False
        Else
            'Konfigurations-Add-In entladen
            On Error Resume Next
            oWord.AddIns(sKonfigProgrammName).Delete
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox fsText(sMSG_KONFIGURATIONSMAKROSCHLIESSEN _
                    , sKonfigProgrammName) _
                    , vbExclamation, sTITEL_KONFIGURATION
                fbKonfigurieren = False
            End If
        End If
    End If
    
    'oWord.Quit SaveChanges:=wdDoNotSaveChanges 'Bei SaveChanges ist der Verweis auf die Library
    'erforderlich.
    oWord.Quit
    Set oWord = Nothing

    'Prfen, ob sichtbare Einstellungen (Erzeugen-Button und Mailen-Meneintrag) gendert wurden
    If iFehlerNummer = 0 Then
        Call fbKonfiguration_lesen(UCase(Application.Name))
        'Anzeige des Buttons in der Symbolleiste an/ausschalten, wenn gbButtonFlag oder
        'bsMailToSwitch verndert wurde
        If UCase(Application.Name) = sTASKNAME_WORD Then
            If fbVorlageIstAenderbar = True _
            And (bButtonFlag <> gbButtonFlag _
            Or sSprachSwitch <> gsSprachSwitch _
            Or (bMailToSwitch = sMAILTOSWITCH_AUS And Not gsMailToSwitch = sMAILTOSWITCH_AUS) _
            Or (Not bMailToSwitch = sMAILTOSWITCH_AUS And gsMailToSwitch = sMAILTOSWITCH_AUS) _
            Or (sDokuAufruf = sLEER And gsDokuAufruf <> sLEER) _
            Or (sDokuAufruf <> sLEER And gsDokuAufruf = sLEER) _
            ) Then
                Call fbVorlageAnpassen(True)
            End If
        Else
            Call fbVorlageAnpassen(True)
        End If
    End If
    
End Function

Function fsAusgabeMedium_konvertieren(sEingabewert As String) As String
    'Die Funktion gibt den zum Eingabenwert passenden Ausgabewert zurck. Wenn der Eingabewert
    'numerisch ist, gibt die Funktion den passenden Text zurck. Wenn der Eingabewert
    'alphanumerisch ist, gibt die Funktion den passenden Index zurck. Anderenfalls gibt die
    'Funktion sLEER zurck.
    'Global:
    '   gvAusgabeMedienTabelle wird gelesen
    'Argumente:
    '   sEingabewert = Zahl oder String
    'Rckgabewert:
    '   0,1..n = passender Index zum Eingabewert.
    '   xx..xx = passender Text zum Eingabewert.
    '   sLEER = kein passendere Wert gefunden.
    'Effekt
    '   keiner

    Dim iZaehler As Integer
    
    If VarType(gvAusgabeMedienTabelle) = vbEmpty Then
        fsAusgabeMedium_konvertieren = sLEER
        Exit Function
    End If
           
    If IsNumeric(sEingabewert) Then
        Select Case CInt(sEingabewert)
        Case LBound(gvAusgabeMedienTabelle, 1) To UBound(gvAusgabeMedienTabelle, 1)
            fsAusgabeMedium_konvertieren = gvAusgabeMedienTabelle(CInt(sEingabewert), 0)
        Case Else
            fsAusgabeMedium_konvertieren = sLEER
        End Select
    Else
        fsAusgabeMedium_konvertieren = sLEER
        For iZaehler = LBound(gvAusgabeMedienTabelle, 1) To UBound(gvAusgabeMedienTabelle, 1)
            If gvAusgabeMedienTabelle(iZaehler, 0) = sEingabewert Then
                fsAusgabeMedium_konvertieren = iZaehler
                Exit For
            End If
        Next iZaehler
    End If
    
End Function

Function fsMailToSwitch_konvertieren(sEingabewert As String) As String
    'Die Funktion gibt den zum Eingabenwert passenden Ausgabewert zurck. Wenn der Eingabewert
    'numerisch ist, gibt die Funktion den passenden Text zurck. Wenn der Eingabewert
    'alphanumerisch ist, gibt die Funktion den passenden Index zurck. Anderenfalls gibt die
    'Funktion sLEER zurck.
    'Global:
    '   gsMailToSwitchListe() wird immer gefllt
    'Argumente:
    '   sEingabewert = Zahl oder String
    'Rckgabewert:
    '   0,1..n = passender Index zum Eingabewert.
    '   xx..xx = passender Text zum Eingabewert.
    '   sLEER = kein passendere Wert gefunden.
    'Effekt
    '   keiner

    Dim iZaehler As Integer
    
    gsMailToSwitchListe(0) = sMAILTOSWITCH_AUS
    gsMailToSwitchListe(1) = sMAILTOSWITCH_VERWENDEN
    gsMailToSwitchListe(2) = sMAILTOSWITCH_NEUERZEUGEN
    
    If IsNumeric(sEingabewert) Then
        Select Case CInt(sEingabewert)
        Case LBound(gsMailToSwitchListe) To UBound(gsMailToSwitchListe)
            fsMailToSwitch_konvertieren = gsMailToSwitchListe(CInt(sEingabewert))
        Case Else
            fsMailToSwitch_konvertieren = sLEER
        End Select
    Else
        fsMailToSwitch_konvertieren = sLEER
        For iZaehler = LBound(gsMailToSwitchListe) To UBound(gsMailToSwitchListe)
            If gsMailToSwitchListe(iZaehler) = sEingabewert Then
                fsMailToSwitch_konvertieren = iZaehler
                Exit For
            End If
        Next iZaehler
    End If
    
End Function

Function fsPDFPageLayoutSwitch_konvertieren(sEingabewert As String) As String
    'Die Funktion gibt den zum Eingabenwert passenden Ausgabewert zurck. Wenn der Eingabewert
    'numerisch ist, gibt die Funktion den passenden Text zurck. Wenn der Eingabewert
    'alphanumerisch ist, gibt die Funktion den passenden Index zurck. Anderenfalls gibt die
    'Funktion sLEER zurck.
    'Global:
    '   gsPdfPageLayoutSwitchListe() wird immer gefllt
    'Argumente:
    '   sEingabewert = Zahl oder String
    'Rckgabewert:
    '   0,1..n = passender Index zum Eingabewert.
    '   xx..xx = passender Text zum Eingabewert.
    '   sLEER = kein passendere Wert gefunden.
    'Effekt
    '   keiner
    
    Dim iZaehler As Integer
    
    ReDim gsPdfPageLayoutSwitchListe(4)
    gsPdfPageLayoutSwitchListe(0) = sPDFPAGELAYOUTSWITCH_DEFAULT
    gsPdfPageLayoutSwitchListe(1) = sPDFPAGELAYOUTSWITCH_SP
    gsPdfPageLayoutSwitchListe(2) = sPDFPAGELAYOUTSWITCH_OC
    gsPdfPageLayoutSwitchListe(3) = sPDFPAGELAYOUTSWITCH_TCR
    gsPdfPageLayoutSwitchListe(4) = sPDFPAGELAYOUTSWITCH_TCL
    If IsNumeric(sEingabewert) Then
        Select Case CInt(sEingabewert)
        Case LBound(gsPdfPageLayoutSwitchListe) To UBound(gsPdfPageLayoutSwitchListe)
            fsPDFPageLayoutSwitch_konvertieren = gsPdfPageLayoutSwitchListe(CInt(sEingabewert))
        Case Else
            fsPDFPageLayoutSwitch_konvertieren = sLEER
        End Select
    Else
        fsPDFPageLayoutSwitch_konvertieren = sLEER
        For iZaehler = LBound(gsPdfPageLayoutSwitchListe) To UBound(gsPdfPageLayoutSwitchListe)
            If gsPdfPageLayoutSwitchListe(iZaehler) = sEingabewert Then
                fsPDFPageLayoutSwitch_konvertieren = iZaehler
                Exit For
            End If
        Next iZaehler
    End If
    
End Function

Function fsPDFPageModeSwitch_konvertieren(sEingabewert As String, sTaskName As String) As String
    'Die Funktion gibt den zum Eingabenwert passenden Ausgabewert zurck. Wenn der Eingabewert
    'numerisch ist, gibt die Funktion den passenden Text zurck. Wenn der Eingabewert
    'alphanumerisch ist, gibt die Funktion den passenden Index zurck. Anderenfalls gibt die
    'Funktion sLEER zurck.
    'Global:
    '   gsPdfPageModeSwitchListe() wird immer gefllt
    'Argumente:
    '   sEingabewert = Zahl oder String
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Rckgabewert:
    '   0,1..n = passender Index zum Eingabewert.
    '   xx..xx = passender Text zum Eingabewert.
    '   sLEER = kein passendere Wert gefunden.
    'Effekt
    '   keiner

    Dim iZaehler As Integer
    
    Select Case sTaskName
    Case sTASKNAME_WORD
        ReDim gsPdfPageModeSwitchListe(4)
        gsPdfPageModeSwitchListe(0) = sPDFPAGEMODESWITCH_USENONE
        gsPdfPageModeSwitchListe(1) = sPDFPAGEMODESWITCH_USEOUTLINES
        gsPdfPageModeSwitchListe(2) = sPDFPAGEMODESWITCH_USETHUMBS
        gsPdfPageModeSwitchListe(3) = sPDFPAGEMODESWITCH_FULLSCREEN
        gsPdfPageModeSwitchListe(4) = sPDFPAGEMODESWITCH_AUTO
    Case sTASKNAME_EXCEL
        ReDim gsPdfPageModeSwitchListe(2)
        gsPdfPageModeSwitchListe(0) = sPDFPAGEMODESWITCH_USENONE
        gsPdfPageModeSwitchListe(1) = sPDFPAGEMODESWITCH_USETHUMBS
        gsPdfPageModeSwitchListe(2) = sPDFPAGEMODESWITCH_FULLSCREEN
    Case sTASKNAME_POWERPOINT
        ReDim gsPdfPageModeSwitchListe(2)
        gsPdfPageModeSwitchListe(0) = sPDFPAGEMODESWITCH_USENONE
        gsPdfPageModeSwitchListe(1) = sPDFPAGEMODESWITCH_USETHUMBS
        gsPdfPageModeSwitchListe(2) = sPDFPAGEMODESWITCH_FULLSCREEN
    Case Else
        MsgBox fsText(sMSG_CASEELSE _
            , "fsPDFPageModeSwitch_konvertieren") _
            , vbExclamation, sTITEL_ERZEUGEN
        Error 51
    End Select
    
    If IsNumeric(sEingabewert) Then
        Select Case CInt(sEingabewert)
        Case LBound(gsPdfPageModeSwitchListe) To UBound(gsPdfPageModeSwitchListe)
            fsPDFPageModeSwitch_konvertieren = gsPdfPageModeSwitchListe(CInt(sEingabewert))
        Case Else
            fsPDFPageModeSwitch_konvertieren = sLEER
        End Select
    Else
        fsPDFPageModeSwitch_konvertieren = sLEER
        For iZaehler = LBound(gsPdfPageModeSwitchListe) To UBound(gsPdfPageModeSwitchListe)
            If gsPdfPageModeSwitchListe(iZaehler) = sEingabewert Then
                fsPDFPageModeSwitch_konvertieren = iZaehler
                Exit For
            End If
        Next iZaehler
    End If
    
End Function

Function fsPDFViewSwitch_konvertieren(sEingabewert As String) As String
    'Die Funktion gibt den zum Eingabenwert passenden Ausgabewert zurck. Wenn der Eingabewert
    'numerisch ist, gibt die Funktion den passenden Text zurck. Wenn der Eingabewert
    'alphanumerisch ist, gibt die Funktion den passenden Index zurck. Anderenfalls gibt die
    'Funktion sLEER zurck.
    'Global:
    '   gsPdfViewSwitchListe() wird immer gefllt
    'Argumente:
    '   sEingabewert = Zahl oder String
    'Rckgabewert:
    '   0,1..n = passender Index zum Eingabewert.
    '   xx..xx = passender Text zum Eingabewert.
    '   sLEER = kein passendere Wert gefunden.
    'Effekt
    '   keiner
    
    Dim iZaehler As Integer
    
    ReDim gsPdfViewSwitchListe(3)
    gsPdfViewSwitchListe(0) = sPDFVIEWSWITCH_XYZ
    gsPdfViewSwitchListe(1) = sPDFVIEWSWITCH_100
    gsPdfViewSwitchListe(2) = sPDFVIEWSWITCH_FIT
    gsPdfViewSwitchListe(3) = sPDFVIEWSWITCH_FITH
    If IsNumeric(sEingabewert) Then
        Select Case CInt(sEingabewert)
        Case LBound(gsPdfViewSwitchListe) To UBound(gsPdfViewSwitchListe)
            fsPDFViewSwitch_konvertieren = gsPdfViewSwitchListe(CInt(sEingabewert))
        Case Else
            fsPDFViewSwitch_konvertieren = sLEER
        End Select
    Else
        fsPDFViewSwitch_konvertieren = sLEER
        For iZaehler = LBound(gsPdfViewSwitchListe) To UBound(gsPdfViewSwitchListe)
            If gsPdfViewSwitchListe(iZaehler) = sEingabewert Then
                fsPDFViewSwitch_konvertieren = iZaehler
                Exit For
            End If
        Next iZaehler
    End If
    
End Function

Function fsPrintSwitch_konvertieren(sEingabewert As String, sTaskName As String) As String
    'Die Funktion gibt den zum Eingabenwert passenden Ausgabewert zurck. Wenn der Eingabewert
    'numerisch ist, gibt die Funktion den passenden Text zurck. Wenn der Eingabewert
    'alphanumerisch ist, gibt die Funktion den passenden Index zurck. Anderenfalls gibt die
    'Funktion sLEER zurck.
    'Global:
    '   gsPrintSwitchListe() wird immer gefllt
    'Argumente:
    '   sEingabewert = Zahl oder String
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Rckgabewert:
    '   0,1..n = passender Index zum Eingabewert.
    '   xx..xx = passender Text zum Eingabewert.
    '   sLEER = kein passendere Wert gefunden.
    'Effekt
    '   keiner

    Dim iZaehler As Integer
    
    Select Case sTaskName
    Case sTASKNAME_WORD
        ReDim gsPrintSwitchListe(7)
        gsPrintSwitchListe(0) = sPRINTSWITCH_WORD_DOKUMENT
        gsPrintSwitchListe(1) = sPRINTSWITCH_WORD_SEITE
        gsPrintSwitchListe(2) = sPRINTSWITCH_WORD_MARKIERUNG
        gsPrintSwitchListe(3) = sPRINTSWITCH_WORD_EIGENSCHAFT
        gsPrintSwitchListe(4) = sPRINTSWITCH_WORD_KOMMENTARE
        gsPrintSwitchListe(5) = sPRINTSWITCH_WORD_FORMATVORLAGEN
        gsPrintSwitchListe(6) = sPRINTSWITCH_WORD_AUTOTEXTE
        gsPrintSwitchListe(7) = sPRINTSWITCH_WORD_TASTENBELEGUNG
    Case sTASKNAME_EXCEL
        ReDim gsPrintSwitchListe(2)
        gsPrintSwitchListe(0) = sPRINTSWITCH_EXCEL_ARBEITSMAPPE
        gsPrintSwitchListe(1) = sPRINTSWITCH_EXCEL_TABELLE
        gsPrintSwitchListe(2) = sPRINTSWITCH_EXCEL_TABELLENAUSWAHL
    Case sTASKNAME_POWERPOINT
        ReDim gsPrintSwitchListe(2)
        gsPrintSwitchListe(0) = sPRINTSWITCH_POWERPOINT_PRAESENTATION
        gsPrintSwitchListe(1) = sPRINTSWITCH_POWERPOINT_FOLIE
        gsPrintSwitchListe(2) = sPRINTSWITCH_POWERPOINT_FOLIENAUSWAHL
    Case Else
        MsgBox fsText(sMSG_CASEELSE _
            , "fsPrintSwitch_konvertieren") _
            , vbExclamation, sTITEL_ERZEUGEN
        Error 51
    End Select
                                                           
    If IsNumeric(sEingabewert) Then
        Select Case CInt(sEingabewert)
        Case LBound(gsPrintSwitchListe) To UBound(gsPrintSwitchListe)
            fsPrintSwitch_konvertieren = gsPrintSwitchListe(CInt(sEingabewert))
        Case Else
            fsPrintSwitch_konvertieren = sLEER
        End Select
    Else
        fsPrintSwitch_konvertieren = sLEER
        For iZaehler = LBound(gsPrintSwitchListe) To UBound(gsPrintSwitchListe)
            If gsPrintSwitchListe(iZaehler) = sEingabewert Then
                fsPrintSwitch_konvertieren = iZaehler
                Exit For
            End If
        Next iZaehler
    End If
    
End Function

Function fsPDFOutSwitch_konvertieren(sEingabewert As String, sTaskName As String) As String
    'Die Funktion gibt den zum Eingabenwert passenden Ausgabewert zurck. Wenn der Eingabewert
    'numerisch ist, gibt die Funktion den passenden Text zurck. Wenn der Eingabewert
    'alphanumerisch ist, gibt die Funktion den passenden Index zurck. Anderenfalls gibt die
    'Funktion sLEER zurck.
    'Global:
    '   gsPdfOutSwitchListe() wird immer gefllt
    'Argumente:
    '   sEingabewert = Zahl oder String
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Rckgabewert:
    '   0,1..n = passender Index zum Eingabewert.
    '   xx..xx = passender Text zum Eingabewert.
    '   sLEER = kein passendere Wert gefunden.
    'Effekt
    '   keiner

    Dim iZaehler As Integer
    
    Select Case sTaskName
    Case sTASKNAME_WORD
        ReDim gsPdfOutSwitchListe(11)
        gsPdfOutSwitchListe(0) = sPDFOUTSWITCH_WORD_KEINELESEZEICHEN
        gsPdfOutSwitchListe(1) = sPDFOUTSWITCH_WORD_ALLEVERZEICHNISSE
        gsPdfOutSwitchListe(2) = sPDFOUTSWITCH_WORD_NURINHALTSVERZEICHNIS
        gsPdfOutSwitchListe(3) = sPDFOUTSWITCH_WORD_ALLEUEBERSCHRIFTEN
        gsPdfOutSwitchListe(4) = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS8
        gsPdfOutSwitchListe(5) = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS7
        gsPdfOutSwitchListe(6) = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS6
        gsPdfOutSwitchListe(7) = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS5
        gsPdfOutSwitchListe(8) = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS4
        gsPdfOutSwitchListe(9) = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS3
        gsPdfOutSwitchListe(10) = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS2
        gsPdfOutSwitchListe(11) = sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS1
    Case sTASKNAME_EXCEL
        'Wird nicht verwendet
        ReDim gsPdfOutSwitchListe(0)
        gsPdfOutSwitchListe(0) = sLEER
    Case sTASKNAME_POWERPOINT
        'Wird nicht verwendet
        ReDim gsPdfOutSwitchListe(0)
        gsPdfOutSwitchListe(0) = sLEER
    Case Else
        MsgBox fsText(sMSG_CASEELSE _
            , "fsPdfOutSwitch_konvertieren") _
            , vbExclamation, sTITEL_ERZEUGEN
        Error 51
    End Select
                                                           
    If IsNumeric(sEingabewert) Then
        Select Case CInt(sEingabewert)
        Case LBound(gsPdfOutSwitchListe) To UBound(gsPdfOutSwitchListe)
            fsPDFOutSwitch_konvertieren = gsPdfOutSwitchListe(CInt(sEingabewert))
        Case Else
            fsPDFOutSwitch_konvertieren = sLEER
        End Select
    Else
        fsPDFOutSwitch_konvertieren = sLEER
        For iZaehler = LBound(gsPdfOutSwitchListe) To UBound(gsPdfOutSwitchListe)
            If gsPdfOutSwitchListe(iZaehler) = sEingabewert Then
                fsPDFOutSwitch_konvertieren = iZaehler
                Exit For
            End If
        Next iZaehler
    End If
    
End Function

Function fsSprachSwitch_konvertieren(sEingabewert As String) As String
    'Die Funktion gibt den zum Eingabenwert passenden Ausgabewert zurck. Wenn der Eingabewert
    'ein Sprachcode ist, gibt die Funktion den passenden Text zurck. Wenn der Eingabewert
    'ein Text ist, gibt die Funktion den passenden Index zurck. Anderenfalls gibt die
    'Funktion sLEER zurck.
    'Global:
    '   gsSprachSwitchListe() wird immer gefllt
    'Argumente:
    '   sEingabewert = Sprachcode (de, en, xx) oder Text
    'Rckgabewert:
    '   xx = passendes Sprachcode zum Eingabewert.
    '   xx..xx = passender Text zum Eingabewert.
    '   sLEER = kein passendere Wert gefunden.
    'Effekt
    '   keiner

    Dim iZaehler As Integer
        
    ReDim gsSprachSwitchListe(2)
    gsSprachSwitchListe(0) = sSPRACHSWITCH_DEUTSCH
    gsSprachSwitchListe(1) = sSPRACHSWITCH_ENGLISCH
    gsSprachSwitchListe(2) = sSPRACHSWITCH_WEITERESPRACHE
    Select Case sEingabewert
    Case sSPRACHCODE_DEUTSCH
        fsSprachSwitch_konvertieren = sSPRACHSWITCH_DEUTSCH
    Case sSPRACHCODE_ENGLISCH
        fsSprachSwitch_konvertieren = sSPRACHSWITCH_ENGLISCH
    Case sSPRACHCODE_WEITERESPRACHE
        fsSprachSwitch_konvertieren = sSPRACHSWITCH_WEITERESPRACHE
    Case sSPRACHSWITCH_DEUTSCH
        fsSprachSwitch_konvertieren = sSPRACHCODE_DEUTSCH
    Case sSPRACHSWITCH_ENGLISCH
        fsSprachSwitch_konvertieren = sSPRACHCODE_ENGLISCH
    Case sSPRACHSWITCH_WEITERESPRACHE
        fsSprachSwitch_konvertieren = sSPRACHCODE_WEITERESPRACHE
    Case Else
        fsSprachSwitch_konvertieren = sLEER
    End Select

End Function

Function fsTypeSwitch_konvertieren(sEingabewert As String, sTaskName As String) As String
    'Die Funktion gibt den zum Eingabenwert passenden Ausgabewert zurck. Wenn der Eingabewert
    'numerisch ist, gibt die Funktion den passenden Text zurck. Wenn der Eingabewert
    'alphanumerisch ist, gibt die Funktion den passenden Index zurck. Anderenfalls gibt die
    'Funktion sLEER zurck.
    'Global:
    '   gsTypeSwitchListe() wird immer gefllt
    'Argumente:
    '   sEingabewert = Zahl oder String
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Rckgabewert:
    '   0,1..n = passender Index zum Eingabewert.
    '   xx..xx = passender Text zum Eingabewert.
    '   sLEER = kein passendere Wert gefunden.
    'Effekt
    '   keiner

    Dim iZaehler As Integer
    
    Select Case sTaskName
    Case sTASKNAME_WORD
        'Wird nicht verwendet
        ReDim gsTypeSwitchListe(0)
        gsTypeSwitchListe(0) = sLEER
    Case sTASKNAME_EXCEL
        'Wird nicht verwendet
        ReDim gsTypeSwitchListe(0)
        gsTypeSwitchListe(0) = sLEER
    Case sTASKNAME_POWERPOINT
        ReDim gsTypeSwitchListe(6)
        gsTypeSwitchListe(0) = sTYPESWITCH_POWERPOINT_AKTIV
        gsTypeSwitchListe(1) = sTYPESWITCH_POWERPOINT_FOLIEN
        gsTypeSwitchListe(2) = sTYPESWITCH_POWERPOINT_HANDZETTEL2
        gsTypeSwitchListe(3) = sTYPESWITCH_POWERPOINT_HANDZETTEL3
        gsTypeSwitchListe(4) = sTYPESWITCH_POWERPOINT_HANDZETTEL6
        gsTypeSwitchListe(5) = sTYPESWITCH_POWERPOINT_NOTIZEN
        gsTypeSwitchListe(6) = sTYPESWITCH_POWERPOINT_GLIEDERUNG
    Case Else
        MsgBox fsText(sMSG_CASEELSE _
            , "fsTypeSwitch_konvertieren") _
            , vbExclamation, sTITEL_ERZEUGEN
        Error 51
    End Select
                                                           
    If IsNumeric(sEingabewert) Then
        Select Case CInt(sEingabewert)
        Case LBound(gsTypeSwitchListe) To UBound(gsTypeSwitchListe)
            fsTypeSwitch_konvertieren = gsTypeSwitchListe(CInt(sEingabewert))
        Case Else
            fsTypeSwitch_konvertieren = sLEER
        End Select
    Else
        fsTypeSwitch_konvertieren = sLEER
        For iZaehler = LBound(gsTypeSwitchListe) To UBound(gsTypeSwitchListe)
            If gsTypeSwitchListe(iZaehler) = sEingabewert Then
                fsTypeSwitch_konvertieren = iZaehler
                Exit For
            End If
        Next iZaehler
    End If
    
End Function

Function fsDateiname_kuerzen(sDateiname As String, lNeueLaenge As Long) As String
    'Die Funktion krzt sDateiname auf lNeueLaenge.
    'Argumente:
    '   sDateiname = Name der Datei mit Pfad
    '   lNeueLaenge = Maximale Lnge des zurckgegebenen Strings, Muss mindestsns 4 sein.
    'Global:
    '   gsPathSeparator wird gelesen
    'Rckgabewert:
    '   sLEER = lNeueLaenge ist zu kurz um nur den Dateiname nach dem letzten Punkt anzuzeigen
    '   xxx..xxx = gekrzter Dateiname.
    'Effekt
    '   keiner
    
    Const sERSATZ As String = "..."
    
    Dim sOhnePfad As String
    Dim sNurEnde As String
    Dim iLaengePfad, iLaengeNurEnde As Integer
            
    sOhnePfad = Mid(sDateiname, flLetztesVorkommen_suchen(sDateiname, gsPathSeparator) + 1)
    iLaengeNurEnde = Len(sOhnePfad) - flLetztesVorkommen_suchen(sOhnePfad, ".") + 2
    If iLaengeNurEnde > Len(sOhnePfad) Then iLaengeNurEnde = 0 'Kein Punkt vorhanden
    iLaengePfad = lNeueLaenge - Len(sERSATZ & gsPathSeparator & sOhnePfad)
    
    If Len(sDateiname) <= lNeueLaenge Then 'alles passt
        fsDateiname_kuerzen = sDateiname
    ElseIf Len(sDateiname) > lNeueLaenge And iLaengePfad >= 0 Then 'ganzen Dateinamen anzeigen
        fsDateiname_kuerzen = Left(sDateiname, iLaengePfad) & sERSATZ & gsPathSeparator & sOhnePfad
    ElseIf lNeueLaenge >= Len(sERSATZ) + iLaengeNurEnde Then
        'Dateiname ohne Pfad kann nicht vollstndig angezeigt werden
        fsDateiname_kuerzen = sERSATZ & Right(sDateiname, lNeueLaenge - Len(sERSATZ))
    Else 'Noch nicht einmal lang genug fr den Teile nach dem letzten Punkt im Dateinamen
        fsDateiname_kuerzen = sLEER
    End If

End Function

Function fsSymbDateiName_umsetzen(sSymbolscherDateiName As String, sName As String, _
sExtension As String) As String
    'Die Funktion prft, ob sAlterDateiName ein gltiger symbolischer Dateiname ist. Sie ersetzt alle
    '<>-Strings und gibt den echten Dateinamen mit Extension zurck. Die Funktion berprft den
    'Namen auf syntaktische Fehler. Falls ein Laufwerk angegeben ist, muss es vorhanden sein. Es
    'wird nicht berpfft, ob ein UNC-Name "\\server\freigabe" oder Verzeichniss vorhanden ist.
    'Laufwerksbuchstaben werden berprft.
    'Folgende Zeichen sind in Namen unzulssig:
    '   ?  Fragezeichen ist unter NT 4.0 unzulssig
    '   *  Stern ist unter NT 4.0 unzulssig
    '   "  Doppeltes_Anfhrungszeichen ist unter NT 4.0 unzulssig
    '   <  Spitze_Klammer_auf ist unter NT 4.0 unzulssig
    '   >  Spitze_Klammer_zu ist unter NT 4.0 unzulssig
    '   |  Pipezeichen ist unter NT 4.0 unzulssig
    '   :  Doppelpunkt ist nur als zweites Zeichen zulssig, wenn davor ein Buchstabe steht.
    '   \  Bachslash ist nur vor dem Prozentzeichen zulssig
    '   %  Prozentzeichen ist wg. Ghostscript unzulssig
    'Namen drfen unter NT 4.0 nicht mit einem Punkt beginnen.
    'Argumente:
    '   sSymbolscherDateiName = Symbolischer Datenname mit <>-Strings
    '   sName = Ersetzungsstring fr <name>
    '   sExtension = Ende des Dateinamens mit Punkt ".xxx" oder sLEER
    'Global:
    '   gsPathSeparator wird gelesen
    'Rckgabewert:
    '   sLEER = aus dem symbolischen Dateinamen kann kein gltiger echter Dateiname ermittelt
    '           werden.
    '   xx..xx = echter PFD-Dateiname.
    'Effekt
    '   keiner

    Dim sDir As String 'zum Test ob der Dateiname zulssig ist
    Dim iDirFehlerNummer As Integer 'Fehlernummer aus Dir()
    Dim sDirFehlerText As String 'Fehlertext aus Dir()
    Dim sEchterPDFDateiName As String
    Dim lAnfangPos As Long 'Position in sEchterPDFDateiName, ab der nach <>-Strings gesucht wird
    Dim sERSATZ As String ' Auflsung der <>-Strings
    Dim lPos As Long 'Hilfsvariable
    Dim sUngueltigeZeichen As String 'Alle ungligen Zeichen werde hier gesammelt
    Dim sEinString As Variant 'For Each fr sOKStrings und sERRStrings
    Dim sOKStrings(20) As String 'Tabelle mit Strings, die ab lAnfangPos erlaubt sind.
    sOKStrings(0) = "<name>"
    sOKStrings(1) = "<d>"
    sOKStrings(2) = "<dd>"
    sOKStrings(3) = "<ddd>"
    sOKStrings(4) = "<dddd>"
    sOKStrings(5) = "<h>"
    sOKStrings(6) = "<hh>"
    sOKStrings(7) = "<m>"
    sOKStrings(8) = "<mm>"
    sOKStrings(9) = "<mmm>"
    sOKStrings(10) = "<mmmm>"
    sOKStrings(11) = "<n>"
    sOKStrings(12) = "<nn>"
    sOKStrings(13) = "<q>"
    sOKStrings(14) = "<s>"
    sOKStrings(15) = "<ss>"
    sOKStrings(16) = "<w>"
    sOKStrings(17) = "<ww>"
    sOKStrings(18) = "<y>"
    sOKStrings(19) = "<yy>"
    sOKStrings(20) = "<yyyy>"
    
    Dim sERRStrings(9) As String 'Tabelle mit alle Strings, die ab lAnfangPos verboten sind.
    sERRStrings(0) = "?"
    sERRStrings(1) = "*"
    sERRStrings(2) = """"
    sERRStrings(3) = "<"
    sERRStrings(4) = ">"
    sERRStrings(5) = "|"
    sERRStrings(6) = ":"
    sERRStrings(7) = "\\"
    sERRStrings(8) = "\."
    sERRStrings(9) = "%"
           
    'Initialisieren
    sUngueltigeZeichen = sLEER
    sEchterPDFDateiName = Trim(sSymbolscherDateiName)
        
    'Anfang berprfen auf sLEER, "C:XXX", "C:\XXX", "\\XXX", "\XXX", "XXX"
    If sEchterPDFDateiName = sLEER Then
        lAnfangPos = 1
    ElseIf Mid(sEchterPDFDateiName, 2, 1) = ":" _
    And Asc(LCase(Left(sEchterPDFDateiName, 1))) >= 97 _
    And Asc(LCase(Left(sEchterPDFDateiName, 1))) <= 122 Then '"c:XXX" und "c:\XXX"
        lAnfangPos = 3
        If Mid(sEchterPDFDateiName, 2, 2) = ":." Then  '"c:.XXX" ist unzulssig
            sUngueltigeZeichen = Mid(sEchterPDFDateiName, 2, 3) & "  "
        End If
    ElseIf Left(sEchterPDFDateiName, 2) = "\\" Then '"\\XXX"
        lAnfangPos = 2
    Else '"\XXX" und "XXX"
        lAnfangPos = 1
        If Left(sEchterPDFDateiName, 1) = "." Then  '".XXX" ist unzulssig
            sUngueltigeZeichen = Left(sEchterPDFDateiName, 3) & "  "
        End If
    End If
    
    'Alle gltigen <>-Strings ersetzen
    For Each sEinString In sOKStrings
        lPos = lAnfangPos
        If InStr(lPos, sEchterPDFDateiName, "<") = 0 Then
            Exit For 'kein < gefunden, also fertig
        End If
        Do
            lPos = InStr(lPos, sEchterPDFDateiName, sEinString, vbTextCompare)
            If lPos > 0 Then
                If StrComp(sEinString, "<name>", vbTextCompare) = 0 Then
                    sERSATZ = sName
                ElseIf StrComp(sEinString, "<dd>", vbTextCompare) = 0 Then
                    sERSATZ = Format(Now, "Dd")
                Else
                    sERSATZ = Format(Now, Mid(sEinString, 2, Len(sEinString) - 2))
                End If
                sEchterPDFDateiName = Left(sEchterPDFDateiName, lPos - 1) _
                    & sERSATZ _
                    & Mid(sEchterPDFDateiName, lPos + Len(sEinString))
                lPos = lPos + Len(sERSATZ)
            Else
                Exit Do
            End If
        Loop
    Next sEinString
    
    'Jetzt auf ungltige Strings prfen
    For Each sEinString In sERRStrings
        lPos = InStr(lAnfangPos, sEchterPDFDateiName, sEinString, vbTextCompare)
        If lPos > 0 Then
            If sUngueltigeZeichen = sLEER Then
                sUngueltigeZeichen = Mid(sEchterPDFDateiName, lPos, 3) & "  "
            Else
                sUngueltigeZeichen = sUngueltigeZeichen & Mid(sEchterPDFDateiName, lPos, 3) & "  "
            End If
        End If
    Next sEinString
    
    If sUngueltigeZeichen <> sLEER Then
        If sSymbolscherDateiName = sEchterPDFDateiName Then
            MsgBox fsText(sMSG_UNZULAESSIGEZEICHEN1 _
                , sUngueltigeZeichen _
                , sSymbolscherDateiName) _
                , vbExclamation, sTITEL_PDFDATEINAME
        Else
            MsgBox fsText(sMSG_UNZULAESSIGEZEICHEN2 _
                , sUngueltigeZeichen _
                , sSymbolscherDateiName _
                , sEchterPDFDateiName) _
                , vbExclamation, sTITEL_PDFDATEINAME
        End If
        fsSymbDateiName_umsetzen = sLEER
    ElseIf Right(sEchterPDFDateiName, 1) = gsPathSeparator _
    Or Right(sEchterPDFDateiName, 1) = ":" _
    Or (Left(sEchterPDFDateiName, 2) = "\\" _
        And InStr(2, sEchterPDFDateiName, gsPathSeparator) = 0) _
    Or sEchterPDFDateiName = sLEER Then
        MsgBox fsText(sMSG_KEINEPDFDATEI _
            , sSymbolscherDateiName) _
            , vbExclamation, sTITEL_PDFDATEINAME
        fsSymbDateiName_umsetzen = sLEER
    Else 'Es knnte ein gltiger Dateiname sein
        On Error Resume Next
        sDir = Dir(sEchterPDFDateiName)
        iDirFehlerNummer = Err.Number
        sDirFehlerText = Error(iDirFehlerNummer)
        On Error GoTo 0
        If iDirFehlerNummer <> 0 Then
            MsgBox fsText(sMSG_DIRFEHLER _
                , sDirFehlerText _
                , sSymbolscherDateiName _
                , sEchterPDFDateiName) _
                , vbExclamation, sTITEL_PDFDATEINAME
            fsSymbDateiName_umsetzen = sLEER
        Else 'Hurra - es ist ein gltiger Dateiname
            If StrComp(Right(sEchterPDFDateiName, Len(sExtension)), sExtension, vbTextCompare) _
            <> 0 Then  'Ende des Namens ist sExtension
                'Wenn sExtension sLEER ist, trifft die If-Bedingung nicht zu
                sEchterPDFDateiName = sEchterPDFDateiName & sExtension
            End If
            fsSymbDateiName_umsetzen = sEchterPDFDateiName
        End If
    End If
    
End Function

Function fbDatei_pruefen_loeschen(sDateiname As String) As Boolean
    'Die Funktion prft, ob eine Datei in einem Verzeichnis erzeugt werden kann, indem sie die Datei
    'lscht, wenn sie vorhanden ist, und dann mit der Lnge 0 anlegt und wieder lscht.
    'Argumente
    '   sDateiname = Dateiname mit Pfad und Extension
    'Global:
    '   Application.Name = Name der aktuellen Applikation wird gelesen.
    '   gsPrintSwitch wird gelesen.
    '   Application.Name und gsPrintSwitch sind nur erforderlich, um eine andere
    '   Fehlermeldung auszugeben, wenn es sich um eine einzelne Excel-Tabelle handelt.
    'Rckgabewert:
    '   False = Datei sDateiname konnte nicht gelscht, erzeugt oder nur erzeugt aber nicht wieder
    '           gelscht werden.
    '   True = Datei sDateiname.ps wurde gelscht, erzeugt und wieder gelscht.
    'Effekt
    '   Entweder wurde eine Datei mit 0 Byte Lnge angelegt und wieder gelscht
    '   oder es wurde eine Fehlermeldung angezeigt.
    
    Dim iFehlerNummer As Integer
    
    fbDatei_pruefen_loeschen = False
    Dim iDateinummer As Integer
    
    If fbDatei_loeschen(sDateiname) = True Then
        On Error Resume Next
        iDateinummer = FreeFile
        Open sDateiname For Output Shared As #iDateinummer
        iFehlerNummer = Err.Number
        On Error GoTo 0
        If iFehlerNummer = 0 Then 'Alles OK
            Close #iDateinummer
            If fbDatei_loeschen(sDateiname) = True Then
                fbDatei_pruefen_loeschen = True 'einziger OK-Fall
            Else 'Paranoia: Datei konnte angelegt aber nicht mehr gelscht werden.
                MsgBox fsText(sMSG_DATEIKANNNICHTMEHRGELOESCHTWERDEN _
                    , Error(iFehlerNummer) _
                    , sDateiname) _
                    , vbExclamation, sTITEL_ERZEUGEN
            End If
        Else 'Datei konnte nicht angelegt werden
            If UCase(Application.Name) = sTASKNAME_EXCEL _
            And Not gsPrintSwitch = sPRINTSWITCH_EXCEL_ARBEITSMAPPE Then
                MsgBox fsText(sMSG_EXCELTABELLEDATEINAMEUNZULAESSIG _
                    , Error(iFehlerNummer) _
                    , sDateiname) _
                    , vbExclamation, sTITEL_ERZEUGEN
            Else
                MsgBox fsText(sMSG_STANDARDDATEINAMEUNZULAESSIG _
                    , Error(iFehlerNummer) _
                    , sDateiname) _
                    , vbExclamation, sTITEL_ERZEUGEN
            End If
        End If
    End If

End Function

Function fbInfo_anzeigen(sFullName As String) As Boolean
    'Die Prozedur zeigt eine Box mit Informationen ber das Add-In an.
    'Effekt
    '   Die Info-Box wurde angezeigt.
    'Argumente:
    '   sFullName = Pfad und Name des Add-In
    'Global:
    '   sADDIN_NAME wird gelesen.
    '   sADDIN_VERSION wird gelesen.
    'Rckgabewert:
    '   True = Die Infomation wurde angezeigt.
    'Effekt
    '   Die Infomation wurde angezeigt.
        
    MsgBox fsText(sMSG_INFO _
        , sADDIN_NAME _
        , sADDIN_VERSION _
        , gsSprachSwitch _
        , fsSprachSwitch_konvertieren(gsSprachSwitch) _
        , fsDateiname_kuerzen(sFullName, 80) _
        , fsDateiname_kuerzen(gsInstVerzeichnis, 80) _
        , sVORLAGE_COPYRIGHT _
        , sVORLAGE_LIZENZ _
        , sVORLAGE_HTTPADRESSE) _
        , vbInformation, sTITEL_INFO
    fbInfo_anzeigen = True

End Function

Function fbKonfiguration_lesen(sTaskName As String) As Boolean
    'Die Funktion liest die Konfiguration aus der Registry und fllt die globalen Variablen g...
    'Fehlende Werte werden durch true oder False (bei Flags) oder sLEER (bei allen anderen) ersetzt.
    'Zuvor liest die Funktion jedoch die Sprache und ruft ggf. fbSprachtexteErzeugen auf, um die
    'Sprache neu zu setzen.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Global:
    '   sREGISTRY_APPNAME wird gelesen
    '   sREGISTRY_SECTION_GHOSTSCRIPT wird gelesen
    '   sREGISTRY_SECTION wird gelesen
    '   sREGISTRY_KEY_* wird gelesen
    '   Alle g... aus GLOB_Prozeduren werden gefllt
    'Rckgabewert:
    '   True = Die Konfiguration wurde gelesen.
    '   False = Es ist keine Konfiguration vorhanden - Es gibt keine Sprachtexte!!!
    'Effekt
    '   keiner

    Dim sRegistrySection As String
    Dim sDummy As String
    Dim iFehlerNummer As Integer
    Dim sFehlerText As String
    Dim sTmpSprachSwitch As String
    Static ssSprachSwitch As String
    
    fbKonfiguration_lesen = False
    
    sRegistrySection = sREGISTRY_SECTION
    
    'Zuerst die Sprache herausfinden und richtig setzen
    'Dazu ist auch das Installationsverzeichnis erforderlich
    If gsInstVerzeichnis = sLEER Then
        gsInstVerzeichnis = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
            sREGISTRY_KEY_INSTVERZEICHNIS, sLEER)
    End If
    If gsInstVerzeichnis = sLEER Then
        'Installation fehlt
        MsgBox fsText("Bitte installieren Sie Gs4Word." _
            & vbCr & vbCr & "Please install Gs4Word.") _
            , vbExclamation, sADDIN_NAME
        Exit Function
    End If
    
    On Error Resume Next
    sDummy = Dir(gsInstVerzeichnis, vbDirectory)
    iFehlerNummer = Err.Number
    sFehlerText = Err.Description
    On Error GoTo 0
    If iFehlerNummer <> 0 Then 'kein Zugriff auf Verzeichnis
        'Installation fehlt
        MsgBox fsText("Fehler (&1) (&2)" _
            & vbCr & vbCr & "Das Installationsverzeichnis '(&3)' ist nicht verfgbar." _
            & vbCr & vbCr & "No connection to installation directory '(&3)'." _
            , CStr(iFehlerNummer) _
            , sFehlerText _
            , gsInstVerzeichnis) _
            , vbExclamation, sADDIN_NAME
        Exit Function
    End If
    If sDummy = sLEER Then 'Verzeichnis nicht vorhanden
        'Installation fehlt
        MsgBox fsText("Das Installationsverzeichnis '(&1)' fehlt. Bitte installieren Sie Gs4Word." _
            & vbCr & vbCr & "Installation directory '(&1)' is missing. Please install Gs4Word." _
            , gsInstVerzeichnis) _
            , vbExclamation, sADDIN_NAME
        Exit Function
    End If
    
    sTmpSprachSwitch = GetSetting(sREGISTRY_APPNAME, sRegistrySection, sREGISTRY_KEY_SPRACHE, _
        sDEFAULT_SPRACHSWITCH)
    If sTmpSprachSwitch <> ssSprachSwitch Then
        ssSprachSwitch = sTmpSprachSwitch
        Call fbSprachtexteErzeugen(ssSprachSwitch, gsInstVerzeichnis)
    End If
    
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
    gbDebugFlag = fbFlag_pruefen(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_DEBUGFLAG, False), False)
    gbDateiumleitungsFlag = fbFlag_pruefen(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_DATEIUMLEITUNGSFLAG, False), False)
    giMaxRechnerWartezeit = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_MAXRECHNERWARTEZEIT, 0)
    gsDokuAufruf = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_DOKUAUFRUF, sLEER)
    gsGSParamKonfName = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_GSPARAMKONF, sLEER)
    gsGSProgrammName = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_GSPROGRAMM, sLEER)
    gsInstVerzeichnis = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_INSTVERZEICHNIS, sLEER)
    gsInstLogbuch = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_INSTLOGBUCH, sLEER)
    gsMailtoParameter = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_MAILTOPARAMETER, sLEER)
    gsMailtoProgrammName = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_MAILTOPROGRAMM, sLEER)
    gsPathSeparator = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_PATHSEPARATOR, sLEER)
    gsPDFProgrammName = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_PDFPROGRAMM, sLEER)
    gsPSDruckerName = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_PSDRUCKERNAME, sLEER)
    gsSprachSwitch = fsSprachSwitch_konvertieren(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_SPRACHE, sDEFAULT_SPRACHSWITCH))
    
    sRegistrySection = sREGISTRY_SECTION_GHOSTSCRIPT
    
    gvAusgabeMedienTabelle = GetAllSettings(sREGISTRY_APPNAME, sRegistrySection)
    
    sRegistrySection = sREGISTRY_SECTION & sSPACE & sTaskName
    
    gbButtonFlag = fbFlag_pruefen(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_BUTTONFLAG, bDEFAULT_BUTTONFLAG), bDEFAULT_BUTTONFLAG)
    gbDialogFlag = fbFlag_pruefen(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_DIALOGFLAG, bDEFAULT_DIALOGFLAG), bDEFAULT_DIALOGFLAG)
    gsMailToSwitch = fsMailToSwitch_konvertieren(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_MAILTOSWITCH, sDEFAULT_MAILTOSWITCH_NEIN))
    gsGSShellSwitch = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_GSSHELLSWITCH, sDEFAULT_GSSHELLSWITCH)
    gbPdfmarkFlag = fbFlag_pruefen(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_PDFMARKFLAG, bDEFAULT_PDFMARKFLAG), bDEFAULT_PDFMARKFLAG)
    gsPdfPageLayoutSwitch = fsPDFPageLayoutSwitch_konvertieren(GetSetting(sREGISTRY_APPNAME, _
        sRegistrySection, sREGISTRY_KEY_PDFPAGELAYOUTSWITCH, sDEFAULT_PDFPAGELAYOUTSWITCH))
    gsPdfPageModeSwitch = fsPDFPageModeSwitch_konvertieren(GetSetting(sREGISTRY_APPNAME, _
        sRegistrySection, sREGISTRY_KEY_PDFPAGEMODESWITCH, sDEFAULT_PDFPAGEMODESWITCH), sTaskName)
    gsPdfViewSwitch = fsPDFViewSwitch_konvertieren(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_PDFVIEWSWITCH, sDEFAULT_PDFVIEWSWITCH))
    gsPdfOutSwitch = fsPDFOutSwitch_konvertieren(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_PDFOUTSWITCH, sDEFAULT_PDFOUTSWITCH), sTaskName)
    gsPrintSwitch = fsPrintSwitch_konvertieren(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_PRINTSWITCH, sDEFAULT_PRINTSWITCH), sTaskName)
    gsTypeSwitch = fsTypeSwitch_konvertieren(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_TYPESWITCH, sDEFAULT_TYPESWITCH), sTaskName)
    gbRahmenFlag = fbFlag_pruefen(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_RAHMENFLAG, bDEFAULT_RAHMENFLAG), bDEFAULT_RAHMENFLAG)
    gbPDFBetrachterFlag = fbFlag_pruefen(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_PDFBETRACHTERFLAG, sDEFAULT_PDFBETRACHTERFLAG), sDEFAULT_PDFBETRACHTERFLAG)
    gbLogDateiLoeschenFlag = fbFlag_pruefen(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_LOGDATEILOESCHENFLAG, sDEFAULT_LOGDATEILOESCHENFLAG), _
        sDEFAULT_LOGDATEILOESCHENFLAG)
    gbPSDateiLoeschenFlag = fbFlag_pruefen(GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_PSDATEILOESCHENFLAG, sDEFAULT_PSDATEILOESCHENFLAG), _
        sDEFAULT_PSDATEILOESCHENFLAG)
    gsAusgabeMedium = fsAusgabeMedium_konvertieren(GetSetting(sREGISTRY_APPNAME, _
        sRegistrySection, sREGISTRY_KEY_AUSGABEMEDIUM, sDEFAULT_AUSGABEMEDIUM))
    gsSymbDateiName = GetSetting(sREGISTRY_APPNAME, sRegistrySection, _
        sREGISTRY_KEY_SYMBDATEINAME, sDEFAULT_SYMBDATEINAME)
    
    fbKonfiguration_lesen = True
   
End Function

Function fbKonfiguration_loeschen(sTaskName As String) As Boolean
    'Die Funktion lscht die Konfiguration von sTaskName aus der Registry.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Global:
    '   sREGISTRY_APPNAME wird gelesen
    '   sREGISTRY_SECTION_GHOSTSCRIPT wird gelesen
    '   sREGISTRY_SECTION wird gelesen
    '   Alle g... aus GLOB_Prozeduren werden gefllt
    'Rckgabewert:
    '   True = Die  Konfiguration wurde gelscht.
    'Effekt
    '   Die Registry wurde verndert.
    
    Dim sRegistrySection As String
    
    On Error Resume Next 'falls dazu kein Key in der Registry eingetragen ist
    sRegistrySection = sREGISTRY_SECTION
    DeleteSetting sREGISTRY_APPNAME, sRegistrySection
    sRegistrySection = sREGISTRY_SECTION_GHOSTSCRIPT
    DeleteSetting sREGISTRY_APPNAME, sRegistrySection
    sRegistrySection = sREGISTRY_SECTION & sSPACE & sTaskName
    DeleteSetting sREGISTRY_APPNAME, sRegistrySection
    On Error GoTo 0
    fbKonfiguration_loeschen = True
    
End Function

Function fbKonfiguration_schreiben(sTaskName As String) As Boolean
    'Die Funktion schreibt die Konfiguration aus den globalen Variablen g... in die
    'Registry.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Global:
    '   sREGISTRY_APPNAME wird gelesen
    '   sREGISTRY_SECTION_GHOSTSCRIPT wird gelesen
    '   sREGISTRY_SECTION wird gelesen
    '   g... aus GLOB_Prozeduren werden gelesen
    '   gs...Liste() wird immer gefllt
    'Rckgabewert:
    '   True = Die Konfiguration wurde in die Registry geschrieben.
    'Effekt
    '   Die Registry wurde verndert.
    
    Dim sRegistrySection As String
    Dim iZaehler As Integer
    
    sRegistrySection = sREGISTRY_SECTION
    
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_DEBUGFLAG, setting:=gbDebugFlag
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_DATEIUMLEITUNGSFLAG, setting:=gbDateiumleitungsFlag
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_MAXRECHNERWARTEZEIT, setting:=giMaxRechnerWartezeit
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_DOKUAUFRUF, setting:=gsDokuAufruf
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_GSPARAMKONF, setting:=gsGSParamKonfName
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_GSPROGRAMM, setting:=gsGSProgrammName
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_INSTVERZEICHNIS, setting:=gsInstVerzeichnis
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_INSTLOGBUCH, setting:=gsInstLogbuch
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_MAILTOPARAMETER, setting:=gsMailtoParameter
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_MAILTOPROGRAMM, setting:=gsMailtoProgrammName
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PATHSEPARATOR, setting:=gsPathSeparator
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PDFPROGRAMM, setting:=gsPDFProgrammName
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PSDRUCKERNAME, setting:=gsPSDruckerName
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_SPRACHE, setting:=fsSprachSwitch_konvertieren(gsSprachSwitch)
    
    sRegistrySection = sREGISTRY_SECTION_GHOSTSCRIPT

    If Not VarType(gvAusgabeMedienTabelle) = vbEmpty Then
        For iZaehler = LBound(gvAusgabeMedienTabelle, 1) To UBound(gvAusgabeMedienTabelle, 1)
            If gvAusgabeMedienTabelle(iZaehler, 0) <> sLEER _
            And gvAusgabeMedienTabelle(iZaehler, 1) <> sLEER Then
                SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
                    Key:=gvAusgabeMedienTabelle(iZaehler, 0), _
                    setting:=gvAusgabeMedienTabelle(iZaehler, 1)
            End If
        Next iZaehler
    End If
    
    sRegistrySection = sREGISTRY_SECTION & sSPACE & sTaskName
    
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_BUTTONFLAG, setting:=gbButtonFlag
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_DIALOGFLAG, setting:=gbDialogFlag
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_MAILTOSWITCH, setting:=fsMailToSwitch_konvertieren(gsMailToSwitch)
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_GSSHELLSWITCH, setting:=gsGSShellSwitch
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PDFMARKFLAG, setting:=gbPdfmarkFlag
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PDFPAGELAYOUTSWITCH, _
        setting:=fsPDFPageLayoutSwitch_konvertieren(gsPdfPageLayoutSwitch)
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PDFPAGEMODESWITCH, _
        setting:=fsPDFPageModeSwitch_konvertieren(gsPdfPageModeSwitch, sTaskName)
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PDFVIEWSWITCH, setting:=fsPDFViewSwitch_konvertieren(gsPdfViewSwitch)
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PDFOUTSWITCH, setting:=fsPDFOutSwitch_konvertieren(gsPdfOutSwitch, sTaskName)
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PRINTSWITCH, setting:=fsPrintSwitch_konvertieren(gsPrintSwitch, sTaskName)
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_TYPESWITCH, setting:=fsTypeSwitch_konvertieren(gsTypeSwitch, sTaskName)
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_RAHMENFLAG, setting:=gbRahmenFlag
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PDFBETRACHTERFLAG, setting:=gbPDFBetrachterFlag
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_AUSGABEMEDIUM, setting:=fsAusgabeMedium_konvertieren(gsAusgabeMedium)
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_LOGDATEILOESCHENFLAG, setting:=gbLogDateiLoeschenFlag
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_PSDATEILOESCHENFLAG, setting:=gbPSDateiLoeschenFlag
    SaveSetting appname:=sREGISTRY_APPNAME, Section:=sRegistrySection, _
        Key:=sREGISTRY_KEY_SYMBDATEINAME, setting:=gsSymbDateiName
        
    fbKonfiguration_schreiben = True
    
End Function

Function fbKonfiguration_testen(sTaskName As String) As Boolean
    'Die Funktion testet, ob die Konfiguration in den globalen Variablen g...vollstndig ist und in
    'die Registry geschrieben werden knnte.
    'Wenn sTaskName leer ist, werden nur die Technik-Parameter geprft. Dies kommt nur bei der
    'Installation vor.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Global:
    '   g... aus GLOB_Prozeduren werden gelesen
    'Rckgabewert:
    '   False = Die Konfiguration ist fehlerhaft.
    '   True = Die  Konfiguration ist OK.
    'Effekt
    '   keiner

    If gsPSDruckerName = sLEER _
    Or gsGSParamKonfName = sLEER _
    Or gsGSProgrammName = sLEER _
    Or gsGSShellSwitch = sLEER _
    Or gsInstVerzeichnis = sLEER _
    Or gsInstLogbuch = sLEER _
    Or gsPDFProgrammName = sLEER _
    Or giMaxRechnerWartezeit = 0 _
    Or gsPathSeparator = sLEER _
    Or gsSprachSwitch = sLEER _
    Or VarType(gvAusgabeMedienTabelle) = vbEmpty _
    Then 'unvollstndig
        fbKonfiguration_testen = False
        Exit Function
    End If
    
    If sTaskName = sLEER Then
        'Nur Technik-Parameter prfen
        fbKonfiguration_testen = True
    Else ' Konfiguratrion ist OK
        If fsAusgabeMedium_konvertieren(gsAusgabeMedium) = sLEER _
        Or (gbButtonFlag <> True And gbButtonFlag <> False) _
        Or gsSymbDateiName = sLEER _
        Or (gbPdfmarkFlag <> True And gbPdfmarkFlag <> False) _
        Or fsPDFPageLayoutSwitch_konvertieren(gsPdfPageLayoutSwitch) = sLEER _
        Or fsPDFPageModeSwitch_konvertieren(gsPdfPageModeSwitch, sTaskName) = sLEER _
        Or fsPDFViewSwitch_konvertieren(gsPdfViewSwitch) = sLEER _
        Or fsPDFOutSwitch_konvertieren(gsPdfOutSwitch, sTaskName) = sLEER _
        Or fsPrintSwitch_konvertieren(gsPrintSwitch, sTaskName) = sLEER _
        Or fsSprachSwitch_konvertieren(gsSprachSwitch) = sLEER _
        Or fsTypeSwitch_konvertieren(gsTypeSwitch, sTaskName) = sLEER _
        Or (gbRahmenFlag <> True And gbRahmenFlag <> False) _
        Or gsAusgabeMedium = sLEER _
        Or (gbDialogFlag <> True And gbDialogFlag <> False) _
        Or fsMailToSwitch_konvertieren(gsMailToSwitch) = sLEER _
        Or (gbLogDateiLoeschenFlag <> True And gbLogDateiLoeschenFlag <> False) _
        Or (gbPSDateiLoeschenFlag <> True And gbPSDateiLoeschenFlag <> False) _
        Or (gbDebugFlag <> True And gbDebugFlag <> False) _
        Or (gbDateiumleitungsFlag <> True And gbDateiumleitungsFlag <> False) _
        Or (gbPDFBetrachterFlag <> True And gbPDFBetrachterFlag <> False) _
        Then 'unvollstndig
            fbKonfiguration_testen = False
        Else ' Konfiguratrion ist OK
            fbKonfiguration_testen = True
        End If
    End If
    
End Function

Function fbKonfiguration_protokollieren(sTaskName As String, bKonfigFlag As Boolean) As Boolean
    'Die Funktion ergnzt das Installationslogbuch im Installationsverzeichnis um die Eintrge
    'fr Gs4Word in der Registry
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    '   bKonfigFlag
    '       True = Aufruf aus der konfiguration; auch Globale Parameter ausgeben
    '       False = Aufruf aus PDF > Erzeugen; keine Globalen Parameter ausgeben
    'Global:
    '   gsInstLogbuch wird gelesen
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim sVBAPfad As String
    Dim sWertPfad As String
    Dim iDateinummer As Integer
    Dim iZaehler As Integer
    
    sVBAPfad = sREGISTRY_VBANAME & "\" & sREGISTRY_APPNAME
    
    iDateinummer = FreeFile
    Open gsInstLogbuch For Append Access Write Lock Read Write As #iDateinummer
    
    Print #iDateinummer, String(120, "-")
    If bKonfigFlag = True Then
        Print #iDateinummer, Format(Date, "Long Date") & sSPACE & Format(Time, "Long Time") _
            & sSPACE & sTITEL_KONFIGURATION & sSPACE & sTaskName
    Else
        Print #iDateinummer, Format(Date, "Long Date") & sSPACE & Format(Time, "Long Time") _
            & sSPACE & sTITEL_ERZEUGEN & sSPACE & sTaskName
    End If
    Print #iDateinummer, ""
    Print #iDateinummer, sTXT_REGISTRY
    
    If bKonfigFlag = True Then
        sWertPfad = sVBAPfad & "\" & sREGISTRY_SECTION
        Print #iDateinummer, "    " & sTXT_SCHLUESSEL; sWertPfad
        Print #iDateinummer, "        " & sREGISTRY_KEY_DEBUGFLAG & " = " & gbDebugFlag
        Print #iDateinummer, "        " & sREGISTRY_KEY_DATEIUMLEITUNGSFLAG & " = " & gbDateiumleitungsFlag
        Print #iDateinummer, "        " & sREGISTRY_KEY_MAXRECHNERWARTEZEIT & " = " & giMaxRechnerWartezeit
        Print #iDateinummer, "        " & sREGISTRY_KEY_DOKUAUFRUF & " = " & gsDokuAufruf
        Print #iDateinummer, "        " & sREGISTRY_KEY_GSPARAMKONF & " = " & gsGSParamKonfName
        Print #iDateinummer, "        " & sREGISTRY_KEY_GSPROGRAMM & " = " & gsGSProgrammName
        Print #iDateinummer, "        " & sREGISTRY_KEY_INSTVERZEICHNIS & " = " & gsInstVerzeichnis
        Print #iDateinummer, "        " & sREGISTRY_KEY_INSTLOGBUCH & " = " & gsInstLogbuch
        Print #iDateinummer, "        " & sREGISTRY_KEY_MAILTOPARAMETER & " = " & gsMailtoParameter
        Print #iDateinummer, "        " & sREGISTRY_KEY_MAILTOPROGRAMM & " = " & gsMailtoProgrammName
        Print #iDateinummer, "        " & sREGISTRY_KEY_PATHSEPARATOR & " = " & gsPathSeparator
        Print #iDateinummer, "        " & sREGISTRY_KEY_PDFPROGRAMM & " = " & gsPDFProgrammName
        Print #iDateinummer, "        " & sREGISTRY_KEY_PSDRUCKERNAME & " = " & gsPSDruckerName
        Print #iDateinummer, "        " & "(Port" & " = " & fsDruckerPort_ermitteln(gsPSDruckerName) & ")"
        Print #iDateinummer, "        " & sREGISTRY_KEY_SPRACHE & " = " & fsSprachSwitch_konvertieren(gsSprachSwitch)
        
        sWertPfad = sVBAPfad & "\" & sREGISTRY_SECTION_GHOSTSCRIPT
        Print #iDateinummer, "    " & sTXT_SCHLUESSEL; sWertPfad
        If Not VarType(gvAusgabeMedienTabelle) = vbEmpty Then
            For iZaehler = LBound(gvAusgabeMedienTabelle, 1) To UBound(gvAusgabeMedienTabelle, 1)
                If gvAusgabeMedienTabelle(iZaehler, 0) <> sLEER _
                And gvAusgabeMedienTabelle(iZaehler, 1) <> sLEER Then
                    Print #iDateinummer, "        " & gvAusgabeMedienTabelle(iZaehler, 0) _
                        & " = " & gvAusgabeMedienTabelle(iZaehler, 1)
                End If
            Next iZaehler
        End If
    End If
    
    sWertPfad = sVBAPfad & "\" & sREGISTRY_SECTION & sSPACE & sTaskName
    Print #iDateinummer, "    " & sTXT_SCHLUESSEL; sWertPfad
    Print #iDateinummer, "        " & sREGISTRY_KEY_BUTTONFLAG & " = " & gbButtonFlag
    Print #iDateinummer, "        " & sREGISTRY_KEY_DIALOGFLAG & " = " & gbDialogFlag
    Print #iDateinummer, "        " & sREGISTRY_KEY_MAILTOSWITCH & " = " & fsMailToSwitch_konvertieren(gsMailToSwitch)
    Print #iDateinummer, "        " & sREGISTRY_KEY_GSSHELLSWITCH & " = " & gsGSShellSwitch
    Print #iDateinummer, "        " & sREGISTRY_KEY_PDFMARKFLAG & " = " & gbPdfmarkFlag
    Print #iDateinummer, "        " & sREGISTRY_KEY_PDFPAGELAYOUTSWITCH & " = " & fsPDFPageLayoutSwitch_konvertieren(gsPdfPageLayoutSwitch)
    Print #iDateinummer, "        " & sREGISTRY_KEY_PDFPAGEMODESWITCH & " = " & fsPDFPageModeSwitch_konvertieren(gsPdfPageModeSwitch, sTaskName)
    Print #iDateinummer, "        " & sREGISTRY_KEY_PDFVIEWSWITCH & " = " & fsPDFViewSwitch_konvertieren(gsPdfViewSwitch)
    Print #iDateinummer, "        " & sREGISTRY_KEY_PDFOUTSWITCH & " = " & fsPDFOutSwitch_konvertieren(gsPdfOutSwitch, sTaskName)
    Print #iDateinummer, "        " & sREGISTRY_KEY_PRINTSWITCH & " = " & fsPrintSwitch_konvertieren(gsPrintSwitch, sTaskName)
    Print #iDateinummer, "        " & sREGISTRY_KEY_TYPESWITCH & " = " & fsTypeSwitch_konvertieren(gsTypeSwitch, sTaskName)
    Print #iDateinummer, "        " & sREGISTRY_KEY_RAHMENFLAG & " = " & gbRahmenFlag
    Print #iDateinummer, "        " & sREGISTRY_KEY_PDFBETRACHTERFLAG & " = " & gbPDFBetrachterFlag
    Print #iDateinummer, "        " & sREGISTRY_KEY_AUSGABEMEDIUM & " = " & fsAusgabeMedium_konvertieren(gsAusgabeMedium)
    Print #iDateinummer, "        " & sREGISTRY_KEY_LOGDATEILOESCHENFLAG & " = " & gbLogDateiLoeschenFlag
    Print #iDateinummer, "        " & sREGISTRY_KEY_PSDATEILOESCHENFLAG & " = " & gbPSDateiLoeschenFlag
    Print #iDateinummer, "        " & sREGISTRY_KEY_SYMBDATEINAME & " = " & gsSymbDateiName
    
    Close #iDateinummer
    
    fbKonfiguration_protokollieren = True

End Function

Function fbHinweisProtokollieren(sHinweisText As String) As Boolean
    'Die Funktion ergnzt das Installationslogbuch im Installationsverzeichnis um einen Hinweis
    'Argumente:
    '   sHinweisText
    '       Text, der in das Installationslogbuch geschrieben wird
    'Global:
    '   gsInstLogbuch wird gelesen
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim iDateinummer As Integer
        
    If gsInstLogbuch = sLEER Then
        fbHinweisProtokollieren = False
    Else
        iDateinummer = FreeFile
        Open gsInstLogbuch For Append Access Write Lock Read Write As #iDateinummer
        
        Print #iDateinummer, String(120, "-")
        Print #iDateinummer, Format(Date, "Long Date") & sSPACE & Format(Time, "Long Time") _
                & sSPACE & UCase(Application.Name) & sSPACE & sHinweisText
        
        Close #iDateinummer
        fbHinweisProtokollieren = True
    End If
    

End Function

Function flLetztesVorkommen_suchen(sSuchtext As String, sText As String) As Long
    'Die Funktion sucht das letze Vorkommen eines Substrings in einem String.
    'Argumente:
    '   sSuchtext = zu durchsuchender String
    '   sText = gesuchter String
    'Rckgabewert:
    '   0 = sText wurde nicht in sSuchtext gefunden.
    '   >0 = Postion an dem der gesuchte String beginnt (wie bei InStr).
    'Effekt
    '   keiner
    
    Dim lPosition As Long 'Position des gesuchten Textes sText im durchsuchten String sSuchtext
    
    flLetztesVorkommen_suchen = 0
    'Unter Office 97 wird bei sText=sLEER die Lnge des Suchstring sSuchtext zurckgegeben
    'Unter Office 2000 fhrt sText=sLEER zu einer Endlosschleife
    'Deshalb 0 zurckgeben
    If sSuchtext = sLEER Or sText = sLEER Then
        Exit Function
    End If
    
    lPosition = InStr(1, sSuchtext, sText) 'Erstes Vorkommen von sText suchen
    Do While lPosition 'Solange suchen bis lPosition = 0 ist; dh. sText nicht mehr gefunden wurde
      flLetztesVorkommen_suchen = lPosition
      lPosition = InStr(flLetztesVorkommen_suchen + 1, sSuchtext, sText)
    Loop
    
End Function

Function fsText(sText As String, Optional sPar1 As String = "", Optional sPar2 As String = sLEER, _
Optional sPar3 As String = sLEER, Optional sPar4 As String = sLEER, _
Optional sPar5 As String = sLEER, Optional sPar6 As String = sLEER, _
Optional sPar7 As String = sLEER, Optional sPar8 As String = sLEER, _
Optional sPar9 As String = sLEER)

    'Die Funktion wandelt einen Text um
    '(&n) wird durch vbCr ersetzt
    '(&t) wird durch vbTab ersetzt
    '(&1) bis (&9) wird durch die Werte in sPar1 bis sPar9 ersetzt.
    '(&1=Beschreibung) bis (&9=Beschreibung) wird ebenfalls durch die Werte in sPar1 bis sPar9
    '   ersetzt. Die beschreibung wird ignoriert.
    
    Const sESCAPE As String = "(&"
    
    Dim sArbText As String
    Dim lPos As Long
    Dim lBisPos As Long
    Dim lNummer As Long
    Dim sZeichen As String
    Dim sPar(9) As String
    
    sArbText = sText
    sPar(1) = sPar1
    sPar(2) = sPar2
    sPar(3) = sPar3
    sPar(4) = sPar4
    sPar(5) = sPar5
    sPar(6) = sPar6
    sPar(7) = sPar7
    sPar(8) = sPar8
    sPar(9) = sPar9
    
    lPos = InStr(1, sArbText, sESCAPE)  'Erstes Vorkommen von (& suchen
    Do While lPos > 0 'Solange suchen bis lPos = 0 ist; dh. das Steuerzeichen nicht mehr gefunden wurde
        sZeichen = Mid(sArbText, lPos + 2, 2)
        Select Case sZeichen
            Case "1)", "2)", "3)", "4)", "5)", "6)", "7)", "8)", "9)"
                sPar(0) = sPar(CInt(Left(sZeichen, 1)))
                sArbText = Left(sArbText, lPos - 1) & sPar(0) & Mid(sArbText, lPos + 4)
                lPos = lPos + Len(sPar(0))
            Case "1=", "2=", "3=", "4=", "5=", "6=", "7=", "8=", "9="
                sPar(0) = sPar(CInt(Left(sZeichen, 1)))
                lBisPos = InStr(lPos + 4, sArbText, ")")
                If lBisPos > 0 Then
                    sArbText = Left(sArbText, lPos - 1) & sPar(0) & Mid(sArbText, lBisPos + 1)
                    lPos = lPos + Len(sPar(0))
                Else
                    lPos = Len(sArbText)
                End If
            Case "n)"
                sArbText = Left(sArbText, lPos - 1) & vbCr & Mid(sArbText, lPos + 4)
                lPos = lPos + 1
            Case "t)"
                sArbText = Left(sArbText, lPos - 1) & vbTab & Mid(sArbText, lPos + 4)
                lPos = lPos + 1
        End Select
        lPos = InStr(lPos, sArbText, sESCAPE)
    Loop
    fsText = sArbText
    
End Function

Function fsTraceZeileAusgeben(sTraceZeile As String) As Boolean
    'Die Funktion verwaltet die Trace-Dateien im Installationsverzeichnis. Je Prozess wrd eine
    'Tracedatei geffnen.
    'Die Funktion ergnzt die aktuelle Tracedatei um sTraceZeile
    'In der Funktion darf keine andere Funktion aufgerufen werden!
    'Global:
    '   gsInstVerzeichnis wird gelesen
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   ggf. Trace-Datei um einen Zeile ergnzt
    '   gf. neue Tracedatei erzeugt
    
    Const lGROESSENZUWACHS As Long = 10485760 '10*1024*1024 = 10 MB
    'Const lGROESSENZUWACHS As Long = 5242880 '5*1024*1024 = 5 MB
    
    Static iTraceDateiNummer As Integer
    Static sDateiname As String
    Static lDateigroesse As Long
    
    If gsInstVerzeichnis <> sLEER Then
        If sDateiname = sLEER Then
            sDateiname = gsInstVerzeichnis & "Protokoll" & Format(Now, "_yyyymmDd_hhnnss") & sTXT
            Dim iFehlerNummer As Integer
            iTraceDateiNummer = FreeFile
            On Error Resume Next
            Open sDateiname For Append Access Write Lock Read Write As #iTraceDateiNummer
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                'Datei war vorhanden; versuchen wir es beim nchsten Aufruf der Funktion noch mal
                iTraceDateiNummer = 0
                sDateiname = sLEER
                Exit Function
            End If
            Print #iTraceDateiNummer, UCase(Application.Name) & sSPACE & sDateiname
        End If
        Print #iTraceDateiNummer, sTraceZeile
        fsTraceZeileAusgeben = True
        If LOF(iTraceDateiNummer) > lDateigroesse + lGROESSENZUWACHS _
        And sMSG_TRACEGROESSE <> sLEER Then
            lDateigroesse = LOF(iTraceDateiNummer)
            MsgBox sMSG_TRACEGROESSE & vbCr & sDateiname & sSPACE & " = " _
                & Int(lDateigroesse / 1048576) & " MB", vbInformation, sTITEL_DEBUGMODUS
        End If
    End If
End Function

'===================================================================================================
'Alle Privaten Funktionen, die nur in GLOB_Prozeduren verwendet werden.
'===================================================================================================

Function fbFlag_pruefen(sEingabewert As String, bDefault As Boolean) As Boolean
    'Die Funktion prft der Eingabenwert und gibt True oder False zurck.
    'Wenn der Eingabewert True oder False ist, gibt die Funktion ihn unterndert zurck.
    'Anderenfalls gibt die Funktion den Wert aus sDefault zurck. Dieser kann True oder False sein.
    'Argumente:
    '   sEingabewert = Zahl oder String
    '   bDefault = Defaultwert True oder False
    'Rckgabewert:
    '   True oder False
    'Effekt
    '   keiner
   
    fbFlag_pruefen = bDefault
    On Error Resume Next
    If sEingabewert = True Then
        fbFlag_pruefen = True
    End If
    If sEingabewert = False Then
        fbFlag_pruefen = False
    End If
    On Error GoTo 0
    
End Function

'===================================================================================================
'Ende.
'===================================================================================================





