Attribute VB_Name = "INST_Schnittstellen"
'KEIN Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   MACH_Schnittstellen
'   Das Modul ist die Schnittstelle zum installieren und deinstallieren von Gs4Word
' Effekt:
'   Siehe Modul INST_Prozeduren
' Restriktionen:
'   Siehe Modul INST_Prozeduren
' Entwicklung und Test:
'   Siehe Modul INST_Prozeduren
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   12.12.2002  Erweitet fr Version 2.62
'   04.04.2005  Erweitert um AutoNew

Sub AutoNew()
    'Unter Office 2000 mit ViaVoice kann es vorkommen, dass die Buttonleiste Dv4Word nicht angezeigt wird.
    CommandBars("Gs4Word").Visible = True
    
    CustomizationContext = ActiveDocument
    FindKey(BuildKeyCode(wdKeyF2)).Disable
    KeyBindings.Add KeyCode:=BuildKeyCode(wdKeyF2) _
        , KeyCategory:=wdKeyCategoryMacro _
        , Command:="AutoNew"

    ActiveDocument.Saved = True
End Sub


'===================================================================================================
'Alle Aufrufe von INST aus anderen Projekten
'===================================================================================================

Sub AutoInstallation()
    'Die Funktion installiert Gs4Word automatisch
    'Sie wird vom Add-In AutoSetup.dot aufgerufen
    
    On Error GoTo Fehler_aufgetreten:
    
    If fbInstallationPruefen = True Then
        If LCase(Left(System.LanguageDesignation, 7)) = "deutsch" Then
            Call fbSprachtexteErzeugen(sSPRACHCODE_DEUTSCH, ThisDocument.Path & Application.PathSeparator)
            gsSprachSwitch = fsSprachSwitch_konvertieren(sSPRACHCODE_DEUTSCH)
        Else
            Call fbSprachtexteErzeugen(sSPRACHCODE_ENGLISCH, ThisDocument.Path & Application.PathSeparator)
            gsSprachSwitch = fsSprachSwitch_konvertieren(sSPRACHCODE_ENGLISCH)
        End If
        gbAutomatischeInstallation = True
        Call fbInstallation_durchfhren
        'Wenn die automatische Installation fehlerfrei verluft, wird Word schon in
        'INST_UF_Installation beendet!
    End If
    
    Application.Quit SaveChanges:=wdDoNotSaveChanges
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , ThisDocument.Name _
        , "AutoInstallation" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER
        
End Sub

Sub AutoDeinstallation()
    'Die Funktion deinstalliert Gs4Word automatisch
    'Sie wird vom Add-In ? aufgerufen
    
    On Error GoTo Fehler_aufgetreten:
    
    If fbInstallationPruefen = True Then
        If LCase(Left(System.LanguageDesignation, 7)) = "deutsch" Then
            Call fbSprachtexteErzeugen(sSPRACHCODE_DEUTSCH, ThisDocument.Path & Application.PathSeparator)
            gsSprachSwitch = fsSprachSwitch_konvertieren(sSPRACHCODE_DEUTSCH)
        Else
            Call fbSprachtexteErzeugen(sSPRACHCODE_ENGLISCH, ThisDocument.Path & Application.PathSeparator)
            gsSprachSwitch = fsSprachSwitch_konvertieren(sSPRACHCODE_ENGLISCH)
        End If
        gbAutomatischeInstallation = True
        Call fbDeinstallation_durchfhren
        'Wenn die automatische Deinstallation fehlerfrei verluft, wird Word schon in
        'INST_UF_Deinstallation beendet!
    End If
    
    Application.Quit SaveChanges:=wdDoNotSaveChanges
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , ThisDocument.Name _
        , "AutoDeinstallation" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER
        
End Sub

Sub DialogInstallation()
    'Die Funktion installiert Gs4Word im Dialog
    'Sie wird vom Add-In Setup.dot aufgerufen
    
    On Error GoTo Fehler_aufgetreten:
    
    If fbInstallationPruefen = True Then
        gsSprachSwitch = sLEER
        INST_UF_Sprache.Show
        
        If gsSprachSwitch <> sLEER Then
            Call fbSprachtexteErzeugen(gsSprachSwitch, ThisDocument.Path & Application.PathSeparator)
            gsSprachSwitch = fsSprachSwitch_konvertieren(gsSprachSwitch)
            gbAutomatischeInstallation = False
            Call fbInstallation_durchfhren
        End If
    End If
        
    Application.Quit SaveChanges:=wdDoNotSaveChanges
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , ThisDocument.Name _
        , "Installation" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER
        
End Sub

Sub DialogDeinstallation()
    'Die Funktion deinstalliert Gs4Word im Dialog
    'Sie wird vom Add-In Uninstall.dot aufgerufen
    
    On Error GoTo Fehler_aufgetreten:
    
    If fbInstallationPruefen = True Then
        gsSprachSwitch = sLEER
        INST_UF_Sprache.Show
        
        If gsSprachSwitch <> sLEER Then
            Call fbSprachtexteErzeugen(gsSprachSwitch, ThisDocument.Path & Application.PathSeparator)
            gsSprachSwitch = fsSprachSwitch_konvertieren(gsSprachSwitch)
            gbAutomatischeInstallation = False
            Call fbDeinstallation_durchfhren
        End If
    End If
        
    Application.Quit SaveChanges:=wdDoNotSaveChanges
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox fsText(sMSG_LAUFZEITFEHLER _
        , Application.Name & sSPACE & Application.VBE.Version _
        , ThisDocument.Name _
        , "Deinstallation" _
        , Str(Err.Number) & sSPACE & Err.Description) _
        , vbExclamation, sTITEL_FEHLER
        
End Sub

'===================================================================================================
'Ende.
'===================================================================================================


