Attribute VB_Name = "KONF_Prozeduren"
Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt :
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   KONF_Prozeduren
' Effekt:
'   Das Modul konfiguriert Gs4Word
' Restriktionen:
'   Alle Module und UserForms GLOB_, KONF_ und TECH_ mssen vorhanden sein.
'   Dieses Add-In darf nicht schreibgeschtzt sein. Der Name ist beliebig.
'   Der genaue Name steht in der ThisDocument.Name.
' Entwicklung und Test:
'   siehe Dokumentation
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   10.10.2002  Erweitet fr Version 2.60
'   30.10.2002
'   05.10.2003  Erweitert um Protokollierung aller nderungen in der Konfiguration
'   20.10.2003  Erweitert um Installation eines Druckers und Installtion von Ghostscript

' Die Eintrge in der Registry sind in GLOB_AddIn beschrieben (siehe dort)

'===================================================================================================
'Deklarationen
'===================================================================================================
    
' Die folgenden Variablen werden fr den Konfigurationsdialog bentigt
'---------------------------------------------------------------------
Public gbVorlageIstAenderbar As Boolean
Public gsGsWerteTabelle() As String
    'Das erste Element der Tabelle muss 0 sein
    'Die WerteTabelle enthlt je Ausgabemedium und Parameter den aktuellen Wert aus der
    'gsGsParamTabelle und den echten Wert fr Ghostscript
    'Sie hat genauso viele Elemente n wie die Tabelle mit den Ausgabemedien gvAusgabeMedienTabelle
    'und genauso viele Elemente m wie die Parametertabelle gsGsParamTabelle
    'n,m,0  =   Der aktuelle Wert zum Ausgabemedium n in gvAusgabeMedienTabelle
    '           und zum Parameter m in der Parametertabelle gsGsParamTabelle
    'n,m,1  =   Dazugehrender echter Wert fr die Funktion fsParamErstellen und Ghostscript
    '           Z.B ist n,m,0 = [TEXT] und n,m,1 = p:\xxx;c:\fff

'===================================================================================================
'Konfiguration
'===================================================================================================

Function fbKonfiguration_aendern(sTaskName As String, bVorlageIstAenderbar As Boolean) As Boolean
    'Die Funktion zeigt die UserForm fr die Konfiguration an.
    'Die genderten Werte werden in den globalen Variablen gespeichert.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_AddIn entsprechen.
    '   bVorlageIstAenderbar Nur wenn das Flag gesetzt ist, wird auch gbButtonFlag und gsMailToSwitch
    '       mit den Defaultwerten belegt
    'Global:
    '   giDialogEffekt wird gesetzt
    '   g*-Variable werden ggf. gendert
    'Rckgabewert:
    '   False = Die nderung der Konfiguration wurde abgebrochen
    '   True = Die Konfiguration wurde gendert
    'Effekt
            
    ' (1) Vorlauf
    '------------
    Call fbKonfiguration_ausRegistryFuellen(sTaskName)
    
    Do While True
    
        ' (2) UserForm anzeigen
        '----------------------
        gsTaskName = sTaskName
        gbVorlageIstAenderbar = bVorlageIstAenderbar
        KONF_UserForm.Show
        
        ' (3) Nachlauf
        '-------------
        Select Case giDialogEffekt
        Case False ' Abbrechen
            'Konfiguration wieder herstellen
            Call fbKonfiguration_lesen(sTaskName)
            Exit Do
        Case True ' OK
            'Zuerst AusgabeMedienTabelle neu fllen
            Call fbAusgabeMedienTabelle_AusGSWerteTabelleFuellen
            'Dann die aktuelle Konfiguration lschen
            Call fbKonfiguration_loeschen(sTaskName)
            'Dann die Konfiguration neu in die Registry schreiben
            Call fbKonfiguration_schreiben(sTaskName)
            Call fbKonfiguration_protokollieren(sTaskName, True)
            Exit Do
        Case -2
            'Die Defaults verwenden
            Call fbKonfiguration_mitTechnikDefaultsBelegen
            Call fbKonfiguration_mitAnwendungsDefaultsBelegen(sTaskName, bVorlageIstAenderbar)
        Case Else
            MsgBox fsText(sMSG_CASEELSE _
                , "fbKonfiguration_aendern") _
                , vbExclamation, sTITEL_ERZEUGEN
            Error 51
            Exit Do
        End Select
    Loop
    
End Function
    
Function fbSprachtexteErzeugen(sSprache As String, sInstVerzeichnis As String) As Boolean

    Call fbGLOB_SprachtexteErzeugen(sSprache, sInstVerzeichnis)
    Call fbKONF_SprachtexteErzeugen(sSprache, sInstVerzeichnis)
    Call fbTECH_SprachtexteErzeugen(sSprache, sInstVerzeichnis)
    fbSprachtexteErzeugen = True

End Function

'===================================================================================================
'Alle Private Funktionen und Subroutinen, die nur in KONF_Prozeduren verwendet werden.
'===================================================================================================

Function fbKonfiguration_ausRegistryFuellen(sTaskName As String) As Boolean
    'Die Funktion belegt die nicht gefllten globalen g*-Variablen aus der Registry mit Werten
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Global:
    '   g*-Variable werden ggf. gendert
    '   gbKonfigurationGespeichert wird gesetzt
    'Rckgabewert:
    '   True = Die Konfiguration wurde ermittelt
    'Effekt
            
    Dim sPSDrucker As String
    Dim iZaehler As Integer
    Dim sPDFVerknpfterProgrammName As String
    
    gbKonfigurationGespeichert = True
  
    'Variable giMaxRechnerWartezeit belegen
    If giMaxRechnerWartezeit = 0 Then
        gbKonfigurationGespeichert = False
        giMaxRechnerWartezeit = fiMaxRechnerWartezeit_ermitteln
    End If
    'Variable gsPathSeparator vor der Nutzung bei gsMailtoProgrammName belegen!!!
    If gsPathSeparator = sLEER Then
        gbKonfigurationGespeichert = False
    End If
    gsPathSeparator = Application.PathSeparator 'PathSeparator IMMER neu ermitteln
    'Variable gsDokuAufruf belegen
    If gsDokuAufruf = sLEER Then 'Default ermitteln
        gbKonfigurationGespeichert = False
        gsDokuAufruf = fsDokuAufruf_ermitteln()
    End If
    'Drucker-Variablen belegen
    
    'Die Ermittlung von giPrnadminInstallationsstatus, giRedmonInstallationsstatus und gsNeuerPortName
    'ist nicht erforderlich, da fbDruckerListe_fuellen mit (False) aufgerufen wird.
    giPrnadminInstallationsstatus = 3 ' 3 = kann nicht registriert werden
    giRedmonInstallationsstatus = 4 ' 4 = kann nicht installiert werden
    gsNeuerPortName = sLEER
    gbAutomatischeInstallation = False
    
    If fbDruckerListe_fuellen(False) = True Then
        If gsPSDruckerName = sLEER Then   'Default ermitteln
            gsPSDruckerName = gsDruckerListe(0)
            gbKonfigurationGespeichert = False
        End If
    End If
    If fbDrucker_pruefen(gsPSDruckerName) = False Then
        gsPSDruckerName = sLEER
        gbKonfigurationGespeichert = False
    End If
    If gsPSDruckerName <> sLEER Then
        If fbDruckerUmleitbar_ermitteln(gsPSDruckerName) = True Then
            'Das gbDateiumleitungsFlag wird nicht verndert, wenn der Drucker umleitbar ist
            gbDateiumleitungsFlagIstAenderbar = True
        Else
            gbDateiumleitungsFlag = False
            gbDateiumleitungsFlagIstAenderbar = False
        End If
    Else
        gbKonfigurationGespeichert = False
    End If

    'Programm-Variablen belegen
    If gsInstVerzeichnis = sLEER Then 'Default ermitteln
        gbKonfigurationGespeichert = False
    End If
    
    Call fbGhostscriptListe_fuellen(False)
    If gsGSProgrammName = sLEER Then 'Default ermitteln
        gsGhostscriptName = gsDefaultGhostscriptTabelle(0, 0)
        gsGSProgrammName = gsDefaultGhostscriptTabelle(0, 1)
        gbKonfigurationGespeichert = False
    Else
        iZaehler = fiGhostscriptDefaultNr_ermitteln(gsGSProgrammName, 1)
        gsGhostscriptName = gsDefaultGhostscriptTabelle(iZaehler, 0)
    End If
    
    Call fbPDFBetrachterListe_fuellen(False)
    If gsPDFProgrammName = sLEER Then 'Default ermitteln
        gsPDFBetrachterName = gsDefaultPDFBetrachterTabelle(0, 0)
        gsPDFProgrammName = gsDefaultPDFBetrachterTabelle(0, 1)
        gbKonfigurationGespeichert = False
    Else
        iZaehler = fiPDFBetrachterDefaultNr_ermitteln(gsPDFProgrammName, 1)
        gsPDFBetrachterName = gsDefaultPDFBetrachterTabelle(iZaehler, 0)
    End If
    
    If gsMailtoProgrammName = sLEER Then 'Default ermitteln
        gsMailtoProgrammName = fsMailtoProgramm_ermitteln()
        gsMailtoParameter = fsMailtoParameter_ermitteln(gsMailtoProgrammName)
    End If
    If gsGSParamKonfName = sLEER Then 'Default ermitteln
        gbKonfigurationGespeichert = False
        gsGSParamKonfName = fsGSParamKonfigName_ermitteln()
    End If
    'AusgabeMedienTabelle fllen
    Call fbParamTabelleFuellen(gsGSParamKonfName)
    If VarType(gvAusgabeMedienTabelle) = vbEmpty Then
        Call fbAusgabeMedienTabelle_DefaultFuellen
        gbKonfigurationGespeichert = False
    End If

    fbKonfiguration_ausRegistryFuellen = True
    
End Function

Function fbDrucker_pruefen(sDruckername) As Boolean
    'Die Funktion prft, ob der Drucker in sDruckerName in der Druckertabelle gsDruckerTabelle
    'vorhanden ist.
    'Global:
    '   gsDruckerListe wird gelesen
    'Rckgabewert:
    '   True  = Der Drucker ist vorhanden.
    '   False = Der Drucker fehlt.
    'Effekt
    '   keiner
    
    Dim iZaehler As Integer
    
    fbDrucker_pruefen = False
    
    If sDruckername <> sLEER Then
        For iZaehler = LBound(gsDruckerListe) To UBound(gsDruckerListe)
            If sDruckername = gsDruckerListe(iZaehler) Then
                fbDrucker_pruefen = True
                Exit For
            End If
        Next iZaehler
    End If
        
End Function


Function fbGSWerteTabelle_fuellen() As Boolean
    'Die Funktion fllt die Tabelle gsGsWerteTabelle aus der Tabelle gvAusgabeMedienTabelle
    'Global:
    '   gsGsWerteTabelle wird gefllt
    '   gvAusgabeMedienTabelle wird gelesen
    '   gsGsParamTabelle wird gelesen
    
    Const sTRENNZEICHEN As String = " "
    Const sGLEICHHEITSZEICHEN As String = "="
    
    Dim iPosVon As Integer
    Dim iPosBis As Integer
    Dim iPosGleich As Integer
    Dim iAnzahlSpalten As Integer
    Dim iAusgabeMediumNr As Integer
    Dim sZeile As String
    Dim sToken As String
    Dim sParamName As String
    Dim sParamWert As String
    Dim bGefunden As Boolean
    Dim iParamNr As Integer
    Dim iSpalteNr As Integer
    Dim iWerteSpalteNr As Integer
    Dim sWert As String
    Dim bWertGefunden As Boolean
    Dim bNummerGefunden As Boolean
    Dim bTextGefunden As Boolean
    Dim bDefinedGefunden As Boolean

    If VarType(gvAusgabeMedienTabelle) = vbEmpty Then
        fbGSWerteTabelle_fuellen = False
        Exit Function
    End If
    
    ReDim gsGsWerteTabelle(UBound(gvAusgabeMedienTabelle, 1), UBound(gsGsParamTabelle, 1), 1)

    For iAusgabeMediumNr = LBound(gvAusgabeMedienTabelle, 1) To UBound(gvAusgabeMedienTabelle, 1)
        'Ein Ausgabemedium
        For iParamNr = LBound(gsGsWerteTabelle, 2) To UBound(gsGsWerteTabelle, 2)
            If gsGsParamTabelle(iParamNr, 1) <> sLEER Then
                gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 0) = sPARWERT_UNDEFINED
                gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 1) = sLEER
            End If
        Next iParamNr
            
        sZeile = Trim(gvAusgabeMedienTabelle(iAusgabeMediumNr, 1)) & sSPACE
        'Anzahl Spalten ermitteln
        iAnzahlSpalten = fiZaehleZeichen(sZeile, sTRENNZEICHEN)
        'Tabelle fllen
        iPosVon = 1
        For iSpalteNr = 1 To iAnzahlSpalten
            'Einen Wert
            sParamName = sLEER
            sParamWert = sLEER
            iPosBis = InStr(iPosVon, sZeile, sTRENNZEICHEN)
            sToken = Mid(sZeile, iPosVon, iPosBis - iPosVon)
            If Len(Trim(sToken)) > 0 Then
                'Einen Wert gefunden
                iPosVon = iPosBis + 1
                iPosGleich = InStr(sToken, sGLEICHHEITSZEICHEN)
                If iPosGleich > 0 Then
                    sParamName = Left(sToken, iPosGleich - 1)
                    sParamWert = Right(sToken, Len(sToken) - iPosGleich)
                ElseIf LCase(Left(sToken, Len(sPARPRAEFIX_D))) = sPARPRAEFIX_D _
                Or LCase(Left(sToken, Len(sPARPRAEFIX_S))) = sPARPRAEFIX_S Then
                    sParamName = sToken
                    sParamWert = sLEER
                Else
                    'Prfen, ob der Parameter in der Parametertabelle vorkommt
                    For iParamNr = LBound(gsGsParamTabelle, 1) To UBound(gsGsParamTabelle, 1)
                        sWert = gsGsParamTabelle(iParamNr, iPARNR_NAME)
                        If Len(sWert) > 0 _
                        And Left(sWert, 2) <> sPARPRAEFIX_D _
                        And Left(sWert, 2) <> sPARPRAEFIX_S _
                        And sWert = Left(sToken & Space(Len(sWert)), Len(sWert)) Then
                            sParamName = sWert
                            sParamWert = Trim(Mid(sToken & sSPACE, Len(sWert) + 1))
                            Exit For
                        End If
                    Next iParamNr
                End If

                If sParamName <> sLEER Then
                    'Prfen, ob der Parameter in der Parametertabelle vorkommt
                    For iParamNr = LBound(gsGsParamTabelle, 1) To UBound(gsGsParamTabelle, 1)
                        If LCase(sParamName) = LCase(gsGsParamTabelle(iParamNr, iPARNR_NAME)) Then
                            'Parameter gefunden
                            'Zuerst die mglichen Werte klassizizieren
                            bWertGefunden = False
                            bDefinedGefunden = False
                            bNummerGefunden = False
                            bTextGefunden = False
                            For iWerteSpalteNr = iPARNR_ERSTERWERT _
                            To Val(gsGsParamTabelle(iParamNr, iPARNR_ANZWERTE)) _
                            + iPARNR_ERSTERWERT - 1
                                sWert = gsGsParamTabelle(iParamNr, iWerteSpalteNr)
                                If sParamWert <> sLEER Then
                                    If LCase(sWert) = LCase(sParamWert) Then
                                        bWertGefunden = True
                                    ElseIf LCase(sWert) = LCase(sPARWERT_NUMBER) _
                                    And IsNumeric(sParamWert) Then
                                        bNummerGefunden = True
                                    ElseIf LCase(sWert) = LCase(sPARWERT_TEXT) Then
                                        bTextGefunden = True
                                    End If
                                Else
                                    If LCase(sWert) = LCase(sPARWERT_DEFINED) Then
                                        bDefinedGefunden = True
                                    End If
                                End If
                            Next iWerteSpalteNr
                            
                            'Dann gsGsWerteTabelle fllen
                            If bDefinedGefunden = True Then 'sParamWert = sLEER
                                gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 0) = sPARWERT_DEFINED
                                gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 1) = sPARWERT_DEFINED
                            ElseIf LCase(sParamWert) = LCase(sPARWERT_NUMBER) _
                            Or LCase(sParamWert) = LCase(sPARWERT_TEXT) _
                            Or LCase(sParamWert) = LCase(sPARWERT_DEFINED) _
                            Or LCase(sParamWert) = LCase(sPARWERT_UNDEFINED) Then
                                'Fehler - Der Wert darf keine Konstante sein
                                'Wird berlesen
                                sParamWert = sParamWert
                            ElseIf bWertGefunden = True Then 'sParamWert <> sLEER
                                gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 0) = sParamWert
                                gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 1) = sParamWert
                            ElseIf bNummerGefunden = True Then 'sParamWert <> sLEER
                                gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 0) = sPARWERT_NUMBER
                                gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 1) = sParamWert
                            ElseIf bTextGefunden = True Then 'sParamWert <> sLEER
                                gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 0) = sPARWERT_TEXT
                                gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 1) = sParamWert
                            End If
                            Exit For
                        End If
                    Next iParamNr
                Else
                    MsgBox fsText(sMSG_UNBEKANNTESTOKEN _
                        , CStr(gvAusgabeMedienTabelle(iAusgabeMediumNr, 0)) _
                        , sToken) _
                        , vbInformation, sTITEL_KONFIGURIEREN
                End If
            End If
        Next iSpalteNr
        
        'Kontrolle, ob jeder Wert in gsGsWerteTabelle auch ein Wert in gsGsParamTabelle ist
        For iParamNr = LBound(gsGsWerteTabelle, 2) To UBound(gsGsWerteTabelle, 2)
            If gsGsParamTabelle(iParamNr, 1) <> sLEER Then
                bWertGefunden = False
                For iWerteSpalteNr = iPARNR_ERSTERWERT _
                To Val(gsGsParamTabelle(iParamNr, iPARNR_ANZWERTE)) _
                + iPARNR_ERSTERWERT - 1
                    If gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 0) _
                    = gsGsParamTabelle(iParamNr, iWerteSpalteNr) Then
                        bWertGefunden = True
                        Exit For
                    End If
                Next iWerteSpalteNr
                If bWertGefunden = False Then
                    MsgBox fsText(sMSG_UNGUELTIGERGSWERT _
                        , CStr(gvAusgabeMedienTabelle(iAusgabeMediumNr, 0)) _
                        , gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 0) _
                        , gsGsParamTabelle(iParamNr, iPARNR_NAME)) _
                        , vbExclamation, sTITEL_KONFIGURIEREN
                    fbGSWerteTabelle_fuellen = False
                    Exit Function
                End If
            End If
        Next iParamNr
        
            
    Next iAusgabeMediumNr
    fbGSWerteTabelle_fuellen = True

End Function

Function fbAusgabeMedienTabelle_AusGSWerteTabelleFuellen() As Boolean
    'Die Funktion fllt die gvAusgabeMedienTabelle mit den Werten aus gsGSWerteTabelle
    'Das darf nur nach den Dialog KONF_UserForm geschehen, da nur dann die Tabellen
    'gsGsParamTabelle und gsGSWerteTabelle gefllt sind.
    'Global:
    '   gvAusgabeMedienTabelle wird verndert
    '   gsGsParamTabelle wird gelesen
    '   gsGSWerteTabelle wird gelesen
    'Effekt
    '   keiner
    
    Dim iAusgabeMediumNr As Integer
    Dim iParamNr As Integer
        
    For iAusgabeMediumNr = LBound(gvAusgabeMedienTabelle, 1) To UBound(gvAusgabeMedienTabelle, 1)
        gvAusgabeMedienTabelle(iAusgabeMediumNr, 1) = sLEER
        For iParamNr = LBound(gsGsParamTabelle, 1) To UBound(gsGsParamTabelle, 1)
            If gsGsParamTabelle(iParamNr, 1) <> sLEER Then
                gvAusgabeMedienTabelle(iAusgabeMediumNr, 1) _
                    = gvAusgabeMedienTabelle(iAusgabeMediumNr, 1) & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsWerteTabelle(iAusgabeMediumNr, iParamNr, 1))
            End If
        Next iParamNr
    Next iAusgabeMediumNr
    
    For iAusgabeMediumNr = LBound(gvAusgabeMedienTabelle, 1) To UBound(gvAusgabeMedienTabelle, 1)
        gvAusgabeMedienTabelle(iAusgabeMediumNr, 1) _
            = Trim(gvAusgabeMedienTabelle(iAusgabeMediumNr, 1))
    Next iAusgabeMediumNr

    fbAusgabeMedienTabelle_AusGSWerteTabelleFuellen = True
    
End Function

'===================================================================================================
'Alle ffentlichen Funktionen, die nur von KONF_UserForm verwendet werden
'===================================================================================================

Function fsSymbDateiName_konfigurieren(sAlterSymbDateiName As String) As String
    'Die Funktion zeigt in einem Dialog den aktuell eingestellten symbolischen Dateinamen an. Er
    'kann gendert werden. Sie gibt den genderten symbolischen Dateinamen zurck.
    'Die Funktion berprft den Namen auf syntaktische Fehler, ohne alle vollstndig zu finden.
    'Ob alle UNC-Namen "\\server\freigabe", Laufwerke und Verzeichnisses vorhanden sind, kann die
    'Funktion nicht berprfen.
    'Argumente:
    '   sAlterSymbDateiName = aktuell eingestellter symbolischer Datenname
    'Rckgabewert:
    '   xx..xx = neuer symbolischer Dateiname.
    'Effekt
    '   Der Dialog fr die Eingabe des symbolischen Dateinamens wurde gefhrt.
    
    fsSymbDateiName_konfigurieren = Trim(sAlterSymbDateiName)

    Do
        fsSymbDateiName_konfigurieren = _
            Trim(InputBox(fsText(sTEXT_IBSYMBDATEINAME), sTITEL_IBSYMBDATEINAME, _
            fsSymbDateiName_konfigurieren))
        
        If fsSymbDateiName_konfigurieren = sLEER Then ' Abgebrochen
            fsSymbDateiName_konfigurieren = Trim(sAlterSymbDateiName)
            Exit Function
        End If
        
    Loop While fsSymbDateiName_umsetzen(fsSymbDateiName_konfigurieren, "XXXXXX", sPDF) = sLEER
       
End Function

'===================================================================================================
'DUMMY-Prozeduren fr GLOB_Prozeduren
'===================================================================================================

Sub ERZEUGEN()
    'Dummy-Prozedur fr GLOB_Prozeduren

End Sub

Function fbVorlageAnpassen(bDummy As Boolean) As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageAnpassen = True
End Function

Function fbVorlageIstAenderbar() As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageIstAenderbar = True
End Function

'===================================================================================================
'Ende.
'===================================================================================================


