Attribute VB_Name = "TECH_Prozeduren"
Option Private Module
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt :
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   TECH_Prozeduren
' Effekt:
'   Das Modul konfiguriert Gs4Word
' Restriktionen:
'   Siehe Modul KONF_Prozeduren und INST_Prozeduren
' Entwicklung und Test:
'   Siehe Modul KONF_Prozeduren und INST_Prozeduren
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   10.10.2002  Erweitet fr Version 2.60
'   05.10.2003  Erweitert fr Ghostscript 8.11
'   05.10.2003  Erweitert fr Rahmen in Powerpoint
'   18.10.2003  Erweitert um Prnadmin.dll zur Installation von Anschluss NUL:
'               und Drucker "HP Color LaserJet 5/5M PS"
'   20.10.2003  Erweitert um Installation eines Druckers und Installation von Ghostscript
'   15.05.2004  Erweitert fr Ghostscript 8.13 und 8.14
'   15.05.2004  Erweitert fr Ghostview 4.6
'   25.05.2004  Fehler in fsGhostscriptProgramm_registrieren beseitigt wenn ohne Kommentare
'   02.04.2005  Erweitert fr Ghostscript 8.50 und 8.15 sowie Gsview 4.7 sowie AdobeReader 7.0
'   21.05.2005  Erweitert fr Ghostscript 8.51
'   19.02.2006  Erweitert fr Ghostscript 8.53
'   15.04.2006  Fehler beseitigt, wenn Laufwerk nicht vorhanden ist
'               In fsGhostscriptProgramm_entpacken Wartezeit beim Entpacken von Ghostscript verdoppelt
'   OFFEN ist, bb es weitere Stellen gibt, an denen das gendert werden muss
'       Wenn Dir auf ein Laufwerk stt, dass nicht vorhanden ist, dann gibt es einen Fehler
'       z.B. Netzlaufwerk, auf das nicht zugegriffen werden kann Fehler 52: Dateiname oder -nummer falsch
'       z.B. Nicht verfgbares Laufwerk Fehler 68: Gert nicht verfgbar

' Die Eintrge in der Registry sind in GLOB_Prozeduren beschrieben (siehe dort)

'===================================================================================================
'Deklarationen
'===================================================================================================

' Spezielle Konstante zur Konfiguration
'--------------------------------------
Public Const sHTML As String = ".html"
Public Const iMAXRECHNERWARTEZEITFAKTOR As Integer = 10
Public Const sGSINIDATEI_70x As String = "GsParam_70x.txt"
Public Const sGSINIDATEI_80x As String = "GsParam_80x.txt"
Public Const sGSINIDATEI_81x As String = "GsParam_81x.txt"
Public Const sGSINIDATEI_85x As String = "GsParam_85x.txt"
Public Const sGSTESTDATEIBASIS As String = "GsParamTest"
Public Const sGSOUTDATEI As String = "GsOut.txt"
    
' Spezielle Konstante zur Installation eines Druckers
'----------------------------------------------------
Public Const sPORTNUL As String = "NUL:"
Public Const sPORTGS4WORD As String = "GS4WORD:"
Public Const sGS4WORDPOSTSCRIPTPRINTER As String = "Gs4Word PostScript Printer"

' Die folgenden Variablen werden fr den Installations- und Konfigurationsdialog bentigt
'----------------------------------------------------------------------------------------
Public gbAutomatischeInstallation As Boolean
Public gbKonfigurationGespeichert As Boolean
Public gsTaskName As String
Public gbDateiumleitungsFlagIstAenderbar As Boolean
Public gbPrnadminFlag As Boolean
Public gbPrnadminFlagIstAenderbar As Boolean
Public giPrnadminInstallationsstatus As Integer
        ' 0 = Port NUL ist vorhanden
        ' 1 = registriert, aber Port NUL: fehlt
        ' 2 = nicht registriert, kann aber registriert werden
        ' 3 = kann nicht registriert werden
Public gbRedmonFlag As Boolean
Public gbRedmonFlagIstAenderbar As Boolean
Public giRedmonInstallationsstatus As Integer
        ' 0 = installiert und Port GS4WORD ist vorhanden
        ' 1 = installiert, aber Port Gs4WORD: fehlt
        ' 2 = nicht installiert, kann aber installiert werden
        ' 3 = nicht entpackt, kann aber entpackt und installiert werden
        ' 4 = kann nicht installiert werden
Public gsNeuerPortName As String

Public gsDefaultGhostscriptTabelle() As String
    'Die Tabelle enthlt fr jedes Default-Ghostscript einen Eintrag
    'Sie wird in fbGhostscriptListe_fuellen gefllt
    'Spalte 0 enthlt den Ghostscriptnamen fr die Auswahl im Dialog
    'Spalte 1 enthlt den Programmnamen mit Pfad
    'Spalte 2 enthlt den Lizenznamen fr die Registry "GNU Ghostscript" oder "AFPL Ghostscript"
    'Spalte 3 enthlt der Versionsnummer fr die Registry.
    'Spalte 4 enthlt ein Flag (True oder False) ob die Version in der Registry eingetragen ist
    'Spalte 5 enthlt den Programmaufruf zum Entpacken von Ghostscript
    'Spalte 6 enthlt ein Flag (True oder False) ob das Programm im Installationsverzeichnis von Gs4Word liegt
Public gsGhostscriptListe() As String
    'Die GhostscriptListe enthlt fr jedes Ghostscript-Programm einen Eintrag
    'mit dem Ghostscript-Namen fr die Auswahl im Dialog.
    'Sie wird in fbGhostscriptListe_fuellen gefllt
Public gsGhostscriptName As String

Public gsDefaultPDFBetrachterTabelle() As String
    'Die Tabelle enthlt fr jeden Default-PDFBetrachter einen Eintrag
    'Sie wird in fbPDFBetrachterListe_fuellen gefllt
    'Spalte 0 enthlt den PDFBetrachternamen fr die Auswahl im Dialog
    'Spalte 1 enthlt den PDFProgrammnamen mit Pfad
    'Spalte 2 ist unbenutzt
    'Spalte 3 enthlt der Versionsnummer von Ghostview fr die Ini-Datei
    'Spalte 4 enthlt ein Flag (True oder False) ob die Version in der Registry eingetragen ist bzw. eine INI-Datei hat
    'Spalte 5 enthlt den Programmaufruf zum Entpacken von Ghostview
    'Spalte 6 enthlt ein Flag (True oder False) ob das Programm im Installationsverzeichnis von Gs4Word liegt
    '         Es wird zur Zeit nicht ausgewertet
Public gsPDFBetrachterListe() As String
    'Die PDFBetrachterListe enthlt fr jedes PDFProgramm einen Eintrag
    'mit dem PDFBetrachter-Namen fr die Auswahl im Dialog.
    'Sie wird in fbPDFBetrachterListe_fuellen gefllt
Public gsPDFBetrachterName As String

Public gsDefaultDruckerTabelle() As String
    'Die Tabelle enthlt fr jeden Default-Drucker eine Eintrag
    'Sie wird in fbDruckerListe_fuellen gefllt
    'Spalte 0 enthlt den Druckernamen
    'Spalte 1 enthlt den Druckertreibernamen, wenn er Drucker neu angelegt werden kann
    '   Ansonsten ist Spalte 1 leer.
    'Spalte 2 enthlt den Herstellernamen, wenn er Drucker neu angelegt werden kann
    '   Ansonsten ist Spalte 2 leer.
    'Spalte 3 enthlt den Hinweistext zur Installation eines neuen Druckers, wenn dieser vom Anwender angeleggt werden muss
    '   Ansonsten ist Spalte 3 leer.
    'Der Druckenname ist 'sGS4WORDPOSTSCRIPTPRINTER & sSPACE & treibername_aus_spalte_1'
    'Sie muss mit einem Eintrag enden, in dem beide Spalten leer sind.

Public gsDruckerListe() As String
    'Die DruckerListe enthlt fr jeden Drucker einen Eintrag.
Public gsGsParamTabelle() As String
    'Die Parametertabelle erhlt fr jeden Ghostscript-Parameter n einen Eintrag mit folgendem
    'Aufbau:
    '   n,0 =   iPARNR_FORMNAME Im Dialog angezeigter Name des Parameters
    '   n,1 =   iPARNR_NAME     Echter Name des Parameters
    '                           Nur wenn er mit sPARPRAEFIX_D oder sPARPRAEFIX_S beginnt, wird Name
    '                           und Wert durch ein Gleichheitszeichen getrennt.
    '   n,2 =   iPARNR_AENDSWITCH Schalter ob der Parameter nderbar ist
    '                           +   =   sPARAEND_JA Ja
    '                           -   =   sPARAEND_NEIN Wird in Ghostscript nicht verwendet
    '                           *   =   sPARAEND_DEFEKT Funktioniert nicht in Ghostscript
    '   n,3 =   iPARNR_DEFAULT  Defaultwert fr "sPDFSETTINGS=default"
    '   n,4 =   iPARNR_SCREEN   Defaultwert fr "sPDFSETTINGS=screen"
    '   n,5 =   iPARNR_EBOOK    Defaultwert fr "sPDFSETTINGS=ebook" (Ab Ghostscript 8.0)
    '   n,6 =   iPARNR_PRINTER  Defaultwert fr "sPDFSETTINGS=printer"
    '   n,7 =   iPARNR_PREPRESS Defaultwert fr "sPDFSETTINGS=prepress"
    '   n,8 =   iPARNR_ABWDEFAULT  Von iPARNR_DEFAULT abweichende Einstellung zur Initialisierung
    '   n,9 =   iPARNR_ABWSCREEN   Von iPARNR_SCREEN abweichende Einstellung zur Initialisierung
    '   n,10 =  iPARNR_ABWEBOOK    Von iPARNR_EBOOK abweichende Einstellung zur Initialisierung
    '   n,11 =  iPARNR_ABWPRINTER  Von iPARNR_PRINTER abweichende Einstellung zur Initialisierung
    '   n,12 =  iPARNR_ABWPREPRESS Von iPARNR_PREPRESS abweichende Einstellung zur Initialisierung
    '   n,13 =  iPARNR_ANZWERTE Anzahl Werte ab iPARNR_ERSTERWERT
    '   n,14 =  iPARNR_ERSTERWERT  Wert-1
    '   n,m =   Wert-m - iPARNR_MIN

Public Const iPARNR_FORMNAME As Integer = 0
Public Const iPARNR_NAME As Integer = 1
    Public Const sPARPRAEFIX_D As String = "-d"
    Public Const sPARPRAEFIX_S As String = "-s"
    Public Const sPARNAME_PDFSETTINGS As String = "-sPDFSETTINGS"
Public Const iPARNR_AENDSWITCH As Integer = 2
    Public Const sPARAEND_JA As String = "+"
    Public Const sPARAEND_NEIN As String = "-"
    Public Const sPARAEND_DEFEKT As String = "*"
Public Const iPARNR_DEFAULT As Integer = 3
Public Const iPARNR_SCREEN As Integer = 4
Public Const iPARNR_EBOOK As Integer = 5
Public Const iPARNR_PRINTER As Integer = 6
Public Const iPARNR_PREPRESS As Integer = 7
Public Const iPARNR_ABWDEFAULT As Integer = 8
    Public Const sPARWERT_KEINEABW As String = "="
Public Const iPARNR_ABWSCREEN As Integer = 9
Public Const iPARNR_ABWEBOOK As Integer = 10
Public Const iPARNR_ABWPRINTER As Integer = 11
Public Const iPARNR_ABWPREPRESS As Integer = 12
Public Const iPARNR_ANZWERTE As Integer = 13
Public Const iPARNR_ERSTERWERT As Integer = 14
    Public Const sPARWERT_DEFINED As String = "[defined]"
    Public Const sPARWERT_UNDEFINED As String = "[undefined]"
    Public Const sPARWERT_NUMBER As String = "[number]"
    Public Const sPARWERT_TEXT As String = "[text]"
    Public Const sPARWERT_SPARDEFAULT As String = "default"
    Public Const sPARWERT_SPARSCREEN As String = "screen"
    Public Const sPARWERT_SPAREBOOK As String = "ebook"
    Public Const sPARWERT_SPARPRINTER As String = "printer"
    Public Const sPARWERT_SPARPREPRESS As String = "prepress"

'===================================================================================================
'Alle ffentlichen Funktionen, die von KONF_UserForm & INST_UserForm verwendet werden
'===================================================================================================

Function fsProgrammName_konfigurieren(sAlterProgrammName As String) As String
    'Die Funktion zeigt in einem Dialog den aktuell eingestellten Programmnamen an. Der Pfad und
    'Programmname kann gendert werden. Sie gibt den ausgewhlten Programmnamen zurck.
    'Argumente:
    '   sAlterProgrammName = aktuell eingestellter Programm-Name
    '                       Der Wert wird zur Zeit nicht verwendet
    'Rckgabewert:
    '   sLEER = Es konnte kein neuer Programm-Name ermittelt werden.
    '   xx..xx = Name des ausgewhlten Programms mit Pfad.
    'Effekt
    '   Der Dialog fr die Eingabe des Programmnamens wurde gefhrt.
            
    With Dialogs(wdDialogFileOpen)
        '"Datei > ffnen" oder "Datei > Speichern unter" wechseln immer dann in das gewnschte
        'Verzeichnis, wenn man ein existierendes Verzeichnis oder eine existierende Datei (mit Pfad)
        'angibt.
        .Name = sAlterProgrammName
        If .Display = True Then
            fsProgrammName_konfigurieren = WordBasic.FilenameInfo$(.Name, 1)
            'In WordBasic.FilenameInfo$ gibt der Wert "1" im zweiten Argument den vollen Dateinamen
            'mit Pfad zurck.
        Else
            fsProgrammName_konfigurieren = sAlterProgrammName
        End If
    End With
    
End Function

Function fsMailtoParameter_konfigurieren(sAlterMailtoParameter As String) As String
    'Die Funktion zeigt in einem Dialog den aktuell eingestellten Mailto-Parameter an. Er kann
    'gendert werden. Sie gibt den genderten Mailto-Parameter zurck.
    'Die Funktion berprft den Parameter nicht auf syntaktische Fehler.
    'Argumente:
    '   sAlterMailtoParameter = aktuell eingestellter Mailto-Parameter
    'Rckgabewert:
    '   xx..xx = neuer Mailto-Parameter.
    'Effekt
    '   Der Dialog fr die Eingabe des Mailto-Parameters wurde gefhrt.
    
    fsMailtoParameter_konfigurieren = Trim(sAlterMailtoParameter)

    fsMailtoParameter_konfigurieren = _
        InputBox(fsText(sTEXT_IBMAILTOPARAMETER), sTITEL_IBMAILTOPARAMETER, _
        fsMailtoParameter_konfigurieren)
    
    If fsMailtoParameter_konfigurieren = sLEER Then ' Abgebrochen
        fsMailtoParameter_konfigurieren = Trim(sAlterMailtoParameter)
    Else
        fsMailtoParameter_konfigurieren = Trim(fsMailtoParameter_konfigurieren)
    End If
    
End Function

Function fsDokuAufruf_konfigurieren(sAlterDokuAufruf As String) As String
    'Die Funktion zeigt in einem Dialog den aktuell eingestellten Aufruf der Dokumentation an.
    'Er kann gendert werden. Sie gibt den genderten Aufruf der Dokumentation zurck.
    'Die Funktion berprft den Parameter nicht auf syntaktische Fehler.
    'Argumente:
    '   sAlterDokuAufruf = aktuell eingestellter Aufruf der Dokumentation
    'Rckgabewert:
    '   xx..xx = neuer Aufruf der Dokumentation.
    'Effekt
    '   Der Dialog fr die Eingabe des Aufrufes der Dokumentation wurde gefhrt.
    
    fsDokuAufruf_konfigurieren = Trim(sAlterDokuAufruf)

    fsDokuAufruf_konfigurieren = _
        InputBox(fsText(sTEXT_IBDOKUAUFRUF), sTITEL_IBDOKUAUFRUF, _
        fsDokuAufruf_konfigurieren)
    
    If fsDokuAufruf_konfigurieren = sLEER Then ' Abgebrochen
        fsDokuAufruf_konfigurieren = Trim(sAlterDokuAufruf)
    Else
        fsDokuAufruf_konfigurieren = Trim(fsDokuAufruf_konfigurieren)
    End If
    
End Function

'===================================================================================================
'Alle ffentlichen Funktionen, die von INST_Prozeduren und KONF_Prozeduren verwendet werden
'===================================================================================================

Function fbKonfiguration_mitTechnikDefaultsBelegen() As Boolean
    'Die Funktion belegt die globalen g*-Variablen zur Technik aus der Registry mit ihren Defaults.
    'Diese Werte sind fr alle Gs4Word-Add-Ins gleich
    'Nur gsInstVerzeichnis, gsInstLogbuch und gsSprachSwitch werden nicht neu belegt.
    'Diese Variablen mssen immer gefllt bleiben.
    'Argumente:
    'Global:
    '   g*-Variable werden ggf. gendert
    '   gbKonfigurationGespeichert wird auf False gesetzt
    'Rckgabewert:
    '   True = Die g*-Variablen wurden mit ihren Defaults belegt
    'Effekt
       
    Dim iZaehler As Integer
    Dim sPDFVerknpfterProgrammName As String
    
    gbKonfigurationGespeichert = False
    
    gbDebugFlag = False
    'Variable giMaxRechnerWartezeit belegen
    giMaxRechnerWartezeit = fiMaxRechnerWartezeit_ermitteln
    'Variable gsPathSeparator vor der Nutzung bei gsMailtoProgrammName belegen!!!
    gsPathSeparator = Application.PathSeparator 'PathSeparator IMMER neu ermitteln
    'Variable gsDokuAufruf belegen
    gsDokuAufruf = fsDokuAufruf_ermitteln()
    'Drucker-Variablen belegen
    If fbPortNUL_ermitteln() = True Then
        giPrnadminInstallationsstatus = 0 ' 0 = Port NUL: ist vorhanden
        gbPrnadminFlag = False
        gbPrnadminFlagIstAenderbar = True
    ElseIf fbPrnadminInstalliert_ermitteln() = True Then
        giPrnadminInstallationsstatus = 1 ' 1 = registriert, aber Port NUL: fehlt
        gbPrnadminFlag = True
        gbPrnadminFlagIstAenderbar = True
    ElseIf fsPrnadminVorhanden_ermitteln() <> sLEER Then
        giPrnadminInstallationsstatus = 2 ' 2 = nicht registriert, kann aber registriert werden
        gbPrnadminFlag = True
        gbPrnadminFlagIstAenderbar = True
    Else
        giPrnadminInstallationsstatus = 3 ' 3 = kann nicht registriert werden
        gbPrnadminFlag = False
        gbPrnadminFlagIstAenderbar = False
    End If
    If fbRedmonPortGS4WORD_ermitteln() = True Then
        giRedmonInstallationsstatus = 0 ' 0 = installiert und Port GS4WORD ist vorhanden
        gbRedmonFlag = False
        gbRedmonFlagIstAenderbar = True
    ElseIf fsRedmonRegPfad_ermitteln() <> sLEER Then
        giRedmonInstallationsstatus = 1 ' 1 = installiert, aber Port Gs4WORD: fehlt
        gbRedmonFlag = True
        gbRedmonFlagIstAenderbar = True
    ElseIf fsRedmonSetup_ermitteln() <> sLEER Then
        giRedmonInstallationsstatus = 2 ' 2 = nicht installiert, kann aber installiert werden
        gbRedmonFlag = True
        gbRedmonFlagIstAenderbar = True
    ElseIf fsRedmonZipfile_ermitteln() <> sLEER Then
        giRedmonInstallationsstatus = 3 ' 3 = nicht entpackt, kann aber entpackt und installiert werden
        gbRedmonFlag = True
        gbRedmonFlagIstAenderbar = True
    Else
        giRedmonInstallationsstatus = 4 ' 4 = kann nicht installiert werden
        gbRedmonFlag = False
        gbRedmonFlagIstAenderbar = False
    End If
    
    If giPrnadminInstallationsstatus = 0 Then
        gsNeuerPortName = sPORTNUL
    ElseIf giRedmonInstallationsstatus = 0 Then
        gsNeuerPortName = sPORTGS4WORD
    ElseIf giPrnadminInstallationsstatus = 1 Then
        gsNeuerPortName = sPORTNUL
    ElseIf giRedmonInstallationsstatus = 1 Then
        gsNeuerPortName = sPORTGS4WORD
    ElseIf giPrnadminInstallationsstatus = 2 Then
        gsNeuerPortName = sPORTNUL
    ElseIf giRedmonInstallationsstatus = 2 Then
        gsNeuerPortName = sPORTGS4WORD
    ElseIf giRedmonInstallationsstatus = 3 Then
        gsNeuerPortName = sPORTGS4WORD
    Else
        gsNeuerPortName = sLEER
    End If
    If gsNeuerPortName = sPORTNUL _
    And gbRedmonFlagIstAenderbar = True Then
        gbRedmonFlag = False
    ElseIf gsNeuerPortName = sPORTGS4WORD _
    And gbPrnadminFlagIstAenderbar = True Then
        gbPrnadminFlag = False
    End If
    
    If fbDruckerListe_fuellen(True) = True Then
        gsPSDruckerName = gsDruckerListe(0)
    End If
    If gsPSDruckerName <> sLEER _
    And fbDruckerUmleitbar_ermitteln(gsPSDruckerName) = True Then
        'Ein umleitbarer Gs4Word-Drucker ist vorhanden oder kann installiert werden
        gbDateiumleitungsFlag = True
        gbDateiumleitungsFlagIstAenderbar = True
    Else
        gbDateiumleitungsFlag = False
        gbDateiumleitungsFlagIstAenderbar = False
    End If
    'Ghostscript
    Call fbGhostscriptListe_fuellen(True)
    'Bei True und bei False wird der Wert aus (0,1) verwendet
    gsGhostscriptName = gsDefaultGhostscriptTabelle(0, 0)
    gsGSProgrammName = gsDefaultGhostscriptTabelle(0, 1)
    'PDF-Betrachter
    Call fbPDFBetrachterListe_fuellen(True)
    'Bei True und bei False wird als Default der Wert aus (0,1) verwendet
    gsPDFBetrachterName = gsDefaultPDFBetrachterTabelle(0, 0)
    gsPDFProgrammName = gsDefaultPDFBetrachterTabelle(0, 1)
    'Wenn eines der Programme in der Liste mit PDF verknpft ist, dann dieses nehmen
    sPDFVerknpfterProgrammName = fsVerknuepfung_ermitteln(sPDF, sLEER)
    If sPDFVerknpfterProgrammName <> sLEER Then
        iZaehler = fiPDFBetrachterDefaultNr_ermitteln(sPDFVerknpfterProgrammName, 1)
        gsPDFBetrachterName = gsDefaultPDFBetrachterTabelle(iZaehler, 0)
        gsPDFProgrammName = gsDefaultPDFBetrachterTabelle(iZaehler, 1)
    End If
    '20031227 auskommentiert gsPDFProgrammName = fsVerknuepfung_ermitteln(sPDF, sLEER)
    'Weitere
    gsMailtoProgrammName = fsMailtoProgramm_ermitteln()
    gsMailtoParameter = fsMailtoParameter_ermitteln(gsMailtoProgrammName)
    gsGSParamKonfName = fsGSParamKonfigName_ermitteln()
    'Shell-Switch fr den Doku-Aufruf
    gsGSShellSwitch = sDEFAULT_GSSHELLSWITCH
    'AusgabeMedienTabelle fllen
    Call fbParamTabelleFuellen(gsGSParamKonfName)
    Call fbAusgabeMedienTabelle_DefaultFuellen
    
    fbKonfiguration_mitTechnikDefaultsBelegen = True
        
End Function

Function fbKonfiguration_mitAnwendungsDefaultsBelegen(sTaskName As String, bVorlageIstAenderbar As Boolean)
    'Die Funktion belegt die globalen g*-Variablen zur Anwendung aus der Registry mit ihren Defaults.
    'Diese Werte sind fr je Gs4Word-Add-In unterschiedlich.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    '   bVorlageIstAenderbar Nur wenn das Flag gesetzt ist, wird auch gbButtonFlag und gsMailToSwitch
    '       mit den Defaultwerten belegt
    'Global:
    '   g*-Variable werden ggf. gendert
    '   gbKonfigurationGespeichert wird auf False gesetzt
    'Rckgabewert:
    '   True = Die g*-Variablen wurden mit ihren Defaults belegt
    'Effekt
    
    gbKonfigurationGespeichert = False
    
    If bVorlageIstAenderbar = True Then
        gbButtonFlag = fbFlag_pruefen(bDEFAULT_BUTTONFLAG, bDEFAULT_BUTTONFLAG)
        If gsMailtoParameter = sLEER Then
            gsMailToSwitch = fsMailToSwitch_konvertieren(sDEFAULT_MAILTOSWITCH_NEIN)
        Else
            gsMailToSwitch = fsMailToSwitch_konvertieren(sDEFAULT_MAILTOSWITCH_JA)
        End If
    End If
    gbDialogFlag = fbFlag_pruefen(bDEFAULT_DIALOGFLAG, bDEFAULT_DIALOGFLAG)
    gbPdfmarkFlag = fbFlag_pruefen(bDEFAULT_PDFMARKFLAG, bDEFAULT_PDFMARKFLAG)
    gsPdfOutSwitch = fsPDFOutSwitch_konvertieren(sDEFAULT_PDFOUTSWITCH, sTaskName)
    gsPdfPageLayoutSwitch = fsPDFPageLayoutSwitch_konvertieren(sDEFAULT_PDFPAGELAYOUTSWITCH)
    If sTaskName = sTASKNAME_WORD Then
        gsPdfPageModeSwitch = fsPDFPageModeSwitch_konvertieren(sDEFAULT_PDFPAGEMODESWITCH_WORD, sTaskName)
    Else
        gsPdfPageModeSwitch = fsPDFPageModeSwitch_konvertieren(sDEFAULT_PDFPAGEMODESWITCH, sTaskName)
    End If
    gsPdfViewSwitch = fsPDFViewSwitch_konvertieren(sDEFAULT_PDFVIEWSWITCH)
    gsPrintSwitch = fsPrintSwitch_konvertieren(sDEFAULT_PRINTSWITCH, sTaskName)
    gsTypeSwitch = fsTypeSwitch_konvertieren(sDEFAULT_TYPESWITCH, sTaskName)
    gbRahmenFlag = fbFlag_pruefen(bDEFAULT_RAHMENFLAG, bDEFAULT_RAHMENFLAG)
    gbPDFBetrachterFlag = fbFlag_pruefen(sDEFAULT_PDFBETRACHTERFLAG, sDEFAULT_PDFBETRACHTERFLAG)
    gbLogDateiLoeschenFlag = fbFlag_pruefen(sDEFAULT_LOGDATEILOESCHENFLAG, _
        sDEFAULT_LOGDATEILOESCHENFLAG)
    gbPSDateiLoeschenFlag = fbFlag_pruefen(sDEFAULT_PSDATEILOESCHENFLAG, _
        sDEFAULT_PSDATEILOESCHENFLAG)
    gsAusgabeMedium = fsAusgabeMedium_konvertieren(sDEFAULT_AUSGABEMEDIUM)
    gsSymbDateiName = sDEFAULT_SYMBDATEINAME
    
    fbKonfiguration_mitAnwendungsDefaultsBelegen = True
    
End Function

Function fsDokuAufruf_ermitteln() As String
    'Die Funktion gibt den Aufruf der HTML-Dokumentation mit dem Browser zurck.
    'Global:
    '   gsInstVerzeichnis wird gelesen
    'Rckgabewert:
    '   sLEER = Es konnte kein Programm ermittelt werden.
    '   xx..xx = Name des zugeordneten Programms.
    'Effekt
    '   keiner
    
    Dim sDokuDatei As String
    
    sDokuDatei = fsText(sDOKUMENTATIONSMUSTER, gsInstVerzeichnis, _
        fsSprachSwitch_konvertieren(gsSprachSwitch), sDOKU_ANFANG)
    If Dir(sDokuDatei, vbNormal) <> sLEER Then
        fsDokuAufruf_ermitteln = fsVerknuepfung_ermitteln(sHTML, "(&1)")
    Else
        fsDokuAufruf_ermitteln = sLEER
    End If

End Function

Function fsDruckerPort_ermitteln(sPSDruckerName As String) As String
    'Die Funktion ermittelt den Drucker-Port aus der Registry
    'Argumente:
    '   sPSDruckerName ist der Druckername
    'Rckgabewert:
    '   sLEER = Es konnte kein Drucker-Port ermittelt werden.
    '   xx..xx = Name des zugeordneten Ports.
    'Effekt
    '   keiner
    
    Const sSCHLUESSEL_PORT As String = "Port"
    Const sDRUCKERKEY As String = _
        "HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Print\Printers\"
        
    fsDruckerPort_ermitteln = System.PrivateProfileString(sLEER, sDRUCKERKEY & Trim(sPSDruckerName), _
        sSCHLUESSEL_PORT)

End Function

Function fbDruckerUmleitbar_ermitteln(sPSDruckerName As String) As String
    'Die Funktion prft, ob der Drucker fr Word umleitbar ist. Das ist der Fall, wenn
    'a) RedMon fr den Gs4Word-Drucker konfiguriert ist. Dazu muss in der Registry ein
    '   RedMon-Drucker-Monitor eingetragen ist, dessen Port und Drucker-Name passt.
    '   Da der Name des RedMon-Registry-Key abhngig von der Sprache ist, in der RedMon installiert
    '   wurde, habe ich die vier verschiedenen Namen aus der Source von RedMon, Version 1.7 genommen.
    '   Diese Version ist in vier Spachen lieferbar. Getestet wurde nur in Deutsch.
    '   Der Port wird aus dem Registry-Eintrag des Druckers ermittelt.
    'b) der Port NUL: verwendet wird. Dieser Port leitet unter Windows NT/2000/XP die Druckausgabe
    '   ins Nichts (UNIX lt gren).
    'c) Der Gs4Word-Drucker neu an Port GS4WORD: installiert werden soll. Dazu muss Redmon installiert
    '   oder installierbar sein
    'Global:
    '   sPORTNUL wird gelesen
    'Argumente:
    '   sPSDruckerName ist der Druckername
    'Rckgabewert:
    '   True = Der Drucker kann umgeleitet werden
    '   False = Der Drucker kann nicht umgeleitet werden
    'Effekt
    '   keiner
        
    Dim sDruckertreiber As String
    Dim sPortWert As String
    
    sDruckertreiber = fsDruckerInstallieren_ermitteln(gsPSDruckerName)
    
    If sDruckertreiber <> sLEER Then
        'Der Drucker ist noch nicht installiert
        fbDruckerUmleitbar_ermitteln = True
        Exit Function
    Else
        'Der Drucker ist schon installiert
        sPortWert = fsDruckerPort_ermitteln(sPSDruckerName)
        If sPortWert <> sLEER Then
            'Ist es Port NUL:?
            If sPortWert = sPORTNUL Then
                'Der Portname muss in Grossbuchstaben geschrieben sein
                fbDruckerUmleitbar_ermitteln = True
                Exit Function
            End If
            'Ist es ein Redmon-Port ?
            If fbRedmonPortGS4WORD_ermitteln = True Then
                fbDruckerUmleitbar_ermitteln = True
                Exit Function
            End If
        End If
                    
    End If
    
    fbDruckerUmleitbar_ermitteln = False
    
End Function

Function fsRedmonPortGS4WORD_installieren() As String
    'Die Funktion entpackt und installiert ggf. Redmon 1.7 und registriert Port GS4WORD:
        '[HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Print\Monitors\Umgeleiteter Anschlu\Ports\RPT1:]
        '"Description"="Umgeleiteter Anschlu" oder "Redirected Port" oder "Port redirig" oder "Omdirigerad port"
        '"Command"="P:\\Programme\\redmon17de\\redfile.exe" 'Anschluss auf folgendes Programm umleiten:
        '"Arguments"="c:\\Temp\\RTP1.out"   'Argumente fr dieses Programm:
        '"Printer"="Gs4Word"                'Drucker:
        '"Output"=dword:00000000            'Aufgabe: 0=Programm erledigt Ausgabe, 1=Prompt for filename, 2=Kopiere Standardausgabe..., 3=Kopiere temporre..., 4=Kopiere Befehlskette...
        '"ShowWindow"=dword:00000000        'Ablauf: 0=Normal, 1=Symbol, 2=Hintergrund
        '"RunUser"=dword:00000000           'Ausfhren als Benutzer: 1=Ja, 0=Nein
        '"Delay"=dword:0000012c = 300       'Schlieverzgerung:
        '"LogFileUse"=dword:00000000
        '"LogFileName"=""
        '"LogFileDebug"=dword:00000000
        '"PrintError"=dword:00000000
    'Global:
    '   gsInstVerzeichnis wird gelesen
    '   sPORTGS4WORD wird gelesen
    'Rckgabewert:
    '   "" = Aufgabe erledigt. Port GS4WORD: existiert in der Registry.
    '   "fehlertext" = Es ist eine Fehler aufgetreten
    'Effekt
    '   Ggf. wurde Redmon im Installationsverzeichnis von Gs4Word entpackt
    '   Ggf. wurde Redmon installiert
    '   Ggf. wurde Anschluss GS4WORD: angelegt
    
    Const sUNZIPFILE As String = "unzip.exe"
    Const sREDMONREDFILE As String = "redfile.exe"
    
    Const sWERTDESCRIPTION As String = "Description"
    Const sWERTCOMMAND As String = "Command"        'Anschluss auf folgendes Programm umleiten:
    Const sWERTARGUMENTS As String = "Arguments"    'Argumente fr dieses Programm:
    Const sWERTPRINTER As String = "Printer"        'Drucker:
    Const sWERTOUTPUT As String = "Output"          'Aufgabe: 0=Programm erledigt Ausgabe, 1=Prompt for filename, 2=Kopiere Standardausgabe..., 3=Kopiere temporre..., 4=Kopiere Befehlskette...
    Const sWERTSHOWWINDOW As String = "ShowWindow"  'Ablauf: 0=Normal, 1=Symbol, 2=Hintergrund
    Const sWERTRUNUSER As String = "RunUser"        'Ausfhren als Benutzer: 1=Ja, 0=Nein
    Const sWERTDELAY As String = "Delay"            'Schlieverzgerung:
    Const sWERTLOGFILEUSE As String = "LogFileUse"
    Const sWERTLOGFILENAME As String = "LogFileName"
    Const sWERTLOGFILEDEBUG As String = "LogFileDebug"
    Const sWERTPRINTERROR As String = "PrintError"
    
    Dim vDatenDescription As Variant
    Dim vDatenCommand As Variant
    Dim vDatenArguments As Variant
    Dim vDatenPrinter As Variant
    Dim vDatenOutput As Variant
    Dim vDatenShowWindow As Variant
    Dim vDatenRunUser As Variant
    Dim vDatenDelay  As Variant
    Dim vDatenLogFileUse As Variant
    Dim vDatenLogFileName As Variant
    Dim vDatenLogFileDebug  As Variant
    Dim vDatenPrintError As Variant
    
    Dim iZaehler As Integer
    Dim lPosition As Long
    Dim sUnzipKomando As String
    Dim sSetupKomando As String
    Dim sRegPfad As String
    Dim sPortPfad As String
    Dim sRedmonDir As String
    Dim sRedfileExe As String
    Dim sRedmonZip As String
    Dim sUNZIPEXE As String
    Dim sSetupExe As String
    Dim sTempPfad As String
    Dim vtaskId As Variant 'Task-ID eines mit Shell aufgerufenen Programms
    Dim iWartezeit As Integer

    sRedmonZip = fsRedmonZipfile_ermitteln()
    lPosition = flLetztesVorkommen_suchen(sRedmonZip, ".zip")
    If lPosition > 0 Then
        sRedmonDir = Left(sRedmonZip, lPosition - 1)
    Else
        fsRedmonPortGS4WORD_installieren = fsText(sMSG_KONNTEREDMONZIPFILENICHTERMITTELN, sRedmonZip)
        Exit Function
    End If

    sUNZIPEXE = gsInstVerzeichnis & sUNZIPFILE
    sSetupExe = fsRedmonSetup_ermitteln()
    sRegPfad = fsRedmonRegPfad_ermitteln()
    ' Wenn Redmon nicht installiert ist
    ' oder Port GS4WORD: nicht oder fehlerhaft installiert ist
    If sRegPfad = sLEER _
    Or fbRedmonPortGS4WORD_ermitteln = False Then
        'Redmon entpacken.
        If sUNZIPEXE <> sLEER _
        And sSetupExe = sLEER Then
            sUnzipKomando = Chr(34) & sUNZIPEXE & Chr(34) & " -o -d " & Chr(34) & sRedmonDir & Chr(34) & sSPACE & Chr(34) & sRedmonZip & Chr(34)
            vtaskId = Shell(sUnzipKomando, 4)
            If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
                'Shell wird asynchron verarbeitet, deshalb solange warten, bis die Setup-Datei
                'ausgepackt sind. Das wird einmal je Sekunde berprft.
                'Wie lange darauf maximal gewartet wird, ist je Rechner (Prozessortakt) unterschiedlich.
                'Wer eine bessere Idee hat, soll sich bitte melden!
                For iWartezeit = 1 To giMaxRechnerWartezeit Step 1
                    Call fbWarten(1)  'In der Schleife immer eine Sekunde warten
                    'Prfen ob Redmon schon komplett ausgepackt ist
                    If fsRedmonSetup_ermitteln <> sLEER Then
                        Exit For
                    End If
                Next iWartezeit
                'Noch zwei Sekunden fr die anderen Dateien zugeben
                Call fbWarten(2)
                If fsRedmonSetup_ermitteln = sLEER Then
                    fsRedmonPortGS4WORD_installieren = fsText(sMSG_KONNTEREDMONNICHTENTPACKEN, sUnzipKomando)
                    Exit Function
                End If
            End If
        End If
        
        'Redmon installieren.
        sSetupExe = fsRedmonSetup_ermitteln()
        If sSetupExe <> sLEER Then
            sSetupKomando = Chr(34) & sSetupExe & Chr(34) & " ."
            'Durch ein beliebiges Zeichen als Parameter werden keine Rckfragen gestellt.
            vtaskId = Shell(sSetupKomando, 4)
            If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
                'Shell wird asynchron verarbeitet, deshalb zuerst solange warten, bis der Eintrag
                'in der Registry erfolgt ist. Das wird einmal je Sekunde berprft.
                'Wie lange darauf maximal gewartet wird, ist je Rechner (Prozessortakt) unterschiedlich.
                'Wer eine bessere Idee hat, soll sich bitte melden!
                For iWartezeit = 1 To giMaxRechnerWartezeit Step 1
                    Call fbWarten(1)  'In der Schleife immer eine Sekunde warten
                    'Prfen ob Setup schon fertig ist
                    If fsRedmonRegPfad_ermitteln <> sLEER Then
                        Exit For
                    End If
                Next iWartezeit
                'Noch zwei Sekunden zugeben
                Call fbWarten(2)
            End If
        End If
        sRegPfad = fsRedmonRegPfad_ermitteln()
        If sRegPfad = sLEER Then
            'Redmon konnte nicht installiert werden
            fsRedmonPortGS4WORD_installieren = fsText(sMSG_KONNTEREDMONNICHTINSTALLIEREN, sSetupKomando)
            Exit Function
        End If
    End If
    
    If fbRedmonPortGS4WORD_ermitteln = True Then
        fsRedmonPortGS4WORD_installieren = sLEER
        Exit Function
    End If
            
    'Werte fllen
    sPortPfad = sRegPfad & "\Ports\" & sPORTGS4WORD
    sRedfileExe = fsRedmonDir_ermitteln & sREDMONREDFILE
    sTempPfad = sLEER
    sTempPfad = Environ("TEMP")
    If sTempPfad = sLEER Then
        sTempPfad = Environ("TMP")
        If sTempPfad = sLEER Then
            'Redmon konnte nicht installiert werden
            fsRedmonPortGS4WORD_installieren = fsText(sMSG_KONNTEREDMONNICHTINSTALLIEREN, sSetupKomando)
            Exit Function
        End If
    End If

    fsRedmonPortGS4WORD_installieren = sMSG_KONNTEREDMONNICHTREGISTRIEREN
    If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTDESCRIPTION, "Umgeleiteter Anschlu", REG_SZ) = True Then
        If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTCOMMAND, sRedfileExe, REG_SZ) = True Then
            If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTARGUMENTS, sTempPfad & gsPathSeparator & "GS4WORD.out", REG_SZ) = True Then
                If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTPRINTER, "Gs4Word", REG_SZ) = True Then
                    If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTOUTPUT, 0, REG_DWORD) = True Then
                        If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTSHOWWINDOW, 0, REG_DWORD) = True Then
                            If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTRUNUSER, 300, REG_DWORD) = True Then
                                If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTDELAY, 0, REG_DWORD) = True Then
                                    If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTLOGFILEUSE, 0, REG_DWORD) = True Then
                                        If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTLOGFILENAME, "", REG_SZ) = True Then
                                            If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTLOGFILEDEBUG, 0, REG_DWORD) = True Then
                                                If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTPRINTERROR, 0, REG_DWORD) = True Then
                                                    fsRedmonPortGS4WORD_installieren = sLEER
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If
    
    If fsRedmonPortGS4WORD_installieren = sLEER Then
        If fbRedmonPortGS4WORD_ermitteln = False Then
            fsRedmonPortGS4WORD_installieren = fsText(sMSG_KONNTEPORTNICHTANLEGEN, sPORTGS4WORD)
        Else
            fsRedmonPortGS4WORD_installieren = sLEER
        End If
    End If
End Function

Function fbRedmonPortGS4WORD_ermitteln() As Boolean
    'Die Funktion ermittelt, ob Port GS4WORD: schon vorhanden ist und on der Port richtig installiert ist.
    'Global:
    '   sPORTGS4WORD wird gelesen
    'Rckgabewert:
    '   True = Port GS4WORD: existiert in der Registry.
    '   False = Port GS4WORD: existiert nicht.
    'Effekt
    '   keiner
    
    Const sREDFILE As String = "\redfile.exe"
    
    Const sWERTCOMMAND As String = "Command"        'Anschluss auf folgendes Programm umleiten:
    Const sWERTARGUMENTS As String = "Arguments"    'Argumente fr dieses Programm:
    Const sWERTOUTPUT As String = "Output"          'Aufgabe: 0=Programm erledigt Ausgabe, 1=Prompt for filename, 2=Kopiere Standardausgabe..., 3=Kopiere temporre..., 4=Kopiere Befehlskette...
            
    Dim vDatenCommand As Variant
    Dim vDatenArguments As Variant
    Dim vDatenOutput As Variant
    
    Dim sDruckertreiber As String
    Dim sRegPfad As String
    Dim sPortWert As String
    Dim sPortPfad As String
    
    sRegPfad = fsRedmonRegPfad_ermitteln()
    If sRegPfad <> sLEER Then
        'Ist es ein Redmon-Port ?
        sPortPfad = sRegPfad & "\Ports\" & sPORTGS4WORD
        If fbRegistry_PfadPruefen(HKEY_LOCAL_MACHINE, sPortPfad) = True Then
            vDatenCommand = fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTCOMMAND, NEVER_RETURN_NULL)
            vDatenArguments = fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTARGUMENTS, NEVER_RETURN_NULL)
            vDatenOutput = fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sPortPfad, sWERTOUTPUT, NEVER_RETURN_NULL)
            'Prfen ob verwendbar
            If Dir(vDatenCommand, vbNormal) <> sLEER _
            And LCase(Right(vDatenCommand, Len(sREDFILE))) = sREDFILE _
            And Len(vDatenArguments) > 0 _
            And vDatenOutput = 0 Then
                'Ist verwendbar
                fbRedmonPortGS4WORD_ermitteln = True
                Exit Function
            End If
        End If
    End If
    
    fbRedmonPortGS4WORD_ermitteln = False
    
End Function

Function fsRedmonRegPfad_ermitteln() As String
    'Die Funktion prft, ob und in welcher Sprache Redmon installiert ist
    '   Da der Name des RedMon-Registry-Key abhngig von der Sprache ist, in der RedMon installiert
    '   wurde, habe ich die vier verschiedenen Namen aus der Source von RedMon, Version 1.7 genommen.
    '   Diese Version ist in vier Spachen lieferbar. Getestet wurde nur in Deutsch.
    'Argumente:
    '   -
    'Rckgabewert:
    '   sLEER = Redmon ist nicht installiert
    '   <> "" = Registry-Pfad zu Redmon
    'Effekt
    '   keiner
    
    Const sPfad As String = "System\CurrentControlSet\Control\Print\Monitors\"

    Dim sRedMonKeys(3) As String
    Dim iZaehler As Integer
    Dim sPortWert As String
    Dim sCommandWert As String
    Dim sProgramm As String
    
    sRedMonKeys(0) = sPfad & "Umgeleiteter Anschlu"
    sRedMonKeys(1) = sPfad & "Redirected Port"
    sRedMonKeys(2) = sPfad & "Port redirig"
    sRedMonKeys(3) = sPfad & "Omdirigerad port"
    For iZaehler = LBound(sRedMonKeys) To UBound(sRedMonKeys)
        If fbRegistry_PfadPruefen(HKEY_LOCAL_MACHINE, sRedMonKeys(iZaehler)) = True Then
            fsRedmonRegPfad_ermitteln = sRedMonKeys(iZaehler)
            Exit Function
        End If
    Next iZaehler
    
    fsRedmonRegPfad_ermitteln = sLEER
    
End Function

Function fsRedmonDir_ermitteln() As String
    'Die Funktion ermittelt den Pfad zu Redmon und prft ob alle 14 Dateien vorhanden sind
    'Global:
    '   gsInstVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    'Argumente:
    '   -
    'Rckgabewert:
    '   sLEER = Kein Pfad zu Redmon vorhanden
    '   gefllt = Pfad zu Redmon
    'Effekt
    '   keiner
    
    Dim sRedmonDir(3) As String
    Dim iZaehler As Integer
    Dim sDatei As String
        
    sRedmonDir(0) = gsInstVerzeichnis & "redmon17de" & gsPathSeparator
    sRedmonDir(1) = gsInstVerzeichnis & "redmon17" & gsPathSeparator
    sRedmonDir(2) = gsInstVerzeichnis & "redmon17fr" & gsPathSeparator
    sRedmonDir(3) = gsInstVerzeichnis & "redmon17se" & gsPathSeparator
    
    fsRedmonDir_ermitteln = sLEER
    
    For iZaehler = LBound(sRedmonDir) To UBound(sRedmonDir)
        If Dir(sRedmonDir(iZaehler), vbDirectory) <> sLEER Then
            fsRedmonDir_ermitteln = sRedmonDir(iZaehler)
            Exit For
        End If
    Next iZaehler
    
    If fsRedmonDir_ermitteln <> sLEER Then
        iZaehler = 0
        sDatei = Dir(fsRedmonDir_ermitteln, vbNormal)
        Do While sDatei <> ""
            iZaehler = iZaehler + 1
            sDatei = Dir ' Nchsten Eintrag abrufen.
        Loop
        
        If iZaehler < 14 Then
            fsRedmonDir_ermitteln = sLEER
        End If
    End If
    
End Function

Function fsRedmonSetup_ermitteln() As String
    'Die Funktion ermittelt den Installationspfad fr das Setup von Redmon
    'Global:
    '   gsInstVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    'Argumente:
    '   -
    'Rckgabewert:
    '   sLEER = Kein Setup fr Redmon vorhanden
    '   gefllt = Setup.exe inklusive Pfad
    'Effekt
    '   keiner
    
    Const sREDMONSETUP As String = "setup.exe"
      
    Dim sRedmonDir As String
    
    sRedmonDir = fsRedmonDir_ermitteln
    fsRedmonSetup_ermitteln = sRedmonDir & sREDMONSETUP
    
    If sRedmonDir = sLEER _
    Or Dir(fsRedmonSetup_ermitteln, vbNormal) = sLEER Then
        fsRedmonSetup_ermitteln = sLEER
        Exit Function
    End If
    
End Function

Function fsRedmonZipfile_ermitteln() As String
    'Die Funktion ermittelt, ob ein Zipfile fr Redmon existiert
    'Global:
    '   gsInstVerzeichnis wird gelesen
    'Argumente:
    '   -
    'Rckgabewert:
    '   sLEER = Kein Zipfile fr Redmon vorhanden
    '   gefllt = redmon17.zip inklusive Pfad
    'Effekt
    '   keiner
    
    Const sUNZIPFILE As String = "unzip.exe"
    
    Dim sRedmonZipfile(3) As String
    Dim sUnzipProgrammName As String
    Dim iZaehler As Integer
        
    sRedmonZipfile(0) = gsInstVerzeichnis & "redmon17de.zip"
    sRedmonZipfile(1) = gsInstVerzeichnis & "redmon17.zip"
    sRedmonZipfile(2) = gsInstVerzeichnis & "redmon17fr.zip"
    sRedmonZipfile(3) = gsInstVerzeichnis & "redmon17se.zip"
    
    fsRedmonZipfile_ermitteln = sLEER
    
    sUnzipProgrammName = gsInstVerzeichnis & sUNZIPFILE
    If Dir(sUnzipProgrammName, vbNormal) = sLEER Then
        'das Zipffile ist nicht vorhanden
        Exit Function
    End If
    
    For iZaehler = LBound(sRedmonZipfile) To UBound(sRedmonZipfile)
        If Dir(sRedmonZipfile(iZaehler), vbNormal) <> sLEER Then
            fsRedmonZipfile_ermitteln = sRedmonZipfile(iZaehler)
            Exit Function
        End If
    Next iZaehler
    
End Function

Function fbPortNUL_ermitteln() As Boolean
    'Die Funktion ermittelt, ob Port NUL: vorhanden ist.
    'Global:
    '   sPORTNUL wird gelesen
    'Rckgabewert:
    '   True = Port NUL: existiert in der Registry.
    '   False = Port NUL: existiert nicht.
    'Effekt
    '   keiner
    
    Const sPORTSPATH As String = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Ports"
        
    If IsNull(fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sPORTSPATH, sPORTNUL, _
        WITH_RETURN_NULL)) = True Then
        fbPortNUL_ermitteln = False
    Else
        fbPortNUL_ermitteln = True
    End If

End Function

'Function fbPortNUL_registrieren() As Boolean
'    'Die Funktion registriert Port NUL:
'    'Anscheinend reicht das aber nicht, unter Windows 2000 ist ein so registrierter Port nicht sichtbar.
'    'Da fehlt noch was - aber was?
'    'Global:
'    '   sPORTNUL wird gelesen
'    'Rckgabewert:
'    '   True = Port NUL: existiert in der Registry.
'    '   False = Port NUL: existiert nicht.
'    'Effekt
'    '   keiner
'
'    Const sSCHLUESSEL_PORT As String = sPORTNUL
'    Const sPORTSPATH As String = "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Ports"
'
'    If IsNull(fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sPORTSPATH, sSCHLUESSEL_PORT, _
'        WITH_RETURN_NULL)) = True Then
'        fbPortNUL_registrieren = fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sPORTSPATH, sSCHLUESSEL_PORT, sLEER, REG_SZ)
'    Else
'        fbPortNUL_registrieren = True
'    End If
'
'End Function

Function fsPortNUL_installieren() As String
    'Die Funktion installiert Port sPORTNUL
    'Global:
    '   sPORTNUL wird gelesen
    'Rckgabewert:
    '   "" = Aufgabe erledigt
    '   "fehlertext" = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner

    Dim oMaster As Object
    Dim oPort As Object
    Dim oPrinter As Object
    Dim vtaskId As Variant 'Task-ID eines mit Shell aufgerufenen Programms
    Dim iWartezeit As Integer
    Dim sRegsvrAufruf As String
    Dim iFehlerNummer As Integer 'Fehlernumer aus GetAttr()
    Dim sPrnadminDatei As String

    fsPortNUL_installieren = ""

    'Prfen ob prmadmin.dll schon registriert ist
    On Error Resume Next
    Set oMaster = CreateObject("PrintMaster.PrintMaster.1")
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer <> 0 Then
        sPrnadminDatei = fsPrnadminVorhanden_ermitteln
        sRegsvrAufruf = "regsvr32 /s " & Chr(34) & sPrnadminDatei & Chr(34)
        vtaskId = Shell(sRegsvrAufruf, 4)
        iFehlerNummer = 9999
        If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
            'Shell wird asynchron verarbeitet, deshalb zuerst solange warten, bis das Prnadmin
            'registriert wurde
            For iWartezeit = 1 To giMaxRechnerWartezeit Step 1
                Call fbWarten(1)  'In der Schleife immer eine Sekunde warten
                'Prfen ob Prnadmin schon registriert wurde
                On Error Resume Next
                Set oMaster = CreateObject("PrintMaster.PrintMaster.1")
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer = 0 Then
                    Exit For
                End If
            Next iWartezeit
        End If
        If iFehlerNummer <> 0 Then
            'Fehler: PrnAdmin konnte nicht registriert werden
            fsPortNUL_installieren = fsText(sMSG_KONNTEPRNADMINNICHTREGISTRIEREN _
                , sRegsvrAufruf)
            Exit Function
        End If
    Else
        sPrnadminDatei = ""
    End If

    'Siehe Microsoft Kowledge Base Artikel 321025:
    '   HOW TO: Programmatically Create a Printe and e Printer Port by Using PrinterA
    '   (Prnadmin.dll) with a Basic Script in Microsoff Windows 2000

    If fbPortNUL_ermitteln = False Then
        'auch Port NUL: fehlt noch

        Set oPort = CreateObject("Port.Port.1")
        oPort.PortName = sPORTNUL
        oPort.PortType = 3 'local

        On Error Resume Next
        oMaster.PortAdd oPort
        iFehlerNummer = Err.Number
        On Error GoTo 0
        If iFehlerNummer <> 0 Then
            'Fehler: Port konnte nicht angelegt werden
            fsPortNUL_installieren = fsText(sMSG_KONNTEPORTNICHTMITPRNADMINANLEGEN _
                , sPORTNUL, Error(iFehlerNummer))
        End If
    End If

    If sPrnadminDatei <> "" Then
        sRegsvrAufruf = "regsvr32 /s /u " & Chr(34) & sPrnadminDatei & Chr(34)
        vtaskId = Shell(sRegsvrAufruf, 4)
        If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
            'Shell wird asynchron verarbeitet, deshalb zuerst solange warten, bis das Programm
            'gestartet ist.
            Call fbWarten(2)
        End If
    End If

End Function

Function fbPrnadminInstalliert_ermitteln() As Boolean

    'Die Funktion prft, ob PrnAdmin schon installiert ist. Diese DLL gehrt zum Windows Resource Kit Pro
    'und ist fr Windows 2000 und XP verfgbar.
    'Rckgabewert:
    '   True = PrnAdmin ist installiert
    '   False = PrnAdmin ist nicht installiert
    'Effekt
    '   keiner

    Dim oMaster As Object
    Dim iFehlerNummer As Integer 'Fehlernumer aus GetAttr()
    Dim sPrnadminDatei As String

    'Prfen ob prmadmin.dll schon registriert ist
    On Error Resume Next
    Set oMaster = CreateObject("PrintMaster.PrintMaster.1")
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then
        fbPrnadminInstalliert_ermitteln = True
    Else
        fbPrnadminInstalliert_ermitteln = False
    End If
    
End Function

Function fsPrnadminVorhanden_ermitteln() As String
    'Die Funktion ermittelt, ob Prnadmin vorhanden ist. Diese DLL gehrt zum Windows Resource Kit Pro
    'und ist fr Windows 2000 und XP verfgbar.
    'Global:
    '   gsInstVerzeichnis wird gelesen
    'Rckgabewert:
    '   "Pfad zu prnadmin.dll"  = Prnadmin kann installiert werden.
    '   "" = Prnadmin nicht gefunden.
    'Effekt
    '   keiner

    Const sPRNADMINDLL As String = "prnadmin.dll"
    
    Dim sResKitName As String
    Dim sResKitInstallDir As String

    fsPrnadminVorhanden_ermitteln = ""

    Select Case LCase(System.OperatingSystem)
    Case "windows"
        'Windows Plattform 1 Windows 95,98, ME
        Exit Function
    Case "windows nt"
        'Windows Plattform 2,
        Select Case Left(System.Version, 3)
        Case "3.5"
            'Windows NT 3.51
            Exit Function
        Case "4.0"
            'Windows NT 4.0
            Exit Function
        Case "5.0"
            'Windows 2000
            sResKitName = "Windows 2000 Pro Resource Kit"
        Case "5.1"
            'Windows XP
            sResKitName = "Windows Resource Kits"
        Case Else
            'unbekanntes Windows
            Exit Function
        End Select
    Case Else
        'Es ist noch nicht einmal Windows
        Exit Function
    End Select

    '(1) Prfen, ob die dll im Installationsverzeichnis von Gs4Word vorhanden ist
    fsPrnadminVorhanden_ermitteln = gsInstVerzeichnis & sPRNADMINDLL
    If Dir(fsPrnadminVorhanden_ermitteln, vbSystem) <> sLEER Then
        Exit Function
    End If

    '(2) Prfen, ob das Resource Kit installiert ist und ob die dll dort vorhanden ist
    ' Das funtioniert nur unter Windows 2000, in Windows XP gibt es einen solchen Pfad in der Registry nicht
    sResKitInstallDir = System.PrivateProfileString(sLEER, _
    "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Reskit\NameSpace\" & sResKitName, _
       "InstallDir")
    If Len(sResKitInstallDir) > 0 Then
        fsPrnadminVorhanden_ermitteln = sResKitInstallDir & sPRNADMINDLL
        If Dir(fsPrnadminVorhanden_ermitteln, vbSystem) <> sLEER Then
            Exit Function
        End If
    End If

    fsPrnadminVorhanden_ermitteln = ""

End Function

Function fbDruckerListe_fuellen(bAuchNeueFlag As Boolean) As Boolean
    'Die Funktion ermittelt alle Drucker fr Gs4Word in der Registry und fllt die Tabelle
    'gsDruckerListe.
    'Die Tabelle wird nach den Namen der Default-Drucker sortiert.
    'Global:
    '   gsNeuerPortName wird gelesen
    '   gbAutomatischeInstallation wird gelesen
    '   gsDefaultDruckerTabelle wird gefllt
    '   gsDruckerListe wird gefllt
    'Argumente:
    '   bAuchNeueFlag
    '   True  = Auch neue Drucker in die Tabelle aufnehmen
    '   False = Keine neuen Drucker in die Tabelle aufnehmen
    'Effekt
    '   keiner
    
    Const sPRINTERSPFAD As String = "System\CurrentControlSet\Control\Print\Printers"
    
    Dim iZaehler1 As Integer
    Dim sTempDruckerListe(99, 1)
    Dim iTempZaehler As Integer
    Dim iTempSuchenZaehler As Integer
    Dim iMaxTempDruckerNr As Integer
    Dim iDruckerZaehler As Integer
    Dim lPfadIndex As Long
    Dim vSubPfadName As Variant
    Dim sEinPrinterPfad As String
    Dim sPrinterName As String
    Dim sPrinterTreiber As String
    Dim iDefaultZaehler As Integer
    Dim iHKeyZaehler As Integer
    Dim lHKeyListe(1) As Long
    Dim DruckerSchonVorhanden As Boolean
    
    lHKeyListe(0) = HKEY_LOCAL_MACHINE
    lHKeyListe(1) = HKEY_CURRENT_USER
    
    ReDim gsDefaultDruckerTabelle(20, 3)
    For iZaehler1 = LBound(gsDefaultDruckerTabelle) To UBound(gsDefaultDruckerTabelle)
        gsDefaultDruckerTabelle(iZaehler1, 0) = sLEER 'Drucker-Name
        gsDefaultDruckerTabelle(iZaehler1, 1) = sLEER 'Drucker-Treiber
        gsDefaultDruckerTabelle(iZaehler1, 2) = sLEER 'Drucker-Hersteller
        gsDefaultDruckerTabelle(iZaehler1, 3) = sLEER 'Drucker-Installationshinsweis
    Next iZaehler1
    'Die Liste muss mit einem Eintrag enden, in dem beide Spalten leer sind.
    gsDefaultDruckerTabelle(0, 0) = "Generic PostScript Printer CMYK"
    gsDefaultDruckerTabelle(1, 0) = "Generic Colour PostScript" 'Drucker-Name
    gsDefaultDruckerTabelle(2, 0) = sGS4WORDPOSTSCRIPTPRINTER
    gsDefaultDruckerTabelle(3, 0) = "Adobe PostScript Printer"
    gsDefaultDruckerTabelle(4, 0) = "Generic PostScript Printer"
    gsDefaultDruckerTabelle(5, 0) = sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "Apple Color LW 12/660 PS"
    gsDefaultDruckerTabelle(6, 0) = sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "Apple LaserWriter II NT"
    gsDefaultDruckerTabelle(7, 0) = sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "HP Color LaserJet 8500 PS"
    gsDefaultDruckerTabelle(8, 0) = sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "HP Color LaserJet 5/5M PS"
    gsDefaultDruckerTabelle(9, 0) = sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "Xerox DocuTech 135 PS2"
    gsDefaultDruckerTabelle(10, 0) = "Apple Color LW 12/660 PS"
    gsDefaultDruckerTabelle(11, 0) = "Apple LaserWriter II NT"
    gsDefaultDruckerTabelle(12, 0) = "HP Color LaserJet 5/5M PS"
    gsDefaultDruckerTabelle(13, 0) = "HP Color LaserJet 8500 PS" 'das ist der gleiche Drucker wie HP CLJ 8500 - PS
    gsDefaultDruckerTabelle(14, 0) = "HP CLJ 8500 - PS" 'das ist der gleiche Drucker wie HP Color LaserJet 8500 PS
    gsDefaultDruckerTabelle(15, 0) = "Xerox DocuTech 135 PS2"
    If bAuchNeueFlag = True Then
        Select Case LCase(System.OperatingSystem)
        Case "windows"
            'Windows Plattform 1
            Select Case Left(System.Version, 3)
            Case "4.0" ' Windows 95
                    gsDefaultDruckerTabelle(16, 0) = sTEXT_NEUERDRUCKERPRAEFIX_1 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "Apple LaserWriter II NT"
                    gsDefaultDruckerTabelle(16, 1) = "Apple LaserWriter II NT" '95, 98
                    gsDefaultDruckerTabelle(16, 2) = "Apple"
                    gsDefaultDruckerTabelle(16, 3) = sTEXT_INSTALLHINWEIS_95 & "&&" & sTEXT_BIDIREKTIONAL_95
            Case "4.1" ' Windows 98
                If gbAutomatischeInstallation = False Then
                    gsDefaultDruckerTabelle(16, 0) = sTEXT_NEUERDRUCKERPRAEFIX_1 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "Apple Color LW 12/660 PS"
                    gsDefaultDruckerTabelle(16, 1) = "Apple Color LW 12/660 PS" '98, ME, 2000 und XP
                    gsDefaultDruckerTabelle(16, 2) = "Apple"
                    gsDefaultDruckerTabelle(16, 3) = sTEXT_INSTALLHINWEIS_98 & "&&" & sTEXT_BIDIREKTIONAL_98
                    gsDefaultDruckerTabelle(17, 0) = sTEXT_NEUERDRUCKERPRAEFIX_1 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "HP Color LaserJet 5/5M PS"
                    gsDefaultDruckerTabelle(17, 1) = "HP Color LaserJet 5/5M PS" '98, ME, NT40, 2000 und XP
                    gsDefaultDruckerTabelle(17, 2) = "HP"
                    gsDefaultDruckerTabelle(17, 3) = sTEXT_INSTALLHINWEIS_98 & "&&" & sTEXT_BIDIREKTIONAL_98
                End If
            Case "4.9" ' Windows ME
                If gbAutomatischeInstallation = False Then
                    gsDefaultDruckerTabelle(16, 0) = sTEXT_NEUERDRUCKERPRAEFIX_1 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "Apple Color LW 12/660 PS"
                    gsDefaultDruckerTabelle(16, 1) = "Apple Color LW 12/660 PS" '98, ME, 2000 und XP
                    gsDefaultDruckerTabelle(16, 2) = "Apple"
                    gsDefaultDruckerTabelle(16, 3) = sTEXT_INSTALLHINWEIS_ME & "&&" & sTEXT_BIDIREKTIONAL_ME
                    gsDefaultDruckerTabelle(17, 0) = sTEXT_NEUERDRUCKERPRAEFIX_1 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "HP Color LaserJet 5/5M PS"
                    gsDefaultDruckerTabelle(17, 1) = "HP Color LaserJet 5/5M PS" '98, ME, NT40, 2000 und XP
                    gsDefaultDruckerTabelle(17, 2) = "HP"
                    gsDefaultDruckerTabelle(17, 3) = sTEXT_INSTALLHINWEIS_ME & "&&" & sTEXT_BIDIREKTIONAL_ME
                End If
            End Select
        Case "windows nt"
            'Windows Plattform 2,
            Select Case Left(System.Version, 3)
            Case "3.5" ' Windows NT 3.51 Ungetestet; wer hat noch NT 3.51 ?
            Case "4.0" ' Windows NT 4.0
                If gbAutomatischeInstallation = False Then
                    gsDefaultDruckerTabelle(16, 0) = sTEXT_NEUERDRUCKERPRAEFIX_1 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "HP Color LaserJet 5/5M PS"
                    gsDefaultDruckerTabelle(16, 1) = "HP Color LaserJet 5/5M PS" '98, ME, NT40, 2000 und XP
                    gsDefaultDruckerTabelle(16, 2) = "HP"
                    gsDefaultDruckerTabelle(16, 3) = sTEXT_INSTALLHINWEIS_NT & "&&" & sTEXT_BIDIREKTIONAL_NT
                End If
            Case "5.0" ' Windows 2000
                gsDefaultDruckerTabelle(16, 0) = sTEXT_NEUERDRUCKERPRAEFIX_2 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "Apple Color LW 12/660 PS"
                gsDefaultDruckerTabelle(16, 1) = "Apple Color LW 12/660 PS" '98, ME, 2000 und XP
                gsDefaultDruckerTabelle(17, 0) = sTEXT_NEUERDRUCKERPRAEFIX_2 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "HP Color LaserJet 5/5M PS"
                gsDefaultDruckerTabelle(17, 1) = "HP Color LaserJet 5/5M PS" '98, ME, NT40, 2000 und XP
                gsDefaultDruckerTabelle(18, 0) = sTEXT_NEUERDRUCKERPRAEFIX_2 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "Xerox DocuTech 135 PS2"
                gsDefaultDruckerTabelle(18, 1) = "Xerox DocuTech 135 PS2" '2000 und XP
            Case "5.1" ' Windows XP
                gsDefaultDruckerTabelle(16, 0) = sTEXT_NEUERDRUCKERPRAEFIX_2 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "Apple Color LW 12/660 PS"
                gsDefaultDruckerTabelle(16, 1) = "Apple Color LW 12/660 PS" '98, ME, 2000 und XP
                gsDefaultDruckerTabelle(17, 0) = sTEXT_NEUERDRUCKERPRAEFIX_2 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "HP Color LaserJet 8500 PS"
                gsDefaultDruckerTabelle(17, 1) = "HP Color LaserJet 8500 PS" 'Nur XP
                gsDefaultDruckerTabelle(18, 0) = sTEXT_NEUERDRUCKERPRAEFIX_2 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "HP Color LaserJet 5/5M PS"
                gsDefaultDruckerTabelle(18, 1) = "HP Color LaserJet 5/5M PS" '98, ME, NT40, 2000 und XP
                gsDefaultDruckerTabelle(19, 0) = sTEXT_NEUERDRUCKERPRAEFIX_2 & sGS4WORDPOSTSCRIPTPRINTER & sSPACE & "Xerox DocuTech 135 PS2"
                gsDefaultDruckerTabelle(19, 1) = "Xerox DocuTech 135 PS2" '2000 und XP
            End Select
        End Select
    End If
    
    fbDruckerListe_fuellen = False
    iTempZaehler = -1
    'Alle Drucke aus der Registry suchen
    For iHKeyZaehler = LBound(lHKeyListe) To UBound(lHKeyListe)
        lPfadIndex = 0
        Do While True
            'in lHKeyListe(iHKeyZaehler) steht entweder HKEY_LOCAL_MACHINE oder HKEY_CURRENT_USER
            vSubPfadName = fvRegistry_SubPfadNummerLesen(lHKeyListe(iHKeyZaehler), sPRINTERSPFAD, lPfadIndex)
            If IsNull(vSubPfadName) = True Then 'fertig
                Exit Do
            End If
            sEinPrinterPfad = sPRINTERSPFAD & "\" & CStr(vSubPfadName)
            sPrinterName = fvRegistry_WertLesen(lHKeyListe(iHKeyZaehler), sEinPrinterPfad, "Name", NEVER_RETURN_NULL)
            sPrinterTreiber = fvRegistry_WertLesen(lHKeyListe(iHKeyZaehler), sEinPrinterPfad, "Printer Driver", NEVER_RETURN_NULL)
            'Prfen ob sPrinterName schon in der sTempDruckerListe vorhanden ist
            If iTempZaehler > -1 _
            And iHKeyZaehler > LBound(lHKeyListe) Then
                For iTempSuchenZaehler = LBound(sTempDruckerListe) To iTempZaehler
                    If LCase(sTempDruckerListe(iTempSuchenZaehler, 0)) = LCase(sPrinterName) Then
                        sPrinterName = sLEER
                        sPrinterTreiber = sLEER
                        Exit For
                    End If
                Next iTempSuchenZaehler
            End If
            If sPrinterName <> sLEER Then
                iTempZaehler = iTempZaehler + 1
                'Prfen ob mehr als 99 Drucker gefunden wurden
                If iTempZaehler > UBound(sTempDruckerListe) Then
                    Exit Do
                End If
                sTempDruckerListe(iTempZaehler, 0) = sPrinterName
                sTempDruckerListe(iTempZaehler, 1) = sPrinterTreiber
            End If
            lPfadIndex = lPfadIndex + 1
        Loop
    Next iHKeyZaehler
    
    'Wenn kein Drucker "Generic PostScript Printer" vorhanden ist
    'und wenn ein passender Port installiert werden kann
    'dann weitere Eintrge machen
    'Installierbare Drucker eintragen
    If gsNeuerPortName <> sLEER Then
        For iDefaultZaehler = LBound(gsDefaultDruckerTabelle) To UBound(gsDefaultDruckerTabelle)
            If gsDefaultDruckerTabelle(iDefaultZaehler, 1) <> sLEER Then
                'Druckertreiber eingetragen -> Neuer Drucker
                DruckerSchonVorhanden = False
                For iZaehler1 = 0 To iTempZaehler
                    If sTEXT_NEUERDRUCKERPRAEFIX_1 & sTempDruckerListe(iZaehler1, 0) _
                    = gsDefaultDruckerTabelle(iDefaultZaehler, 0) _
                    Or sTEXT_NEUERDRUCKERPRAEFIX_2 & sTempDruckerListe(iZaehler1, 0) _
                    = gsDefaultDruckerTabelle(iDefaultZaehler, 0) Then
                        'Drucker ist schon vorhanden - nicht nochmal eintragen
                        DruckerSchonVorhanden = True
                        Exit For
                    End If
                Next iZaehler1
                If DruckerSchonVorhanden = False _
                And iTempZaehler + 1 <= UBound(sTempDruckerListe) _
                And Not (Left(System.Version, 3) = "5.0" _
                    And gsDefaultDruckerTabelle(iDefaultZaehler, 1) = "HP Color LaserJet 8500 PS") Then
                    iTempZaehler = iTempZaehler + 1
                    sTempDruckerListe(iTempZaehler, 0) = gsDefaultDruckerTabelle(iDefaultZaehler, 0)
                    sTempDruckerListe(iTempZaehler, 1) = gsDefaultDruckerTabelle(iDefaultZaehler, 1)
                End If
            End If
        Next iDefaultZaehler
                
    End If
    
    iMaxTempDruckerNr = iTempZaehler
    If iMaxTempDruckerNr > -1 Then
        ReDim gsDruckerListe(iMaxTempDruckerNr)
        iDruckerZaehler = -1
        'Postscript-Drucker sortiert nach DefaultListe in die gsDruckerListe stellen
        For iDefaultZaehler = LBound(gsDefaultDruckerTabelle) To UBound(gsDefaultDruckerTabelle)
            For iTempZaehler = 0 To iMaxTempDruckerNr
                If (gsDefaultDruckerTabelle(iDefaultZaehler, 0) <> sLEER _
                And gsDefaultDruckerTabelle(iDefaultZaehler, 1) <> sLEER _
                And LCase(sTempDruckerListe(iTempZaehler, 0)) _
                = LCase(gsDefaultDruckerTabelle(iDefaultZaehler, 0)) _
                And LCase(sTempDruckerListe(iTempZaehler, 1)) _
                = LCase(gsDefaultDruckerTabelle(iDefaultZaehler, 1))) _
                Or (gsDefaultDruckerTabelle(iDefaultZaehler, 0) = sLEER _
                And gsDefaultDruckerTabelle(iDefaultZaehler, 1) <> sLEER _
                And LCase(sTempDruckerListe(iTempZaehler, 1)) _
                = LCase(gsDefaultDruckerTabelle(iDefaultZaehler, 1))) _
                Or (gsDefaultDruckerTabelle(iDefaultZaehler, 0) <> sLEER _
                And gsDefaultDruckerTabelle(iDefaultZaehler, 1) = sLEER _
                And LCase(sTempDruckerListe(iTempZaehler, 0)) _
                = LCase(gsDefaultDruckerTabelle(iDefaultZaehler, 0))) _
                Or (gsDefaultDruckerTabelle(iDefaultZaehler, 0) = sLEER _
                And gsDefaultDruckerTabelle(iDefaultZaehler, 1) = sLEER _
                And sTempDruckerListe(iTempZaehler, 0) <> sLEER) _
                Then
                    If iDruckerZaehler = -1 Then
                        'Ist der erste Eintrag ein PostScript-Drucker?
                        If gsDefaultDruckerTabelle(iDefaultZaehler, 0) <> sLEER _
                        Or gsDefaultDruckerTabelle(iDefaultZaehler, 1) <> sLEER Then
                            fbDruckerListe_fuellen = True
                        End If
                    End If
                    iDruckerZaehler = iDruckerZaehler + 1
                    gsDruckerListe(iDruckerZaehler) = sTempDruckerListe(iTempZaehler, 0)
                    sTempDruckerListe(iTempZaehler, 0) = sLEER
                    sTempDruckerListe(iTempZaehler, 1) = sLEER
                End If
            Next iTempZaehler
        Next iDefaultZaehler
'For iDruckerZaehler = LBound(gsDruckerListe) To UBound(gsDruckerListe)
'   MsgBox iDruckerZaehler & "=" & gsDruckerListe(iDruckerZaehler)
'Next iDruckerZaehler
    Else
        ReDim gsDruckerListe(0)
    End If

End Function

Function fsDruckerInstallieren_ermitteln(sPSDruckerName) As String
    'Die Funktion prft, ob der Drucker in sPSDruckerName in der Druckertabelle gsDruckerTabelle
    'und gsDefaultDruckerTabelle vorhanden ist und ob dort ein Treiber eingetragen ist.
    'Global:
    '   gsDruckerListe wird gelesen
    'Argumente:
    '   sPSDruckerName ist der Name des neuen Druckers wie er im Dialog angezeigt wird
    '   sPortName ist der Name des Druckerports sPORTNUL oder sPORTGS4WORD
    'Rckgabewert:
    '   Treibername  = DruckerTreiber zur Installation.
    '   "" = Der Drucker kann nicht installiert werden.
    'Effekt
    '   keiner
    
    Dim iZaehler As Integer
    Dim jZaehler As Integer
    
    fsDruckerInstallieren_ermitteln = sLEER
    
    If sPSDruckerName <> sLEER Then
        For iZaehler = LBound(gsDruckerListe) To UBound(gsDruckerListe)
            If sPSDruckerName = gsDruckerListe(iZaehler) Then
                For jZaehler = LBound(gsDefaultDruckerTabelle, 1) To UBound(gsDefaultDruckerTabelle, 1)
                    If sPSDruckerName = gsDefaultDruckerTabelle(jZaehler, 0) Then
                        fsDruckerInstallieren_ermitteln = gsDefaultDruckerTabelle(jZaehler, 1)
                        Exit Function
                    End If
                Next jZaehler
            End If
        Next iZaehler
    End If
End Function
        
Function fbDruckerPostscript_ermitteln(sPSDruckerName) As Boolean
    'Die Funktion prft, ob der Drucker in sPSDruckerName in der Druckertabelle gsDruckerTabelle
    'und gsDefaultDruckerTabelle vorhanden ist. Dann ist es ein Postscript-Drucker.
    'Global:
    '   gsDruckerListe wird gelesen
    'Argumente:
    '   sPSDruckerName ist der Name des neuen Druckers wie er im Dialog angezeigt wird
    'Rckgabewert:
    '   True = Es ist ein Postscript-Drucker
    '   False = Es ist kein Postscript-Drucker
    'Effekt
    '   keiner
    
    Dim iZaehler As Integer
    Dim jZaehler As Integer
    
    fbDruckerPostscript_ermitteln = False
    
    If sPSDruckerName <> sLEER Then
        For iZaehler = LBound(gsDruckerListe) To UBound(gsDruckerListe)
            If sPSDruckerName = gsDruckerListe(iZaehler) Then
                For jZaehler = LBound(gsDefaultDruckerTabelle, 1) To UBound(gsDefaultDruckerTabelle, 1)
                    If sPSDruckerName = gsDefaultDruckerTabelle(jZaehler, 0) Then
                        fbDruckerPostscript_ermitteln = True
                        Exit Function
                    End If
                Next jZaehler
            End If
        Next iZaehler
    End If
        
End Function

Function fsDialogDruckerInstallationstext_ermitteln(sPSDruckerName As String, sPortName As String) As String
    'Die Funktion prft, ob der Drucker in sPsPSDruckerName in der Druckertabelle gsDruckerTabelle
    'und gsDefaultDruckerTabelle vorhanden ist und ob dazu ein Installationstext existiert.
    'Dann wird der Drucker im Diamlig installiert.
    'Global:
    '   gsDruckerListe wird gelesen
    'Argumente:
    '   sPSDruckerName ist der Name des neuen Druckers wie er im Dialog angezeigt wird
    '   sPortName ist der Name des Druckerports sPORTNUL oder sPORTGS4WORD
    'Rckgabewert:
    '   Installationstest  = Text zur Installation.
    '   "" = Der Drucker wird nicht im Dialog sondern automatisch installiert.
    'Effekt
    '   keiner
    
    Dim iZaehler As Integer
    Dim jZaehler As Integer
    
    fsDialogDruckerInstallationstext_ermitteln = sLEER
    
    If sPSDruckerName <> sLEER Then
        For iZaehler = LBound(gsDruckerListe) To UBound(gsDruckerListe)
            If sPSDruckerName = gsDruckerListe(iZaehler) Then
                For jZaehler = LBound(gsDefaultDruckerTabelle, 1) To UBound(gsDefaultDruckerTabelle, 1)
                    If sPSDruckerName = gsDefaultDruckerTabelle(jZaehler, 0) _
                    And gsDefaultDruckerTabelle(jZaehler, 3) <> sLEER Then
                        fsDialogDruckerInstallationstext_ermitteln = fsText(gsDefaultDruckerTabelle(jZaehler, 3), gsDefaultDruckerTabelle(jZaehler, 2), gsDefaultDruckerTabelle(jZaehler, 1), sPortName)
                        Exit Function
                    End If
                Next jZaehler
            End If
        Next iZaehler
    End If
        
End Function

Function fsNeuenDrucker_installieren_dialog(sPSDruckerName As String, sInstallationstext As String, sPortName As String) As String
    'Die Funktion zeigt an, wie der Drucker sPSDruckerName an Port sPortName installiert werden muss.
    'Argumente:
    '   sPSDruckerName ist der Name des neuen Druckers
    '   sInstallationstext ist der Installationstext
    '   sPortName ist der Name des Druckerports sPORTNUL oder sPORTGS4WORD
    'Rckgabewert:
    '   "" = Aufgabe erledigt
    '   Text = Es ist ein Fehler aufgetreten
    'Effekt
    '   sInstallationstext wird angezeigt
    '   Drucker wurde ggf. installiert
    
    Dim sText1 As String
    Dim sText2 As String
    Dim lPosition As Long
    
    
    lPosition = flLetztesVorkommen_suchen(sInstallationstext, "&&")
    If lPosition > 2 Then
        sText1 = Left(sInstallationstext, lPosition - 1)
        sText2 = Mid(sInstallationstext, lPosition + 2)
    Else
        sText1 = sInstallationstext
        sText2 = sLEER
    End If
    
    If sText1 <> sLEER Then
        MsgBox sText1 _
            , vbInformation, sTITEL_DRUCKERINSTALLIEREN
    End If
    
    If fsDruckerPort_ermitteln(sPSDruckerName) <> sLEER Then
        If sText2 <> sLEER Then
            MsgBox sText2 _
                , vbInformation, sTITEL_DRUCKERINSTALLIEREN
        End If
        fsNeuenDrucker_installieren_dialog = sLEER
    Else
        fsNeuenDrucker_installieren_dialog = fsText(sMSG_SIEHABENDRUCKERNICHTANGELEGT, sPSDruckerName, sPortName)
    End If
        
End Function

Function fsNeuenDrucker_installieren_auto(sPSDruckerName As String, sPSTreiberName As String, sPortName As String) As String
    'Die Funktion installiert den Drucker sPSDruckerName mit dem Treiber sPSTreiberName.
    'Argumente:
    '   sPSDruckerName ist der Name des neuen Druckers
    '   sPSTreiberName ist der Name des Treibers. Er muss vorhanden sein.
    '   sPortName ist der Name des Druckerports sPORTNUL oder sPORTGS4WORD
    'Rckgabewert:
    '   "" = Aufgabe erledigt
    '   Text = Es ist ein Fehler aufgetreten
    'Effekt
    '   Drucker wurde ggf. installiert
    
    Dim vtaskId As Variant 'Task-ID eines mit Shell aufgerufenen Programms
    Dim sRegsvrAufruf As String
    Dim iWartezeit As Integer
    Dim sPrnadminDatei As String
                                 
    'rundll32 printui.dll,PrintUIEntry /if /b "Apple Color LW 12/660 PS" /f "C:\WINNT\inf\ntprint.inf" /r "lpt1:" /m "Apple Color LW 12/660 PS"
    sRegsvrAufruf = "rundll32 printui.dll,PrintUIEntry /if /b " _
    & Chr(34) & sPSDruckerName & Chr(34) _
    & " /f " _
    & Chr(34) & Environ("systemroot") & gsPathSeparator & "inf\ntprint.inf" & Chr(34) _
    & " /r " _
    & Chr(34) & sPortName & Chr(34) _
    & " /m " _
    & Chr(34) & sPSTreiberName & Chr(34)
    vtaskId = Shell(sRegsvrAufruf, 4)
    If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
        'Shell wird asynchron verarbeitet, deshalb zuerst solange warten, bis das Programm
        'den Port eingetragen hat.
        For iWartezeit = 1 To giMaxRechnerWartezeit * 2 Step 1
            Call fbWarten(1)  'In der Schleife immer eine Sekunde warten
            'Prfen ob Redmon schon komplett ausgepackt ist
            If fsDruckerPort_ermitteln(sPSDruckerName) <> sLEER Then
                Exit For
            End If
        Next iWartezeit
    End If
    
    If fsDruckerPort_ermitteln(sPSDruckerName) <> sLEER Then
        fsNeuenDrucker_installieren_auto = sLEER
    Else
        fsNeuenDrucker_installieren_auto = fsText(sMSG_KONNTEDRUCKERNICHTANLEGEN, sPSDruckerName, sPortName, sRegsvrAufruf)
    End If
        
End Function

'Function fsNeuenDrucker_installieren_MitPrnadmin(sPSDruckerName As String, sPSTreiberName As String) As String
'    'Die Funktion installiert ggf. Port sPORTNUL und den Drucker sPSDruckerName
'    'mit den Treiber sPSTreiberName.
'    'Argumente:
'    '   sPSDruckerName ist der Name des neuen Druckers
'    '   sPSTreiberName ist der Name des Treibers. Er muss vorhanden sein.
'    'Global:
'    '   sPORTNUL wird gelesen
'    '   gsPSDruckerName wird gelesen und gendert
'    'Rckgabewert:
'    '   fsNeuenDrucker_installieren =  "" = Aufgabe erledigt
'    '   fsNeuenDrucker_installieren <> "" = Es ist eine Fehler aufgetreten
'    'Effekt
'    '   keiner
'
'    Dim oMaster As Object
'    Dim oPort As Object
'    Dim oPrinter As Object
'    Dim vtaskId As Variant 'Task-ID eines mit Shell aufgerufenen Programms
'    Dim sRegsvrAufruf As String
'    Dim iFehlerNummer As Integer 'Fehlernumer aus GetAttr()
'    Dim sPrnadminDatei As String
'
'    fsNeuenDrucker_installieren_MitPrnadmin = ""
'
'    'Prfen ob prmadmin.dll schon registriert ist
'    On Error Resume Next
'    Set oMaster = CreateObject("PrintMaster.PrintMaster.1")
'    iFehlerNummer = Err.Number
'    On Error GoTo 0
'    If iFehlerNummer <> 0 Then
'        sPrnadminDatei = fsPrnadmin_ermitteln
'        sRegsvrAufruf = "regsvr32 /s " & Chr(34) & sPrnadminDatei & Chr(34)
'        vtaskId = Shell(sRegsvrAufruf, 4)
'        If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
'            'Shell wird asynchron verarbeitet, deshalb zuerst solange warten, bis das Programm
'            'gestartet ist.
'            Call fbWarten(1)
'        End If
'        On Error Resume Next
'        Set oMaster = CreateObject("PrintMaster.PrintMaster.1")
'        iFehlerNummer = Err.Number
'        On Error GoTo 0
'        If iFehlerNummer <> 0 Then
'            'Fehler: PrnAdmin konnte nicht registriert werden
'            fsNeuenDrucker_installieren_MitPrnadmin = fsText(sMSG_KONNTEPRNADMINNICHTREGISTRIEREN _
'                , sRegsvrAufruf)
'            Exit Function
'        End If
'    Else
'        sPrnadminDatei = ""
'    End If
'
'    'Siehe Microsoft Kowledge Base Artikel 321025:
'    '   HOW TO: Programmatically Create a Printe and e Printer Port by Using PrinterA
'    '   (Prnadmin.dll) with a Basic Script in Microsoff Windows 2000
'
'    If fbPortNUL_ermitteln = False Then
'        'auch Port NUL: fehlt noch
'
'        Set oPort = CreateObject("Port.Port.1")
'        oPort.PortName = sPORTNUL
'        oPort.PortType = 3 'local
'
'        On Error Resume Next
'        oMaster.PortAdd oPort
'        iFehlerNummer = Err.Number
'        On Error GoTo 0
'        If iFehlerNummer <> 0 Then
'            'Fehler: Port konnte nicht angelegt werden
'            fsNeuenDrucker_installieren_MitPrnadmin = fsText(sMSG_KONNTEPORTNICHTMITPRNADMINANLEGEN _
'                , sPORTNUL, Error(iFehlerNummer))
'        End If
'    End If
'
'    If iFehlerNummer = 0 Then
'        Set oPrinter = CreateObject("Printer.Printer.1")
'
'        oPrinter.PrinterName = sPSDruckerName
'        oPrinter.DriverName = sPSTreiberName
'        oPrinter.PortName = sPORTNUL
'
'        On Error Resume Next
'        oMaster.PrinterAdd oPrinter
'        iFehlerNummer = Err.Number
'        On Error GoTo 0
'        If iFehlerNummer <> 0 Then
'            'Fehler: Drucker konnte nicht angelegt werden
'            fsNeuenDrucker_installieren_MitPrnadmin = fsText(sMSG_KONNTEDRUCKERNICHTANLEGEN _
'                , sPSDruckerName, sPORTNUL, Error(iFehlerNummer))
'        End If
'    End If
'
'    If sPrnadminDatei <> "" Then
'        sRegsvrAufruf = "regsvr32 /s /u " & Chr(34) & sPrnadminDatei & Chr(34)
'        vtaskId = Shell(sRegsvrAufruf, 4)
'        If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
'            'Shell wird asynchron verarbeitet, deshalb zuerst solange warten, bis das Programm
'            'gestartet ist.
'            Call fbWarten(1)
'        End If
'    End If
'
'End Function
'
Function fsVerknuepfung_ermitteln(sVerknuepfung As String, sName As String) As String
    'Die Funktion gibt den Namen des Programms zurck, mit dem sVerknpfung verknpft ist. Dabei
    'wird die Environment-Variable SYSTEMROOT aufgelst, wenn sie an Anfang steht. Das Programm
    'muss vorhanden sein.
    'Wenn sName nicht leer ist, wird sName fr den hinter dem Programmnamen stehenden Parameter
    '   %1 (z.B. %1 oder /r "%1") eingesetzt. Die Anfhrungszeichen werden nicht ersetzt.
    'Wenn sName leer ist, wird nur der Programmname ohne Anfhrungszeichen zurckgegeben.
    'Argumente:
    '   sVerknpfung = Name der Verknpfung. Der Name beginnt mit einem Punkt
    '   sName = leer oder Dateiname mit Pfad
    'Rckgabewert:
    '   sLEER = Es konnte kein zugeordnetes Programm ermittelt werden.
    '   xx..xx = Name des zugeordneten Programms und ggf. der aufzurufenfen Datei.
    'Effekt
    '   keiner
       
    Dim sWert As String
    Dim sRegistryWert As String
    Dim sProgramm As String
    Dim lPosition As Long

    fsVerknuepfung_ermitteln = sLEER
    
    sWert = System.PrivateProfileString(sLEER, "HKEY_LOCAL_MACHINE\SOFTWARE\classes\" _
        & sVerknuepfung, sLEER)
    sRegistryWert = System.PrivateProfileString(sLEER, _
        "HKEY_LOCAL_MACHINE\SOFTWARE\classes\" & sWert & "\shell\open\command", sLEER)
    'Der Dateiname darf in Anfhrungszeichen (") stehen.
    'entweder 'xxx.exe %1' oder '"xxx" "%1"' oder '%systemroot%\xxx %1' oder eine Kombination
    sRegistryWert = Trim(sRegistryWert)
    If LCase(Left(sRegistryWert, 12)) = LCase("%systemroot%") Then
        sRegistryWert = Environ("systemroot") & gsPathSeparator & Mid(sRegistryWert, 13)
    ElseIf LCase(Left(sRegistryWert, 13)) = Chr(34) & LCase("%systemroot%") Then
        sRegistryWert = Chr(34) & Environ("systemroot") & gsPathSeparator & Mid(sRegistryWert, 14)
    End If
    sProgramm = sRegistryWert & sSPACE

    If Left(sProgramm, 1) = Chr(34) Then 'Programmname ist in Anfhrungszeichen eingeschossen
        sProgramm = Mid(sProgramm, 2) 'erstes Anfhrungszeichen entfernen
        lPosition = InStr(sProgramm, Chr(34)) 'zweites Anfhrungszeichen suchen
    Else
        lPosition = InStr(sProgramm, sSPACE)  'erstes Leerzeichen suchen
    End If
    If lPosition > 0 Then
        sProgramm = Left(sProgramm, lPosition - 1)
        If Dir(sProgramm, vbNormal) <> sLEER Then
            If sName = sLEER Then
                fsVerknuepfung_ermitteln = sProgramm
            Else
                lPosition = flLetztesVorkommen_suchen(sRegistryWert, "%1")
                If lPosition > 0 Then
                    fsVerknuepfung_ermitteln = Left(sRegistryWert, lPosition - 1) _
                        & sName & Mid(sRegistryWert & sSPACE, lPosition + 2)
                Else
                    fsVerknuepfung_ermitteln = sRegistryWert & sSPACE & sName
                End If
            End If
        End If
    End If

End Function

Function fbGhostscriptListe_fuellen(bAuchNeueFlag As Boolean) As Boolean
    'Die Funktion ermittelt alle Ghostscript-Installationen und fllt die Tabelle gsDefaultGhostscriptTabelle
    'und die Tabelle gsGhostscriptListe
    'Die Tabellen sind nach den Ghostscript-Versionen sortiert.
    'Global:
    '   gsInstVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    '   gsDefaultGhostscriptTabelle wird gefllt
    '   gsGhostscriptListe wird gefllt
    'Argumente:
    '   bAuchNeueFlag
    '   True  = Auch neue Ghostscript-Installtionen in die Tabelle aufnehmen
    '   False = Keine neuen Ghostscript-Installtionen in die Tabelle aufnehmen
    'Rckgabewert:
    '   True  = Tabelle gefllt.
    '   False = Tabelle ist leer.
    'Effekt
    '   keiner
        
    Const sUNZIPFILE As String = "unzip.exe"
    Const sGSWIN32 As String = "gswin32.exe"
    Const sGSWIN32C As String = "gswin32c.exe"
    Const sAFPLGHOSTSRIPTNAME As String = "AFPL Ghostscript"
    Const sGNUGHOSTSRIPTNAME As String = "GNU Ghostscript"
    Const sGPLGHOSTSRIPTNAME As String = "GPL Ghostscript"
    
    Dim sUnzipProgrammName As String
    Dim sUnzipAufruf As String
    Dim iZaehler As Integer
    Dim iTempZaehler As Integer
    Dim sGSDefaultLaufwerk As String
    Dim sDummy As String
    Dim iFehlerNummer As Integer
    Dim sGSProgrammLizenz As String
    Dim sGSProgrammName As String
    Dim sGSInstProgrammName As String
    Dim sGSInstDirName As String
    Dim sGSProgrammVersion As String
    Dim bGSProgrammInRegistry As Boolean
    Dim sEineVersion As Variant
    Dim sProgramm As String
    Dim sWert As String
    Dim lPosition As Long
    Dim sVersionName(13) As String 'Tabelle mit Versionsnummern von Ghostscript, die passen knnten.
      
    'Nummern der geprften Versionen von Ghostscript
    sVersionName(0) = "8.53"
    sVersionName(1) = "8.51"
    sVersionName(2) = "8.50"
    sVersionName(3) = "8.15"
    sVersionName(4) = "8.14"
    sVersionName(5) = "8.13"
    sVersionName(6) = "8.11"
    sVersionName(7) = "8.00"
    sVersionName(8) = "7.07"
    sVersionName(9) = "7.06"
    sVersionName(10) = "7.05"
    sVersionName(11) = "7.04"
    sVersionName(12) = "7.03"
    sVersionName(13) = "7.00"

    ReDim gsDefaultGhostscriptTabelle(99, 6)
    iZaehler = -1
    
    'Wenn Dir auf ein Laufwerk stt, dass nicht vorhanden ist, dann gibt es einen Fehler
    '- z.B. Netzlaufwerk, auf das nicht zugegriffen werden kann Fehler 52: Dateiname oder -nummer falsch
    '- z.B. Nicht verfgbares Laufwerk Fehler 68: Gert nicht verfgbar
    sGSDefaultLaufwerk = sLEER
    sGSDefaultLaufwerk = Environ("SYSTEMDRIVE")
    If sGSDefaultLaufwerk = sLEER Then
        sGSDefaultLaufwerk = Environ("HOMEDRIVE")
        If sGSDefaultLaufwerk = sLEER Then
            sGSDefaultLaufwerk = Left(Environ("WINDIR"), 2)
        End If
    End If
    sGSDefaultLaufwerk = sGSDefaultLaufwerk & Application.PathSeparator
    On Error Resume Next
    sDummy = Dir(sGSDefaultLaufwerk, vbNormal)
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer <> 0 Then
        sGSDefaultLaufwerk = sLEER
    End If

    For Each sEineVersion In sVersionName
        sGSProgrammVersion = CStr(sEineVersion)
        'erster Versuch: Ghostscript-DLL in der Registry suchen und prfen, ob dort auch das
        'Programm steht.
        'Dabei nach AFPF, GPL und GNU suchen. 8.15 gibt es nur als GPL-Version, 7.05, 7.06, 7.07 gibt es nur als GNU-Version, die anderen nur als AFPL-Versionen
        If sGSProgrammVersion = "8.15" Then
            sGSProgrammLizenz = sGPLGHOSTSRIPTNAME
        ElseIf sGSProgrammVersion = "7.05" _
        Or sGSProgrammVersion = "7.06" _
        Or sGSProgrammVersion = "7.07" _
        Then
            sGSProgrammLizenz = sGNUGHOSTSRIPTNAME
        Else
            sGSProgrammLizenz = sAFPLGHOSTSRIPTNAME
        End If
        sProgramm = System.PrivateProfileString(sLEER, _
            "HKEY_LOCAL_MACHINE\SOFTWARE\" & sGSProgrammLizenz & "\" & sGSProgrammVersion, "GS_DLL")
            'z.B. "HKEY_LOCAL_MACHINE\SOFTWARE\AFPL Ghostscript\7.00"
            'oder "HKEY_LOCAL_MACHINE\SOFTWARE\GNU Ghostscript\7.05"
            'oder "HKEY_LOCAL_MACHINE\SOFTWARE\GLP Ghostscript\8.15"
        If sProgramm <> sLEER Then 'Hier steht die DLL von Ghostscript
            lPosition = flLetztesVorkommen_suchen(sProgramm, gsPathSeparator)
            If lPosition > 0 Then
                sGSProgrammName = Left(sProgramm, lPosition) & sGSWIN32
                'z.B. "C:\Programme\gs\gs7.00\bin\gswin32.exe"
                If Dir(sGSProgrammName, vbNormal) <> sLEER _
                And iZaehler <= 98 Then
                    iZaehler = iZaehler + 1
                    gsDefaultGhostscriptTabelle(iZaehler, 0) = sTXT_GSWIN32NAME
                    gsDefaultGhostscriptTabelle(iZaehler, 1) = sGSProgrammName
                    gsDefaultGhostscriptTabelle(iZaehler, 2) = sGSProgrammLizenz
                    gsDefaultGhostscriptTabelle(iZaehler, 3) = sGSProgrammVersion
                    gsDefaultGhostscriptTabelle(iZaehler, 4) = True
                    gsDefaultGhostscriptTabelle(iZaehler, 5) = sLEER
                    If LCase(gsInstVerzeichnis) = LCase(Left(sGSProgrammName, Len(gsInstVerzeichnis))) Then
                        gsDefaultGhostscriptTabelle(iZaehler, 6) = True
                    Else
                        gsDefaultGhostscriptTabelle(iZaehler, 6) = False
                    End If
                End If
                 sGSProgrammName = Left(sProgramm, lPosition) & sGSWIN32C
                'z.B. "C:\Programme\gs\gs7.00\bin\gswin32c.exe"
                If Dir(sGSProgrammName, vbNormal) <> sLEER _
                And iZaehler <= 98 Then
                    iZaehler = iZaehler + 1
                    gsDefaultGhostscriptTabelle(iZaehler, 0) = sTXT_GSWIN32CNAME
                    gsDefaultGhostscriptTabelle(iZaehler, 1) = sGSProgrammName
                    gsDefaultGhostscriptTabelle(iZaehler, 2) = sGSProgrammLizenz
                    gsDefaultGhostscriptTabelle(iZaehler, 3) = sGSProgrammVersion
                    gsDefaultGhostscriptTabelle(iZaehler, 4) = True
                    gsDefaultGhostscriptTabelle(iZaehler, 5) = sLEER
                    If LCase(gsInstVerzeichnis) = LCase(Left(sGSProgrammName, Len(gsInstVerzeichnis))) Then
                        gsDefaultGhostscriptTabelle(iZaehler, 6) = True
                    Else
                        gsDefaultGhostscriptTabelle(iZaehler, 6) = False
                    End If
                End If
           End If
        End If
        
        If bAuchNeueFlag = True Then
            'zweiter Versuch: Liegen die Ghostscript-Programme in Gs4Word?
            'Dieses Verzeichnis kann im Netzwerk liegen.
            sGSProgrammName = gsInstVerzeichnis & "gs\gs" & sGSProgrammVersion & "\bin\" & sGSWIN32
                'z.B. "P:\Programe\Gs4Word_310\gs\gs8.11\bin\gswin32.exe"
            If Dir(sGSProgrammName, vbNormal) <> sLEER _
            And iZaehler <= 98 Then
                iZaehler = iZaehler + 1
                gsDefaultGhostscriptTabelle(iZaehler, 0) = sTXT_GSWIN32NAME
                gsDefaultGhostscriptTabelle(iZaehler, 1) = sGSProgrammName
                gsDefaultGhostscriptTabelle(iZaehler, 2) = sGSProgrammLizenz
                gsDefaultGhostscriptTabelle(iZaehler, 3) = sGSProgrammVersion
                gsDefaultGhostscriptTabelle(iZaehler, 4) = False
                gsDefaultGhostscriptTabelle(iZaehler, 5) = sLEER
                gsDefaultGhostscriptTabelle(iZaehler, 6) = True
            End If
            sGSProgrammName = gsInstVerzeichnis & "gs\gs" & sGSProgrammVersion & "\bin\" & sGSWIN32C
                'z.B. "P:\Programe\gs\gs8.11\bin\gswin32c.exe"
            If Dir(sGSProgrammName, vbNormal) <> sLEER _
            And iZaehler <= 98 Then
                iZaehler = iZaehler + 1
                gsDefaultGhostscriptTabelle(iZaehler, 0) = sTXT_GSWIN32CNAME
                gsDefaultGhostscriptTabelle(iZaehler, 1) = sGSProgrammName
                gsDefaultGhostscriptTabelle(iZaehler, 2) = sGSProgrammLizenz
                gsDefaultGhostscriptTabelle(iZaehler, 3) = sGSProgrammVersion
                gsDefaultGhostscriptTabelle(iZaehler, 4) = False
                gsDefaultGhostscriptTabelle(iZaehler, 5) = sLEER
                gsDefaultGhostscriptTabelle(iZaehler, 6) = True
            End If
            
            'dritter Versuch: Liegen die Ghostscript-Programme eingepackt in Gs4Word?
            'Dieses Verzeichnis kann im Netzwerk liegen.
            sGSProgrammName = gsInstVerzeichnis & "gs\gs" & sGSProgrammVersion & "\bin\" & sGSWIN32
            sGSInstProgrammName = gsInstVerzeichnis & "gs" & Left(sGSProgrammVersion, 1) & Right(sGSProgrammVersion, 2) & "w32.exe"
            sGSInstDirName = gsInstVerzeichnis & "gs"
                'z.B. "P:\Programe\Gs4Word_310\gs811w32.exe"
            sUnzipProgrammName = gsInstVerzeichnis & sUNZIPFILE
            sUnzipAufruf = Chr(34) & sUnzipProgrammName & Chr(34) & " -o -d " & Chr(34) & sGSInstDirName & Chr(34) & sSPACE & Chr(34) & sGSInstProgrammName & Chr(34)
            If Dir(sUnzipProgrammName, vbNormal) <> sLEER _
            And Dir(sGSInstProgrammName, vbNormal) <> sLEER _
            And Dir(sGSInstDirName, vbDirectory) = sLEER _
            And iZaehler <= 97 Then
                iZaehler = iZaehler + 1
                gsDefaultGhostscriptTabelle(iZaehler, 0) = sTXT_GSWIN32NAME
                gsDefaultGhostscriptTabelle(iZaehler, 1) = sGSProgrammName
                gsDefaultGhostscriptTabelle(iZaehler, 2) = sGSProgrammLizenz
                gsDefaultGhostscriptTabelle(iZaehler, 3) = sGSProgrammVersion
                gsDefaultGhostscriptTabelle(iZaehler, 4) = False
                gsDefaultGhostscriptTabelle(iZaehler, 5) = sUnzipAufruf
                gsDefaultGhostscriptTabelle(iZaehler, 6) = True
                sGSProgrammName = gsInstVerzeichnis & "gs\gs" & sGSProgrammVersion & "\bin\" & sGSWIN32C
                iZaehler = iZaehler + 1
                gsDefaultGhostscriptTabelle(iZaehler, 0) = sTXT_GSWIN32CNAME
                gsDefaultGhostscriptTabelle(iZaehler, 1) = sGSProgrammName
                gsDefaultGhostscriptTabelle(iZaehler, 2) = sGSProgrammLizenz
                gsDefaultGhostscriptTabelle(iZaehler, 3) = sGSProgrammVersion
                gsDefaultGhostscriptTabelle(iZaehler, 4) = False
                gsDefaultGhostscriptTabelle(iZaehler, 5) = sUnzipAufruf
                gsDefaultGhostscriptTabelle(iZaehler, 6) = True
            End If
            
            'vierter Versuch: Liegen die Ghostscript-Programme in "C:\gs"?
            'Dieses Verzeichnis wird bei der Installation vorgeschlagen.
            sGSProgrammName = sGSDefaultLaufwerk & "gs\gs" & sGSProgrammVersion & "\bin\" & sGSWIN32
                'z.B. "C:\gs\gs7.00\bin\gswin32.exe"
            If Dir(sGSProgrammName, vbNormal) <> sLEER _
            And iZaehler <= 98 Then
                iZaehler = iZaehler + 1
                gsDefaultGhostscriptTabelle(iZaehler, 0) = sTXT_GSWIN32NAME
                gsDefaultGhostscriptTabelle(iZaehler, 1) = sGSProgrammName
                gsDefaultGhostscriptTabelle(iZaehler, 2) = sGSProgrammLizenz
                gsDefaultGhostscriptTabelle(iZaehler, 3) = sGSProgrammVersion
                gsDefaultGhostscriptTabelle(iZaehler, 4) = False
                gsDefaultGhostscriptTabelle(iZaehler, 5) = sLEER
                gsDefaultGhostscriptTabelle(iZaehler, 6) = False
            End If
            sGSProgrammName = sGSDefaultLaufwerk & "gs\gs" & sGSProgrammVersion & "\bin\" & sGSWIN32C
                'z.B. "C:\gs\gs7.00\bin\gswin32c.exe"
            If Dir(sGSProgrammName, vbNormal) <> sLEER _
            And iZaehler <= 98 Then
                iZaehler = iZaehler + 1
                gsDefaultGhostscriptTabelle(iZaehler, 0) = sTXT_GSWIN32CNAME
                gsDefaultGhostscriptTabelle(iZaehler, 1) = sGSProgrammName
                gsDefaultGhostscriptTabelle(iZaehler, 2) = sGSProgrammLizenz
                gsDefaultGhostscriptTabelle(iZaehler, 3) = sGSProgrammVersion
                gsDefaultGhostscriptTabelle(iZaehler, 4) = False
                gsDefaultGhostscriptTabelle(iZaehler, 5) = sLEER
                gsDefaultGhostscriptTabelle(iZaehler, 6) = False
            End If
                
            'fnfter Versuch: Liegen die Ghostscript-Programme im Standard-Programmverzeichnis?
            sProgramm = System.PrivateProfileString(sLEER, _
                "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion", "ProgramFilesDir")
            If sProgramm <> sLEER Then
                sGSProgrammName = sProgramm & "\gs\gs" & sGSProgrammVersion & "\bin\" & sGSWIN32
                'z.B. "C:\Programme\gs\gs7.00\bin\gswin32.exe"
                If Dir(sGSProgrammName, vbNormal) <> sLEER _
                And iZaehler <= 98 Then
                    iZaehler = iZaehler + 1
                    gsDefaultGhostscriptTabelle(iZaehler, 0) = sTXT_GSWIN32NAME
                    gsDefaultGhostscriptTabelle(iZaehler, 1) = sGSProgrammName
                    gsDefaultGhostscriptTabelle(iZaehler, 2) = sGSProgrammLizenz
                    gsDefaultGhostscriptTabelle(iZaehler, 3) = sGSProgrammVersion
                    gsDefaultGhostscriptTabelle(iZaehler, 4) = False
                    gsDefaultGhostscriptTabelle(iZaehler, 5) = sLEER
                    gsDefaultGhostscriptTabelle(iZaehler, 6) = False
                End If
                sGSProgrammName = sProgramm & "\gs\gs" & sGSProgrammVersion & "\bin\" & sGSWIN32C
                'z.B. "C:\Programme\gs\gs7.00\bin\gswin32c.exe"
                If Dir(sGSProgrammName, vbNormal) <> sLEER _
                And iZaehler <= 98 Then
                    iZaehler = iZaehler + 1
                    gsDefaultGhostscriptTabelle(iZaehler, 0) = sTXT_GSWIN32CNAME
                    gsDefaultGhostscriptTabelle(iZaehler, 1) = sGSProgrammName
                    gsDefaultGhostscriptTabelle(iZaehler, 2) = sGSProgrammLizenz
                    gsDefaultGhostscriptTabelle(iZaehler, 3) = sGSProgrammVersion
                    gsDefaultGhostscriptTabelle(iZaehler, 4) = False
                    gsDefaultGhostscriptTabelle(iZaehler, 5) = sLEER
                    gsDefaultGhostscriptTabelle(iZaehler, 6) = False
                End If
            End If
        End If
    Next sEineVersion
    
    If iZaehler = -1 Then
        'Das war wohl nichts
        ReDim gsDefaultGhostscriptTabelle(0, 6)
        iZaehler = 0
        ReDim gsGhostscriptListe(0)
        fbGhostscriptListe_fuellen = False
    Else
        ReDim gsGhostscriptListe(iZaehler)
        For iTempZaehler = LBound(gsDefaultGhostscriptTabelle, 1) To iZaehler
            gsGhostscriptListe(iTempZaehler) = gsDefaultGhostscriptTabelle(iTempZaehler, 2) & sSPACE & gsDefaultGhostscriptTabelle(iTempZaehler, 3) & sSPACE & gsDefaultGhostscriptTabelle(iTempZaehler, 0) & sSPACE & "(" & iTempZaehler + 1 & ")"
            gsDefaultGhostscriptTabelle(iTempZaehler, 0) = gsGhostscriptListe(iTempZaehler)
        Next iTempZaehler
        iZaehler = iZaehler + 1
        fbGhostscriptListe_fuellen = True
    End If
    gsDefaultGhostscriptTabelle(iZaehler, 0) = sLEER
    gsDefaultGhostscriptTabelle(iZaehler, 1) = sLEER
    gsDefaultGhostscriptTabelle(iZaehler, 2) = sLEER
    gsDefaultGhostscriptTabelle(iZaehler, 3) = sLEER
    gsDefaultGhostscriptTabelle(iZaehler, 4) = True 'Hier muss True stehen, damit bei einem unbekannten Programm keine Eintrge in der registry vorgenomen werden
    gsDefaultGhostscriptTabelle(iZaehler, 5) = sLEER
    gsDefaultGhostscriptTabelle(iZaehler, 6) = False 'Hier muss False stehen, damit bei der Deinstallation keine Eintrge aus der Registry gelscht werden
    
End Function

Function fiGhostscriptDefaultNr_ermitteln(sFeldWert As String, iSpalte As Integer) As Integer
    'Die Funktion ermittelt zu sFeldWert aus der Spalte iSpalte die Nummer in der Tabelle gsDefaultGhostscriptTabelle
    'Global:
    '   gsDefaultGhostscriptTabelle wird gelesen
    'Argumente:
    '   sFeldWert = Wert des Feldes
    '               Bei iSpalte = 0 ist es der Anzeigename aus gsDefaultGhostscriptTabelle(n,0)
    '               Bei iSpalte = 1 ist es der Programmname mit Pfad aus gsDefaultGhostscriptTabelle(n,1)
    '   iSpalte = Nummer der Spalte in gsDefaultGhostscriptTabelle
    '               0 enthlt den Ghostscriptnamen fr die Auswahl im Dialog
    '               1 enthlt den Programmnamen mit Pfad
    '               2 enthlt den Lizenznamen fr die Registry "GNU Ghostscript" oder "AFPL Ghostscript"
    '               3 enthlt der Versionsnummer fr die Registry.
    '               4 enthlt ein Flag (True oder False) ob die Version in der Registry eingetragen ist
    '               5 enthlt den Programmaufruf zum Entpacken von Ghostscript
    'Rckgabewert:
    '    Nummer in der Tabelle gsDefaultGhostscriptTabelle
    '       Wenn kein passender Eintrag gefunden wird, steht der Rckgabewert auf
    '       dem letzten Eintrag. Dieser nuss imer leer sein!
    'Effekt
    '   keiner
    
    For fiGhostscriptDefaultNr_ermitteln = LBound(gsDefaultGhostscriptTabelle, 1) To UBound(gsDefaultGhostscriptTabelle, 1)
        If LCase(gsDefaultGhostscriptTabelle(fiGhostscriptDefaultNr_ermitteln, iSpalte)) = LCase(sFeldWert) _
        Or gsDefaultGhostscriptTabelle(fiGhostscriptDefaultNr_ermitteln, iSpalte) = sLEER Then
            Exit Function
        End If
    Next fiGhostscriptDefaultNr_ermitteln
    
End Function

Function fsGhostscriptProgramm_entpacken(sGSProgrammName As String) As String
    'Die Funktion entpackt Ghostscript in Installationsverzeichnis von Gs4Word
    'Global:
    '   gsPathSeparator wird gelesen
    '   gsDefaultGhostscriptTabelle wird gelesen
    'Argumente:
    '   sGSProgrammName = Ghostscript-Programmname
    'Rckgabewert:
    '   "" = Aufgabe erledigt. Ghostscript wurde entpackt.
    '   "fehlertext" = Es ist eine Fehler aufgetreten
    'Effekt
    '   Ggf. wurde Ghostscript im Installationsverzeichnis von Gs4Word entpackt
    
    Dim sGSBinVerzeichnis As String
    Dim sGSDocVerzeichnis As String
    Dim sGSExamplesVerzeichnis As String
    Dim sGSLibVerzeichnis As String
    Dim sGSResourceVerzeichnis As String
    Dim lPosition As Long
    Dim iZaehler As Integer
    Dim iWartezeit As Integer
    Dim sGSInstAufruf As String
    Dim vtaskId As Variant 'Task-ID eines mit Shell aufgerufenen Programms
    
    iZaehler = fiGhostscriptDefaultNr_ermitteln(sGSProgrammName, 1)
    sGSInstAufruf = gsDefaultGhostscriptTabelle(iZaehler, 5)
    If sGSInstAufruf = sLEER Then
        fsGhostscriptProgramm_entpacken = fsText(sMSG_GHOSTSCRIPTKEINENTPACKEN, sGSProgrammName)
        Exit Function
    End If
    
    lPosition = flLetztesVorkommen_suchen(sGSProgrammName, gsPathSeparator)
    If lPosition > 0 Then
        sGSBinVerzeichnis = Left(sGSProgrammName, lPosition)
        'z.B. "C:\Programme\gs\gs7.00\bin\"
        lPosition = flLetztesVorkommen_suchen(Left(sGSBinVerzeichnis, Len(sGSBinVerzeichnis) - 1), gsPathSeparator)
        If lPosition > 0 Then
            sGSExamplesVerzeichnis = Left(sGSBinVerzeichnis, lPosition) & "examples"
            'z.B. "C:\Programme\gs\gs7.00\examples\"
            sGSDocVerzeichnis = Left(sGSBinVerzeichnis, lPosition) & "doc"
            'z.B. "C:\Programme\gs\gs7.00\doc\"
            sGSLibVerzeichnis = Left(sGSBinVerzeichnis, lPosition) & "lib"
            'z.B. "C:\Programme\gs\gs7.00\lib\"
            If gsDefaultGhostscriptTabelle(iZaehler, 3) = "8.53" _
            Or gsDefaultGhostscriptTabelle(iZaehler, 3) = "8.51" _
            Or gsDefaultGhostscriptTabelle(iZaehler, 3) = "8.50" _
            Or gsDefaultGhostscriptTabelle(iZaehler, 3) = "8.14" _
            Or gsDefaultGhostscriptTabelle(iZaehler, 3) = "8.13" _
            Or gsDefaultGhostscriptTabelle(iZaehler, 3) = "8.11" Then
                sGSResourceVerzeichnis = Left(sGSBinVerzeichnis, lPosition) & "Resource"
                'z.B. "C:\Programme\gs\gs8.11\Resource\"
            Else
                sGSResourceVerzeichnis = sGSLibVerzeichnis
            End If
        End If
    End If
    If sGSBinVerzeichnis = sLEER _
    Or sGSDocVerzeichnis = sLEER _
    Or sGSExamplesVerzeichnis = sLEER _
    Or sGSLibVerzeichnis = sLEER _
    Or sGSResourceVerzeichnis = sLEER Then
        fsGhostscriptProgramm_entpacken = fsText(sMSG_GHOSTSCRIPTVERZEICHNISSEFALSCH, sGSProgrammName)
        Exit Function
    End If
    
    vtaskId = Shell(sGSInstAufruf, 4)
    If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
        'Shell wird asynchron verarbeitet, deshalb solange warten, bis alle Ghostscript-Verzeichnisse
        'vorhanden sind. Das wird einmal je Sekunde berprft.
        'Wie lange darauf maximal gewartet wird, ist je Rechner (Prozessortakt) unterschiedlich.
        'Wer eine bessere Idee hat, soll sich bitte melden!
        For iWartezeit = 1 To giMaxRechnerWartezeit * 4 Step 1
            Call fbWarten(1)  'In der Schleife immer eine Sekunde warten
            'Prfen ob Ghostscript schon komplett ausgepackt ist
            If Dir(sGSBinVerzeichnis, vbDirectory) <> sLEER _
            And Dir(sGSDocVerzeichnis, vbDirectory) <> sLEER _
            And Dir(sGSExamplesVerzeichnis, vbDirectory) <> sLEER _
            And Dir(sGSLibVerzeichnis, vbDirectory) <> sLEER _
            And Dir(sGSResourceVerzeichnis, vbDirectory) <> sLEER Then
                Exit For
            End If
        Next iWartezeit
        'Noch zwei Sekunden fr die anderen Dateien zugeben
        Call fbWarten(2)
    End If
    
    If Dir(sGSBinVerzeichnis, vbDirectory) <> sLEER _
    And Dir(sGSDocVerzeichnis, vbDirectory) <> sLEER _
    And Dir(sGSExamplesVerzeichnis, vbDirectory) <> sLEER _
    And Dir(sGSLibVerzeichnis, vbDirectory) <> sLEER _
    And Dir(sGSResourceVerzeichnis, vbDirectory) <> sLEER Then
        fsGhostscriptProgramm_entpacken = sLEER
    Else
        fsGhostscriptProgramm_entpacken = fsText(sMSG_KONNTEGHOSTSCRIPTNICHTENTPACKEN, gsDefaultGhostscriptTabelle(iZaehler, 0), sGSInstAufruf)
    End If

End Function

Function fsGhostscriptProgramm_registrieren() As String
    'Die Funktion registriert die Ghostscript-Version in der Registry.
    'Global:
    '   gsPathSeparator wird gelesen
    '   gsGSProgrammName wird gelesen
    '   gsDefaultGhostscriptTabelle wird gelesen
    'Rckgabewert:
    '   "" = Aufgabe erledigt. Registry-Eintrge sind jetzt vorhanden.
    '   "fehlertext" = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Const sDLLNAME As String = "GS_DLL"
    Const sLIBNAME As String = "GS_LIB"
       
    Dim iZaehler As Integer
    Dim lPosition As Long
    Dim sPfadMitVersion As String
    Dim sPfadOhneVersion As String
    Dim sRegPfad As String
    Dim sDllWert As String
    Dim sLibWert As String
    Dim sProgramm As String
      
    iZaehler = fiGhostscriptDefaultNr_ermitteln(gsGSProgrammName, 1)
      
    If gsGSProgrammName = sLEER _
    Or gsDefaultGhostscriptTabelle(iZaehler, 2) = sLEER _
    Or gsDefaultGhostscriptTabelle(iZaehler, 3) = sLEER _
    Or gsDefaultGhostscriptTabelle(iZaehler, 4) = True Then
        fsGhostscriptProgramm_registrieren = fsText(sMSG_GHOSTSCRIPTKEINEDATEN, gsDefaultGhostscriptTabelle(iZaehler, 0), gsGSProgrammName)
        Exit Function
    End If
    
    'Aus dem Programmnamen den Pfad ermitteln
    'z.B. aus "C:\Programme\gs\gs7.00\bin\gswin32.exe"
    sPfadMitVersion = sLEER
    sPfadOhneVersion = sLEER
    lPosition = flLetztesVorkommen_suchen(LCase(gsGSProgrammName), gsPathSeparator & "bin" & gsPathSeparator)
    If lPosition > 0 Then
        sPfadMitVersion = Left(gsGSProgrammName, lPosition - 1)
        'z.B. "C:\Programme\gs\gs7.00"
        lPosition = flLetztesVorkommen_suchen(sPfadMitVersion, gsPathSeparator)
        If lPosition > 0 Then
            sPfadOhneVersion = Left(sPfadMitVersion, lPosition - 1)
        End If
    End If
    
    If sPfadMitVersion = sLEER _
    Or sPfadOhneVersion = sLEER Then
        fsGhostscriptProgramm_registrieren = fsText(sMSG_GHOSTSCRIPTVERZEICHNISSEFALSCH1, gsGSProgrammName)
        Exit Function
    End If
    
    sRegPfad = "SOFTWARE\" & gsDefaultGhostscriptTabelle(iZaehler, 2) & "\" & gsDefaultGhostscriptTabelle(iZaehler, 3)
    sDllWert = sPfadMitVersion & gsPathSeparator & "bin" & gsPathSeparator & "gsdll32.dll"
    sLibWert = sPfadMitVersion & gsPathSeparator & "lib;" _
        & sPfadOhneVersion & gsPathSeparator & "fonts;" _
        & sPfadMitVersion & gsPathSeparator & "Resource"
    
    'If System.PrivateProfileString(sLEER, "HKEY_LOCAL_MACHINE\" & sRegPfad, sDLLNAME) = sLEER Then
        'Eintrag nicht gefunden
        If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sRegPfad, sDLLNAME, sDllWert, REG_SZ) = False Then
            fsGhostscriptProgramm_registrieren = fsText(sMSG_KONNTEGHOSTSCRIPTNICHTREGISTRIEREN, gsDefaultGhostscriptTabelle(iZaehler, 0))
            Exit Function
        End If
    'End If
    'If System.PrivateProfileString(sLEER, "HKEY_LOCAL_MACHINE\" & sRegPfad, sLIBNAME) = sLEER Then
        'Eintrag nicht gefunden
        If fbRegistry_WertSetzen(HKEY_LOCAL_MACHINE, sRegPfad, sLIBNAME, sLibWert, REG_SZ) = False Then
            fsGhostscriptProgramm_registrieren = fsText(sMSG_KONNTEGHOSTSCRIPTNICHTREGISTRIEREN, gsDefaultGhostscriptTabelle(iZaehler, 0))
            Exit Function
        End If
    'End If
    
    fsGhostscriptProgramm_registrieren = sLEER

End Function

Function fbPDFBetrachterListe_fuellen(bAuchNeueFlag As Boolean) As Boolean
    'Die Funktion ermittelt alle PDFBetrachter-Installationen und fllt die Tabelle gsDefaultPDFBetrachterTabelle
    'und die Tabelle gsPDFBetrachterListe
    'Die Tabellen sind nach den PDFBetrachter-Versionen sortiert.
    'Global:
    '   gsInstVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    '   gsDefaultPDFBetrachterTabelle wird gefllt
    '   gsPDFBetrachterListe wird gefllt
    'Argumente:
    '   bAuchNeueFlag
    '   True  = Auch neue Ghostview-Installtionen in die Tabelle aufnehmen
    '   False = Keine neuen Ghostview-Installtionen in die Tabelle aufnehmen
    '   True  = Tabelle gefllt.
    '   False = Tabelle ist leer.
    'Effekt
    '   keiner
        
    Const sUNZIPFILE As String = "unzip.exe"
    Const sSETUPFILE As String = "setup.exe"
    Const sGSVIEW32 As String = "gsview32.exe"
    Const sACROREADER As String = "AcroRd32.exe"
    
    Dim sReaderVersionName(4) As String 'Tabelle mit Versionsnummern von Acrobat Reader, die passen knnten.
    Dim sEineVersion As Variant
    Dim iZaehler As Integer
    Dim sPDFProgrammVersion As String
    Dim sInstallPath As String
    Dim sPDFProgrammName As String
    Dim sPDFInstProgrammName As String
    Dim sPDFInstDirName As String
    Dim sIniDatei As String
    Dim iIniDateiDateinummer As Integer
    Dim sUnzipProgrammName As String
    Dim sUnzipAufruf As String
    Dim iLBound As Integer
    Dim iUBound As Integer
    Dim iTempZaehler As Integer
    Dim sProgramm As String
    Dim sGhostviewVersionName(7) As String 'Tabelle mit Versionsnummern von Ghostview, die passen knnten.
    Dim sPDFVerknpfterProgrammName As String
      
    ReDim gsDefaultPDFBetrachterTabelle(100, 6) 'Eintrag 100 dient mur zum umsortieren
    iZaehler = -1
    
    '(1) Acrobat Reader
    'Nummern der Versionen von Acrobat Reader
    sReaderVersionName(0) = "7.0"
    sReaderVersionName(1) = "6.0"
    sReaderVersionName(2) = "5.1"
    sReaderVersionName(3) = "5.0"
    sReaderVersionName(4) = "4.0"
    
    For Each sEineVersion In sReaderVersionName
        sPDFProgrammVersion = CStr(sEineVersion)
        'erster Versuch: AcrobatReader in der Registry suchen und prfen, ob dort auch das
        'Programm steht.
        sInstallPath = System.PrivateProfileString(sLEER, _
            "HKEY_LOCAL_MACHINE\SOFTWARE\Adobe\Acrobat Reader\" & sPDFProgrammVersion & "\InstallPath", sLEER)
            'z.B. "HKEY_LOCAL_MACHINE\Adobe\Acrobat Reader\7.0\InstallPath"
        If sInstallPath <> sLEER Then
            sPDFProgrammName = sInstallPath & gsPathSeparator & sACROREADER
            If Dir(sPDFProgrammName, vbNormal) <> sLEER _
            And iZaehler <= 98 Then
                iZaehler = iZaehler + 1
                gsDefaultPDFBetrachterTabelle(iZaehler, 0) = iZaehler
                gsDefaultPDFBetrachterTabelle(iZaehler, 1) = sPDFProgrammName
                gsDefaultPDFBetrachterTabelle(iZaehler, 2) = sTXT_ACROBATREADER
                gsDefaultPDFBetrachterTabelle(iZaehler, 3) = sPDFProgrammVersion
                gsDefaultPDFBetrachterTabelle(iZaehler, 4) = True
                gsDefaultPDFBetrachterTabelle(iZaehler, 5) = sLEER
                gsDefaultPDFBetrachterTabelle(iZaehler, 6) = False
            End If
        End If
        
    Next sEineVersion
    
    '(2) Ghostview
    'Nummern der Versionen von Ghostview
    sGhostviewVersionName(0) = "4.7"
    sGhostviewVersionName(1) = "4.6"
    sGhostviewVersionName(2) = "4.5"
    sGhostviewVersionName(3) = "4.4"
    sGhostviewVersionName(4) = "4.3"
    sGhostviewVersionName(5) = "4.2"
    sGhostviewVersionName(6) = "4.1"
    sGhostviewVersionName(7) = "4.0"

    For Each sEineVersion In sGhostviewVersionName
        sPDFProgrammVersion = CStr(sEineVersion)
        'erster Versuch: Ghostview in der Registry suchen und prfen, ob dort auch das
        'Programm steht.
        sInstallPath = System.PrivateProfileString(sLEER, _
            "HKEY_LOCAL_MACHINE\SOFTWARE\Ghostgum\GSview", sPDFProgrammVersion)
            'z.B. "HKEY_LOCAL_MACHINE\Ghostgum\GSview\4.4"
        If sInstallPath <> sLEER Then
            sPDFProgrammName = sInstallPath & gsPathSeparator & "gsview" & gsPathSeparator & sGSVIEW32
            If iZaehler >= 0 Then
                For iTempZaehler = LBound(gsDefaultPDFBetrachterTabelle, 1) To iZaehler
                    If gsDefaultPDFBetrachterTabelle(iTempZaehler, 1) = sPDFProgrammName Then
                        sPDFProgrammName = sLEER
                        Exit For
                    End If
                Next iTempZaehler
            End If
            If sPDFProgrammName <> sLEER _
            And Dir(sPDFProgrammName, vbNormal) <> sLEER _
            And fbGhostviewVersion_pruefen(sPDFProgrammName, sPDFProgrammVersion) = True _
            And iZaehler <= 98 Then
                iZaehler = iZaehler + 1
                gsDefaultPDFBetrachterTabelle(iZaehler, 0) = iZaehler
                gsDefaultPDFBetrachterTabelle(iZaehler, 1) = sPDFProgrammName
                gsDefaultPDFBetrachterTabelle(iZaehler, 2) = sTXT_GSVIEW
                gsDefaultPDFBetrachterTabelle(iZaehler, 3) = sPDFProgrammVersion
                gsDefaultPDFBetrachterTabelle(iZaehler, 4) = True
                gsDefaultPDFBetrachterTabelle(iZaehler, 5) = sLEER
                If LCase(gsInstVerzeichnis) = LCase(Left(sPDFProgrammName, Len(gsInstVerzeichnis))) Then
                    gsDefaultPDFBetrachterTabelle(iZaehler, 6) = True
                Else
                    gsDefaultPDFBetrachterTabelle(iZaehler, 6) = False
                End If
            End If
        End If
        
        'zweiter Versuch: Liegen die Ghostview-Programme ausgepackt in Gs4Word
        'und ist eine passende Ini-Datei vorhanden?
        'Dieses Verzeichnis kann im Netzwerk liegen.
        sPDFProgrammName = gsInstVerzeichnis & "Ghostgum" & gsPathSeparator & "gsview" & gsPathSeparator & sGSVIEW32
            'z.B. "P:\Programe\Gs4Word_310\Ghostgum\gsview\gsview32.exe"
        If iZaehler >= 0 Then
            For iTempZaehler = LBound(gsDefaultPDFBetrachterTabelle, 1) To iZaehler
                If gsDefaultPDFBetrachterTabelle(iTempZaehler, 1) = sPDFProgrammName Then
                    sPDFProgrammName = sLEER
                    Exit For
                End If
            Next iTempZaehler
        End If
        If sPDFProgrammName <> sLEER _
        And Dir(sPDFProgrammName, vbNormal) <> sLEER _
        And fbGhostviewVersion_pruefen(sPDFProgrammName, sPDFProgrammVersion) = True _
        And iZaehler <= 98 Then
            iZaehler = iZaehler + 1
            gsDefaultPDFBetrachterTabelle(iZaehler, 0) = iZaehler
            gsDefaultPDFBetrachterTabelle(iZaehler, 1) = sPDFProgrammName
            gsDefaultPDFBetrachterTabelle(iZaehler, 2) = sTXT_GSVIEW
            gsDefaultPDFBetrachterTabelle(iZaehler, 3) = sPDFProgrammVersion
            gsDefaultPDFBetrachterTabelle(iZaehler, 4) = True
            gsDefaultPDFBetrachterTabelle(iZaehler, 5) = sLEER
            gsDefaultPDFBetrachterTabelle(iZaehler, 6) = False
        End If
            
        If bAuchNeueFlag = True Then
            'dritter Versuch: Liegen die Ghostview-Programme eingepackt in Gs4Word?
            'Dieses Verzeichnis kann im Netzwerk liegen.
            sPDFProgrammName = gsInstVerzeichnis & "Ghostgum" & gsPathSeparator & "gsview" & gsPathSeparator & sGSVIEW32
            If iZaehler >= 0 Then
                For iTempZaehler = LBound(gsDefaultPDFBetrachterTabelle, 1) To iZaehler
                    If gsDefaultPDFBetrachterTabelle(iTempZaehler, 1) = sPDFProgrammName Then
                        sPDFProgrammName = sLEER
                        Exit For
                    End If
                Next iTempZaehler
            End If
            sPDFInstProgrammName = gsInstVerzeichnis & "gsv" & Left(sPDFProgrammVersion, 1) & Right(sPDFProgrammVersion, 1) & "w32.exe"
                'z.B. "P:\Programe\Gs4Word_310\gsv44w32.exe"
            sPDFInstDirName = gsInstVerzeichnis & "Ghostgum"
            sUnzipProgrammName = gsInstVerzeichnis & sUNZIPFILE
            sUnzipAufruf = Chr(34) & sUnzipProgrammName & Chr(34) & " -o -d " & Chr(34) & sPDFInstDirName & Chr(34) & sSPACE & Chr(34) & sPDFInstProgrammName & Chr(34)
            If sPDFProgrammName <> sLEER _
            And Dir(sUnzipProgrammName, vbNormal) <> sLEER _
            And Dir(sPDFInstProgrammName, vbNormal) <> sLEER _
            And Dir(sPDFInstDirName, vbDirectory) = sLEER _
            And iZaehler <= 97 Then
                iZaehler = iZaehler + 1
                gsDefaultPDFBetrachterTabelle(iZaehler, 0) = iZaehler
                gsDefaultPDFBetrachterTabelle(iZaehler, 1) = sPDFProgrammName
                gsDefaultPDFBetrachterTabelle(iZaehler, 2) = sTXT_GSVIEW
                gsDefaultPDFBetrachterTabelle(iZaehler, 3) = sPDFProgrammVersion
                gsDefaultPDFBetrachterTabelle(iZaehler, 4) = False
                gsDefaultPDFBetrachterTabelle(iZaehler, 5) = sUnzipAufruf
                gsDefaultPDFBetrachterTabelle(iZaehler, 6) = False
            End If
        End If
            
        'vierter Versuch: Liegen die Ghostscript-Programme im Standard-Programmverzeichnis
        'und ist eine passende Ini-Datei vorhanden?
        sProgramm = System.PrivateProfileString(sLEER, _
            "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion", "ProgramFilesDir")
        If sProgramm <> sLEER Then
            sPDFProgrammName = sProgramm & gsPathSeparator & "Ghostgum" & gsPathSeparator & "gsview" & gsPathSeparator & sGSVIEW32
                'z.B. "C:\Programme\Ghostgum\gsview\gsview32.exe"
            If iZaehler >= 0 Then
                For iTempZaehler = LBound(gsDefaultPDFBetrachterTabelle, 1) To iZaehler
                    If gsDefaultPDFBetrachterTabelle(iTempZaehler, 1) = sPDFProgrammName Then
                        sPDFProgrammName = sLEER
                        Exit For
                    End If
                Next iTempZaehler
            End If
            If sPDFProgrammName <> sLEER _
            And Dir(sPDFProgrammName, vbNormal) <> sLEER _
            And fbGhostviewVersion_pruefen(sPDFProgrammName, sPDFProgrammVersion) = True _
            And iZaehler <= 98 Then
                iZaehler = iZaehler + 1
                gsDefaultPDFBetrachterTabelle(iZaehler, 0) = iZaehler
                gsDefaultPDFBetrachterTabelle(iZaehler, 1) = sPDFProgrammName
                gsDefaultPDFBetrachterTabelle(iZaehler, 2) = sTXT_GSVIEW
                gsDefaultPDFBetrachterTabelle(iZaehler, 3) = sPDFProgrammVersion
                gsDefaultPDFBetrachterTabelle(iZaehler, 4) = True
                gsDefaultPDFBetrachterTabelle(iZaehler, 5) = sLEER
                gsDefaultPDFBetrachterTabelle(iZaehler, 6) = False
            End If
        End If
        
    Next sEineVersion
    
    sPDFVerknpfterProgrammName = fsVerknuepfung_ermitteln(sPDF, sLEER)
    
    If iZaehler = -1 _
    And sPDFVerknpfterProgrammName = sLEER Then
        'Das war wohl nichts
        ReDim gsDefaultPDFBetrachterTabelle(0, 6)
        iZaehler = 0
        ReDim gsPDFBetrachterListe(0)
        fbPDFBetrachterListe_fuellen = False
    ElseIf iZaehler = -1 _
    And sPDFVerknpfterProgrammName <> sLEER Then
        'Ein anderes Programm ist eingetragen, kommt aber nicht in der Liste vor
        ReDim gsDefaultPDFBetrachterTabelle(1, 6)
        gsDefaultPDFBetrachterTabelle(0, 0) = sLEER
        gsDefaultPDFBetrachterTabelle(0, 1) = sPDFVerknpfterProgrammName
        gsDefaultPDFBetrachterTabelle(0, 2) = sLEER
        gsDefaultPDFBetrachterTabelle(0, 3) = sLEER
        gsDefaultPDFBetrachterTabelle(0, 4) = True
        gsDefaultPDFBetrachterTabelle(0, 5) = sLEER
        gsDefaultPDFBetrachterTabelle(0, 6) = False
        iZaehler = 1
        ReDim gsPDFBetrachterListe(0)
        gsPDFBetrachterListe(0) = sLEER
        fbPDFBetrachterListe_fuellen = True
    Else
        ReDim gsPDFBetrachterListe(iZaehler)
        For iTempZaehler = LBound(gsDefaultPDFBetrachterTabelle, 1) To iZaehler
            gsPDFBetrachterListe(iTempZaehler) = gsDefaultPDFBetrachterTabelle(iTempZaehler, 2) & sSPACE & gsDefaultPDFBetrachterTabelle(iTempZaehler, 3) & sSPACE & "(" & gsDefaultPDFBetrachterTabelle(iTempZaehler, 0) & ")"
            gsDefaultPDFBetrachterTabelle(iTempZaehler, 0) = gsPDFBetrachterListe(iTempZaehler)
        Next iTempZaehler
        iZaehler = iZaehler + 1
        fbPDFBetrachterListe_fuellen = True
    End If
    gsDefaultPDFBetrachterTabelle(iZaehler, 0) = sLEER
    gsDefaultPDFBetrachterTabelle(iZaehler, 1) = sLEER
    gsDefaultPDFBetrachterTabelle(iZaehler, 2) = sLEER
    gsDefaultPDFBetrachterTabelle(iZaehler, 3) = sLEER
    gsDefaultPDFBetrachterTabelle(iZaehler, 4) = True 'Hier muss True stehen, damit bei einem unbekannten Programm keine Eintrge in der Registry vorgenomen werden
    gsDefaultPDFBetrachterTabelle(iZaehler, 5) = sLEER
    gsDefaultPDFBetrachterTabelle(iZaehler, 6) = False 'Hier muss False stehen, damit bei der Deinstallation keine Eintrge aus der Registry gelscht werden
    
End Function

Function fbGhostviewVersion_pruefen(sProgrammName As String, sVersion As String) As Boolean
    'Die Funktion prft, ob Ghostview-Programmname und Version zusammenpassen
    'Dazu liest sie in der Inidatei die erste Zeile
    'Ihr Inhalt ist "[GSview-9.9]" mit "9.9" als Versionsnummer
    'Global:
    'Argumente:
    '   sProgrammName = Pfad und Programname von GsView32.exe
    '   sVersion = Versionsnummer im Format "9.9"
    'Rckgabewert:
    '   False = keine Ini-Datei oder keine passende Versionsnummer
    '   True = Versionsnummer passt
    'Effekt
    '   keiner
    
    Dim sZeile As String
    Dim sIniDatei As String
    Dim iIniDateinummer As Integer
    
    If sProgrammName = sLEER _
    Or sVersion = sLEER Then
        fbGhostviewVersion_pruefen = False
        Exit Function
    End If
    
    sIniDatei = Left(sProgrammName, Len(sProgrammName) - 4) & ".ini"
    sZeile = sLEER
    If Dir(sIniDatei, vbNormal) <> sLEER Then
        iIniDateinummer = FreeFile
        Open sIniDatei For Input Access Read Shared As iIniDateinummer
        If Not EOF(iIniDateinummer) Then
            Line Input #iIniDateinummer, sZeile
            Close #iIniDateinummer
        End If
    End If
    If UCase(Trim(sZeile)) = UCase("[GSview-" & sVersion & "]") Then
        fbGhostviewVersion_pruefen = True
    Else
        fbGhostviewVersion_pruefen = False
    End If
    
End Function

Function fiPDFBetrachterDefaultNr_ermitteln(sFeldWert As String, iSpalte As Integer) As Integer
    'Die Funktion ermittelt zu sFeldWert aus der Spalte iSpalte die Nummer in der Tabelle gsDefaultPDFBetrachterTabelle
    'Global:
    '   gsDefaultPDFBetrachterTabelle wird gelesen
    'Argumente:
    '   sFeldWert = Wert des Feldes
    '               Bei iSpalte = o ist es der Anzeigename aus gsDefaultPDFBetrachterTabelle(n,0)
    '               Bei iSpalte = 1 ist es der Programmname mit Pfad aus gsDefaultGPDFBetrachterTabelle(n,1)
    '   iSpalte = Nummer der Spalte in gsDefaultPDFBetrachterTabelle
    '               0 enthlt den PDFBetrachternamen fr die Auswahl im Dialog
    '               1 enthlt den PDFProgrammnamen mit Pfad
    '               2 ist ungenutzt
    '               3 enthlt der Versionsnummer von Ghostview fr die Ini-Datei
    '               4 ist ungenutzt
    '               5 enthlt den Programmaufruf zum Entpacken von Ghostscript
    'Rckgabewert:
    '   Nummer in der Tabelle gsDefaultPDFBetrachterTabelle,
    '       Wenn kein passender Eintrag gefunden wird, steht der Rckgabewert auf
    '       dem letzten Eintrag. Dieser nuss imer leer sein!
    'Effekt
    '   keiner
    
    For fiPDFBetrachterDefaultNr_ermitteln = LBound(gsDefaultPDFBetrachterTabelle, 1) To UBound(gsDefaultPDFBetrachterTabelle, 1)
        If LCase(gsDefaultPDFBetrachterTabelle(fiPDFBetrachterDefaultNr_ermitteln, iSpalte)) = LCase(sFeldWert) _
        Or gsDefaultPDFBetrachterTabelle(fiPDFBetrachterDefaultNr_ermitteln, iSpalte) = sLEER Then
            Exit Function
        End If
    Next fiPDFBetrachterDefaultNr_ermitteln
    
End Function

Function fsGhostview_entpacken(sPDFProgrammName As String, sGSProgrammName As String) As String
    'Die Funktion entpackt Ghostview in Installationsverzeichnis von Gs4Word und erzeugt eine Ini-Datei
    'Global:
    '   gsPathSeparator wird gelesen
    '   gsDefaultPDFBetrachterTabelle wird gelesen
    '   gsDefaultGhostscriptBetrachterTabelle wird gelesen
    'Argumente:
    '   sPFDProgrammName = Ghostview-Programmname
    '   sGSProgrammName = Ghostscript-Programmname
    'Rckgabewert:
    '   "" = Aufgabe erledigt. Ghostview wurde entpackt.
    '   "fehlertext" = Es ist eine Fehler aufgetreten
    'Effekt
    '   Ggf. wurde Ghostview im Installationsverzeichnis von Gs4Word entpackt und die ini-datei erzeugt
    
    Dim lPosition As Long
    Dim iPDFZaehler As Integer
    Dim sUnzipAufruf As String
    Dim sPDFVersion As String
    Dim sGsviewVerzeichnis As String
    Dim sPstotextVerzeichnis As String
    Dim vtaskId As Variant 'Task-ID eines mit Shell aufgerufenen Programms
    Dim iWartezeit As Integer
    Dim iGSZaehler As Integer
    Dim sGSVersion As String
    Dim sGSVersionOhnePunkt As String
    Dim sIniDatei As String
    Dim iIniDateiDateinummer As Integer
    Dim sPfadMitVersion As String
    Dim sPfadOhneVersion As String
    Dim sDllWert As String
    Dim sLibWert As String
    
    'Vorbereiten und prfen, ob alles OK ist
    iPDFZaehler = fiPDFBetrachterDefaultNr_ermitteln(sPDFProgrammName, 1)
    sUnzipAufruf = gsDefaultPDFBetrachterTabelle(iPDFZaehler, 5)
    sPDFVersion = gsDefaultPDFBetrachterTabelle(iPDFZaehler, 3)
    If sGSProgrammName = sLEER _
    Or sUnzipAufruf = sLEER _
    Or sPDFVersion = sLEER Then
        fsGhostview_entpacken = fsText(sMSG_GHOSTVIEWKEINENTPACKEN, sPDFProgrammName)
        Exit Function
    End If
        
    iGSZaehler = fiGhostscriptDefaultNr_ermitteln(sGSProgrammName, 1)
    sGSVersion = gsDefaultGhostscriptTabelle(iGSZaehler, 3)
    If Len(sGSVersion) = 4 Then
        sGSVersionOhnePunkt = Left(sGSVersion, 1) & Right(sGSVersion, 2)
    Else
        sGSVersionOhnePunkt = sLEER
    End If
    If sGSProgrammName = sLEER _
    Or sGSVersion = sLEER _
    Or sGSVersionOhnePunkt = sLEER Then
        fsGhostview_entpacken = fsText(sMSG_GHOSTSCRIPTPROGRAMMNAME, gsGSProgrammName)
        Exit Function
    End If
    
    'Aus dem PDF-Programmnamen (Ghostview!) den Pfad ermitteln
    'z.B. aus "C:\Programme\Gs4Word\Ghostgum\gsview\gsview32.exe"
    lPosition = flLetztesVorkommen_suchen(LCase(sPDFProgrammName), gsPathSeparator)
    If lPosition > 0 Then
        sGsviewVerzeichnis = Left(sPDFProgrammName, lPosition - 1)
        'z.B. "C:\Programme\Gs4Word\Ghostgum\gsview"
        lPosition = flLetztesVorkommen_suchen(sGsviewVerzeichnis, gsPathSeparator)
        If lPosition > 0 Then
            sPstotextVerzeichnis = Left(sGsviewVerzeichnis, lPosition) & "pstotext"
            'z.B. "C:\Programme\Gs4Word\Ghostgum\pstotext"
        End If
    End If
    
    'Aus dem GS-Programmnamen (Ghostscript nicht Ghostview!) den Pfad ermitteln
    'z.B. aus "C:\Programme\gs\gs7.00\bin\gswin32.exe"
    sPfadMitVersion = sLEER
    sPfadOhneVersion = sLEER
    lPosition = flLetztesVorkommen_suchen(LCase(sGSProgrammName), gsPathSeparator & "bin" & gsPathSeparator)
    If lPosition > 0 Then
        sPfadMitVersion = Left(sGSProgrammName, lPosition - 1)
        'z.B. "C:\Programme\gs\gs7.00"
        lPosition = flLetztesVorkommen_suchen(sPfadMitVersion, gsPathSeparator)
        If lPosition > 0 Then
            sPfadOhneVersion = Left(sPfadMitVersion, lPosition - 1)
        End If
    End If
    
    If sPfadMitVersion = sLEER _
    Or sPfadOhneVersion = sLEER Then
        fsGhostview_entpacken = fsText(sMSG_GHOSTSCRIPTVERZEICHNISSEFALSCH2, gsGSProgrammName)
        Exit Function
    End If
    
    'Gsview entpacken
    vtaskId = Shell(sUnzipAufruf, 4)
    If vtaskId <> 0 Then 'Der Wert ist unter NT 4.0 immer positiv, unter ME auch negativ
        'Shell wird asynchron verarbeitet, deshalb solange warten, bis alle Ghostview-Verzeichnisse
        'ausgepackt sind. Das wird einmal je Sekunde berprft.
        'Wie lange darauf maximal gewartet wird, ist je Rechner (Prozessortakt) unterschiedlich.
        'Wer eine bessere Idee hat, soll sich bitte melden!
        For iWartezeit = 1 To giMaxRechnerWartezeit Step 1
            Call fbWarten(1)  'In der Schleife immer eine Sekunde warten
           'Prfen ob Ghostscript schon komplett ausgepackt ist
            If Dir(sGsviewVerzeichnis, vbDirectory) <> sLEER _
            And Dir(sPstotextVerzeichnis, vbDirectory) <> sLEER Then
                Exit For
            End If
        Next iWartezeit
        'Noch zwei Sekunden fr die anderen Dateien zugeben
        Call fbWarten(2)
    End If
    
    If Dir(sGsviewVerzeichnis, vbDirectory) = sLEER _
    Or Dir(sPstotextVerzeichnis, vbDirectory) = sLEER Then
        fsGhostview_entpacken = fsText(sMSG_KONNTEPDFBETRACHTERNICHTENTPACKEN, gsDefaultPDFBetrachterTabelle(iPDFZaehler, 0), sUnzipAufruf)
        Exit Function
    End If
        
    'Ini-Datei fr Gsview erzeugen. Der Inhalt ist in Version 4.4:
    '   [GSview-4.4]
    '   Version = 4.4
    '   GSversion = 811
    '   GhostscriptDLL=C:\Programme\Gs4Word_310\gs\gs8.11\bin\gsdll32.dll
    '   GhostscriptInclude=C:\Programme\Gs4Word_310\gs\gs8.11\lib;C:\Programme\Gs4Word_310\gs\fonts;C:\Programme\Gs4Word_310\gs\gs8.11\Resource
    '   GhostscriptOther = -dNOPLATFONTS - sFONTPATH = "c:\psfonts"
    '   Configured = 1
    '   [Options]
    '   Language = de
    
    sDllWert = sPfadMitVersion & gsPathSeparator & "bin" & gsPathSeparator & "gsdll32.dll"
    sLibWert = sPfadMitVersion & gsPathSeparator & "lib;" _
        & sPfadOhneVersion & gsPathSeparator & "fonts;" _
        & sPfadMitVersion & gsPathSeparator & "Resource"
      
    'Aus dem Programmnamen den Namen der Ini-Datei ermitteln
    sIniDatei = Left(sPDFProgrammName, Len(sPDFProgrammName) - 4) & ".ini"
    iIniDateiDateinummer = FreeFile
    Open sIniDatei For Output Access Write As iIniDateiDateinummer
    Print #iIniDateiDateinummer, "[GSview-" & sPDFVersion & "]"
    Print #iIniDateiDateinummer, "Version = " & sPDFVersion
    Print #iIniDateiDateinummer, "GSversion = " & sGSVersionOhnePunkt
    Print #iIniDateiDateinummer, "GhostscriptDLL=" & sDllWert
    Print #iIniDateiDateinummer, "GhostscriptInclude=" & sLibWert
    Print #iIniDateiDateinummer, "GhostscriptOther = -dNOPLATFONTS - sFONTPATH = " & Chr(34) & "c:\psfonts" & Chr(34)
    Print #iIniDateiDateinummer, "Configured = 1"
    Print #iIniDateiDateinummer, "[Options]"
    Print #iIniDateiDateinummer, "Language = de"
    Close #iIniDateiDateinummer
    
    fsGhostview_entpacken = sLEER

End Function

Function fsMailtoProgramm_ermitteln() As String
    'Die Funktion gibt den Namen des Programms zurck, mit dem mailto verknpft ist. Dabei wird die
    'Environment-Variable SYSTEMROOT aufgelst, wenn sie an Anfang steht. Hinter dem Programmnamen
    'stehende Parameter (z.B. %1 oder /r "%1") werden entfernt. Das Programm muss vorhanden sein.
    'Rckgabewert:
    '   sLEER = Es konnte kein zugeordnetes Programm ermittelt werden.
    '   xx..xx = Name des zugeordneten Programms.
    'Effekt
    '   keiner
       
    Dim sWert As String
    Dim sProgramm As String
    Dim lPosition As Long

    fsMailtoProgramm_ermitteln = sLEER
    
    sProgramm = System.PrivateProfileString(sLEER, _
        "HKEY_LOCAL_MACHINE\SOFTWARE\classes\mailto\shell\open\command", sLEER)
    'Der Dateiname darf in Anfhrungszeichen (") stehen.
    'entweder 'xxx.exe %1' oder '"xxx" "%1"' oder '%systemroot%\xxx %1' oder eine Kombination
    sProgramm = Trim(sProgramm) & sSPACE
    If Left(sProgramm, 1) = Chr(34) Then 'Programmname ist in Anfhrungszeichen eingeschossen
        sProgramm = Mid(sProgramm, 2) 'erstes Anfhrungszeichen entfernen
        lPosition = InStr(sProgramm, Chr(34)) 'zweites Anfhrungszeichen suchen
    Else
        lPosition = InStr(sProgramm, sSPACE)  'erstes Leerzeichen suchen
    End If
    If lPosition > 0 Then
        sProgramm = Left(sProgramm, lPosition - 1)
        If LCase(Left(sProgramm, 12)) = LCase("%systemroot%") Then
            sProgramm = Environ("systemroot") & gsPathSeparator & Mid(sProgramm, 13)
        End If
        If Dir(sProgramm, vbNormal) <> sLEER Then
            fsMailtoProgramm_ermitteln = sProgramm
        End If
    End If

End Function

Function fsMailtoParameter_ermitteln(sMailtoProgrammName As String) As String
    'Die Funktion gibt den Default-Parameter zum Mailto-Programm zurck.
    'Argumente:
    '   sMailtoProgrammName = Name des Mailto-Programms mit Pfad. Zwei Programme werden erkannt:
    '       netscape.exe ist der 'Netscape Communicator 4.xx
    '       outlook.exe ist Outlook 97/98/2000
    'Rckgabewert:
    '   sLEER = Es konnte kein zugeordnetes Mailto-Programm ermittelt werden.
    '   xx..xx = Default-Parameter.
    'Effekt
    '   keiner
    
    Select Case UCase(Mid(gsMailtoProgrammName, _
        flLetztesVorkommen_suchen(gsMailtoProgrammName, gsPathSeparator) + 1))
    Case "OUTLOOK.EXE" 'Outlook 97/98/2000
        fsMailtoParameter_ermitteln = "/c ipm.note /a " & Chr(34) & "%" & Chr(34)
    Case "NETSCAPE.EXE" 'Netscape Communicator 4.xx
        fsMailtoParameter_ermitteln = "-compose " & Chr(34) & "-%" & Chr(34)
    Case Else
        fsMailtoParameter_ermitteln = sLEER
    End Select

End Function

Function fiMaxRechnerWartezeit_ermitteln() As Integer
    'Die Funktion gibt eine Anzahl Sekunden zurck, die auf diesem Rechner MAXIMAL gewartet werden
    'muss, um einen Prozess zu starten und die Verarbeitung zu beginnen.
    'Global:
    '   iMAXRECHNERWARTEZEITFAKTOR wird gelesen
    'Rckgabewert:
    '   3 * iMAXRECHNERWARTEZEITFAKTOR Sekunden. Der Rckgabewert muss durch
    '           iMAXRECHNERWARTEZEITFAKTOR teilbar sein.
    'Effekt
    '   keiner
    
     fiMaxRechnerWartezeit_ermitteln = 3 * iMAXRECHNERWARTEZEITFAKTOR 'Defaultwert
        
End Function
Function fbAusgabeMedienTabelle_DefaultFuellen() As Boolean
    'Die Funktion fllt die ersten fnf Elemente der gvAusgabeMedienTabelle mit den Defaultwerten
    'Wenn die Tabelle schon gefllt ist, und mehr als fnf Elemente hat, werden die brigen
    'Elemente nicht verndert.
    'Global:
    '   gvAusgabeMedienTabelle wird gefllt
    '   gsGsParamTabelle wird gelesen
    'Effekt
    '   keiner
    
    Dim iParamNr As Integer
    Dim iSpalteNr As Integer
    Dim bUndefined As Boolean
    
    'Wenn die Tabelle schon gefllt ist, werden die Elemente  > 4 nicht verndert
    If VarType(gvAusgabeMedienTabelle) = vbEmpty Then
        gvAusgabeMedienTabelle = GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION_GHOSTSCRIPT)
        If VarType(gvAusgabeMedienTabelle) = vbEmpty Then
            ReDim gvAusgabeMedienTabelle(4, 1)
        End If
    End If
    If UBound(gvAusgabeMedienTabelle, 1) < 4 Then
        ReDim gvAusgabeMedienTabelle(4, 1)
    End If
    
    'Namen der fnf ersten Elemente in der richtigen Sprache neu belegen
    gvAusgabeMedienTabelle(0, 0) = sAUSGABEMEDIUM_DEFAULT
    gvAusgabeMedienTabelle(1, 0) = sAUSGABEMEDIUM_SCREEN
    gvAusgabeMedienTabelle(2, 0) = sAUSGABEMEDIUM_RESERVIERT
    gvAusgabeMedienTabelle(3, 0) = sAUSGABEMEDIUM_PRINTER
    gvAusgabeMedienTabelle(4, 0) = sAUSGABEMEDIUM_PREPRESS
    gvAusgabeMedienTabelle(0, 1) = sLEER
    gvAusgabeMedienTabelle(1, 1) = sLEER
    gvAusgabeMedienTabelle(2, 1) = sLEER
    gvAusgabeMedienTabelle(3, 1) = sLEER
    gvAusgabeMedienTabelle(4, 1) = sLEER
    
    For iParamNr = LBound(gsGsParamTabelle, 1) To UBound(gsGsParamTabelle, 1)
        If gsGsParamTabelle(iParamNr, 1) <> sLEER Then
            If gsGsParamTabelle(iParamNr, 1) = sPARNAME_PDFSETTINGS Then
                'Ist ebook ein zulssiger Wert?
                For iSpalteNr = iPARNR_ERSTERWERT _
                To Val(gsGsParamTabelle(iParamNr, iPARNR_ANZWERTE)) + iPARNR_ERSTERWERT - 1
                    If LCase(gsGsParamTabelle(iParamNr, iSpalteNr)) = sPARWERT_SPAREBOOK Then
                        'Der Wert ebook ist zulssig, Parameter muss nicht verwendet werden
                        gvAusgabeMedienTabelle(2, 0) = sAUSGABEMEDIUM_EBOOK
                    End If
                Next iSpalteNr
            End If
            
            bUndefined = False
            For iSpalteNr = iPARNR_ERSTERWERT _
            To Val(gsGsParamTabelle(iParamNr, iPARNR_ANZWERTE)) + iPARNR_ERSTERWERT - 1
                If LCase(gsGsParamTabelle(iParamNr, iSpalteNr)) = LCase(sPARWERT_UNDEFINED) Then
                    'Der Wert undefined ist zulssig, Parameter muss nicht verwendet werden
                    bUndefined = True
                End If
            Next iSpalteNr
            
            'Fr alle vier Einstellungen (default, screen, printer und prepress wird geprft,
            'ob der Parameter in die Liste aufgenommen werden muss. Das ist der Fall, wenn
            '   (a) der Parameter nicht [undefined] sein darf und er nicht durch eine Individuelle
            '       Einstellung bersteuert wird.
            '   (b) der Parameter durch eine individuelle Einstellung bersteuert wird.
            If bUndefined = False _
            And gsGsParamTabelle(iParamNr, iPARNR_ABWDEFAULT) = sPARWERT_KEINEABW Then
                gvAusgabeMedienTabelle(0, 1) = gvAusgabeMedienTabelle(0, 1) _
                    & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsParamTabelle(iParamNr, iPARNR_DEFAULT))
            ElseIf gsGsParamTabelle(iParamNr, iPARNR_ABWDEFAULT) <> sPARWERT_KEINEABW Then
                gvAusgabeMedienTabelle(0, 1) = gvAusgabeMedienTabelle(0, 1) _
                    & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsParamTabelle(iParamNr, iPARNR_ABWDEFAULT))
            End If
            If bUndefined = False _
            And gsGsParamTabelle(iParamNr, iPARNR_ABWSCREEN) = sPARWERT_KEINEABW Then
                gvAusgabeMedienTabelle(1, 1) = gvAusgabeMedienTabelle(1, 1) _
                    & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsParamTabelle(iParamNr, iPARNR_SCREEN))
            ElseIf gsGsParamTabelle(iParamNr, iPARNR_ABWSCREEN) <> sPARWERT_KEINEABW Then
                gvAusgabeMedienTabelle(1, 1) = gvAusgabeMedienTabelle(1, 1) _
                    & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsParamTabelle(iParamNr, iPARNR_ABWSCREEN))
            End If
            If bUndefined = False _
            And gsGsParamTabelle(iParamNr, iPARNR_ABWEBOOK) = sPARWERT_KEINEABW Then
                gvAusgabeMedienTabelle(2, 1) = gvAusgabeMedienTabelle(2, 1) _
                    & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsParamTabelle(iParamNr, iPARNR_EBOOK))
            ElseIf gsGsParamTabelle(iParamNr, iPARNR_ABWEBOOK) <> sPARWERT_KEINEABW Then
                gvAusgabeMedienTabelle(2, 1) = gvAusgabeMedienTabelle(2, 1) _
                    & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsParamTabelle(iParamNr, iPARNR_ABWEBOOK))
            End If
            If bUndefined = False _
            And gsGsParamTabelle(iParamNr, iPARNR_ABWPRINTER) = sPARWERT_KEINEABW Then
                gvAusgabeMedienTabelle(3, 1) = gvAusgabeMedienTabelle(3, 1) _
                    & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsParamTabelle(iParamNr, iPARNR_PRINTER))
            ElseIf gsGsParamTabelle(iParamNr, iPARNR_ABWPRINTER) <> sPARWERT_KEINEABW Then
                gvAusgabeMedienTabelle(3, 1) = gvAusgabeMedienTabelle(3, 1) _
                    & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsParamTabelle(iParamNr, iPARNR_ABWPRINTER))
            End If
            If bUndefined = False _
            And gsGsParamTabelle(iParamNr, iPARNR_ABWPREPRESS) = sPARWERT_KEINEABW Then
                gvAusgabeMedienTabelle(4, 1) = gvAusgabeMedienTabelle(4, 1) _
                    & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsParamTabelle(iParamNr, iPARNR_PREPRESS))
            ElseIf gsGsParamTabelle(iParamNr, iPARNR_ABWPREPRESS) <> sPARWERT_KEINEABW Then
                gvAusgabeMedienTabelle(4, 1) = gvAusgabeMedienTabelle(4, 1) _
                    & fsParamErstellen( _
                    gsGsParamTabelle(iParamNr, iPARNR_NAME), _
                    gsGsParamTabelle(iParamNr, iPARNR_ABWPREPRESS))
            End If
        End If
    Next iParamNr
    gvAusgabeMedienTabelle(0, 1) = Trim(gvAusgabeMedienTabelle(0, 1))
    gvAusgabeMedienTabelle(1, 1) = Trim(gvAusgabeMedienTabelle(1, 1))
    gvAusgabeMedienTabelle(2, 1) = Trim(gvAusgabeMedienTabelle(2, 1))
    gvAusgabeMedienTabelle(3, 1) = Trim(gvAusgabeMedienTabelle(3, 1))
    gvAusgabeMedienTabelle(4, 1) = Trim(gvAusgabeMedienTabelle(4, 1))

    fbAusgabeMedienTabelle_DefaultFuellen = True
    
End Function

Function fsParamErstellen(sParName As String, sParWert As String) As String
    'Die Funktion erzeugt einen Parametereintrag zum Aufruf von Ghostscript
    'Argumente:
    '   sParName ist der Name des Parameters.
    '   sParWert ist der Wert oder sLEER
    'Rckgabewert:
    '   xx..xx = Parameter
    'Effekt
    '   keiner
    
    fsParamErstellen = sLEER
    If LCase(sParWert) = LCase(sPARWERT_DEFINED) Then
        fsParamErstellen = sSPACE & sParName
    ElseIf sParWert <> sLEER _
    And LCase(sParWert) <> LCase(sPARWERT_UNDEFINED) Then
        If LCase(Left(sParName, Len(sPARPRAEFIX_D))) = sPARPRAEFIX_D _
        Or LCase(Left(sParName, Len(sPARPRAEFIX_S))) = sPARPRAEFIX_S Then
            fsParamErstellen = sSPACE & sParName & "=" & sParWert
        Else
            fsParamErstellen = sSPACE & sParName & sParWert
        End If
    End If
    
End Function

Function fbParamTabelleFuellen(sGSParamKonfigName As String) As Boolean
    'Die Funktion fllt die Tabelle gsGsParamTabelle aus der Datei GsParam.txt
    'Global:
    '   gsGsParamTabelle wird gefllt
    'Argumente:
    '   sGSParamKonfigName mit den Pfad und Dateinamen der Ghostscript-Konfigurationsdatei
    'Rckgabewert:
    '   True = gsGsParamTabelle wurde gefllt
    '   False = gsGsParamTabelle wurde nicht gefllt
    'Effekt
    '   keiner
    
    Const sTRENNZEICHEN As String = ","
    Const sKOMMENTARZEICHEN As String = "#"
    
    Dim iAnzahlZeilen As Integer
    Dim iAnzahlSpalten As Integer
    Dim iZeileNr As Integer
    Dim iSpalteNr As Integer
    Dim iSpaltenMin As Integer
    Dim iSpaltenMax As Integer
    Dim iPosVon As Integer
    Dim iPosBis As Integer
    Dim sGeleseneZeile As String
    Dim sZeile As String
    Dim sFehler As String
    Dim sEintrag As String
    Dim sIniDateiName As String
    Dim iIniDateinummer As Integer
    
    
    If Dir(sGSParamKonfigName, vbNormal) = sLEER Then
        fbParamTabelleFuellen = False
        Exit Function
    End If
    
    iAnzahlZeilen = 0
    iSpaltenMax = 0
    iSpaltenMin = 9999
    sIniDateiName = sGSParamKonfigName
    
    fbParamTabelleFuellen = True
        
    iIniDateinummer = FreeFile
    Open sIniDateiName For Input Access Read Shared As #iIniDateinummer
    Do While Not EOF(iIniDateinummer)
        Line Input #iIniDateinummer, sGeleseneZeile
        sZeile = fsErsetzeZeichen(sGeleseneZeile, vbTab, sLEER)
        sZeile = Trim(sZeile)
        If Left(sZeile, 1) <> sKOMMENTARZEICHEN _
        And Len(sZeile) > 0 Then
            'Keine Kommentarzeile
            iAnzahlZeilen = iAnzahlZeilen + 1
            'Die Zeile muss mit einem Trennzeichen abgeschlossen sein
            If Right(sZeile, 1) <> sTRENNZEICHEN Then
                sZeile = sZeile & sTRENNZEICHEN
            End If
            'Anzahl Spalten ermitteln und Min/max merken
            iAnzahlSpalten = fiZaehleZeichen(sZeile, sTRENNZEICHEN)
            If iAnzahlSpalten < iSpaltenMin Then
                iSpaltenMin = iAnzahlSpalten
            End If
            If iAnzahlSpalten > iSpaltenMax Then
                iSpaltenMax = iAnzahlSpalten
            End If
        End If
    Loop
    Close #iIniDateinummer
    If iAnzahlZeilen < 1 _
    Or iSpaltenMax < iPARNR_ERSTERWERT _
    Or iSpaltenMax < iSpaltenMin Then
        MsgBox fsText(sMSG_KEINEGUELTIGEINIDATEI _
            , sIniDateiName) _
            , vbExclamation, sTITEL_KONFIGURIERENINSTALLIEREN
        fbParamTabelleFuellen = False
        Exit Function
    End If

    ReDim gsGsParamTabelle(iAnzahlZeilen - 1, iSpaltenMax - 1)
    
    iZeileNr = -1
    iIniDateinummer = FreeFile
    Open sIniDateiName For Input Access Read Shared As #iIniDateinummer
    Do While Not EOF(iIniDateinummer)
        Line Input #iIniDateinummer, sGeleseneZeile
        sZeile = fsErsetzeZeichen(sGeleseneZeile, vbTab, sLEER)
        sZeile = Trim(sZeile)
        If Left(sZeile, 1) <> sKOMMENTARZEICHEN _
        And Len(sZeile) > 0 Then
            'Keine Kommentarzeile
            iZeileNr = iZeileNr + 1
            'Die Zeile muss mit einem Trennzeichen abgeschlossen sein
            If Right(sZeile, 1) <> sTRENNZEICHEN Then
                sZeile = sZeile & sTRENNZEICHEN
            End If
            'Anzahl Spalten ermitteln
            iAnzahlSpalten = fiZaehleZeichen(sZeile, sTRENNZEICHEN)
            'Tabelle fllen
            iPosVon = 1
            For iSpalteNr = LBound(gsGsParamTabelle, 1) To iAnzahlSpalten - 1
                iPosBis = InStr(iPosVon, sZeile, sTRENNZEICHEN)
                sEintrag = Trim(Mid(sZeile, iPosVon, iPosBis - iPosVon))
                'Der Eintrag darf nicht leer sein
                If sEintrag = sLEER Then
                    MsgBox fsText(sMSG_INIDATEIFEHLER1 _
                        , sIniDateiName _
                        , sGeleseneZeile) _
                        , vbExclamation, sTITEL_KONFIGURIERENINSTALLIEREN
                    fbParamTabelleFuellen = False
                    Exit Function
                End If
                'Fr alle symbolischen Werte einheitliche Schreibweise vorsehen
                Select Case LCase(sEintrag)
                    Case LCase(sPARWERT_NUMBER)
                        sEintrag = sPARWERT_NUMBER
                    Case LCase(sPARWERT_TEXT)
                        sEintrag = sPARWERT_TEXT
                    Case LCase(sPARWERT_DEFINED)
                        sEintrag = sPARWERT_DEFINED
                    Case LCase(sPARWERT_UNDEFINED)
                        sEintrag = sPARWERT_UNDEFINED
                End Select
                gsGsParamTabelle(iZeileNr, iSpalteNr) = sEintrag
                iPosVon = iPosBis + 1
            Next iSpalteNr
            'Parameterzeile prfen - der erste Parameter ist immer gefllt
            If iAnzahlSpalten > 1 Then
                gsGsParamTabelle(iZeileNr, iPARNR_ANZWERTE) _
                    = Str(iAnzahlSpalten - iPARNR_ERSTERWERT)
                'Es muss mindestens eine Wertespalte vorhanden sein
                If Val(gsGsParamTabelle(iZeileNr, iPARNR_ANZWERTE)) < 0 Then
                    MsgBox fsText(sMSG_INIDATEIFEHLER2 _
                        , sIniDateiName _
                        , sGeleseneZeile) _
                        , vbExclamation, sTITEL_KONFIGURIERENINSTALLIEREN
                    fbParamTabelleFuellen = False
                    Exit Do
                End If
                'nderungsflag muss richtig gefllt sein
                If Not (gsGsParamTabelle(iZeileNr, iPARNR_AENDSWITCH) = sPARAEND_JA _
                Or gsGsParamTabelle(iZeileNr, iPARNR_AENDSWITCH) = sPARAEND_NEIN _
                Or gsGsParamTabelle(iZeileNr, iPARNR_AENDSWITCH) = sPARAEND_DEFEKT) Then
                    MsgBox fsText(sMSG_INIDATEIFEHLER3 _
                        , sIniDateiName _
                        , sGeleseneZeile) _
                        , vbExclamation, sTITEL_KONFIGURIERENINSTALLIEREN
                    fbParamTabelleFuellen = False
                    Exit Do
                End If
            End If
        End If
    Loop
    Close #iIniDateinummer
        
End Function

Function fiZaehleZeichen(sZeile As String, sZeichen As String) As Integer
    'Die Funktion zhlt die Anzahl sZeichen in sString
    
    Dim lPos As Long
    
    fiZaehleZeichen = 0
    If sZeile = sLEER Or sZeichen = sLEER Then
        Exit Function
    End If
    
    lPos = InStr(1, sZeile, sZeichen) 'Erstes Vorkommen von sZeichen suchen
    Do While lPos > 0 'Solange suchen bis lPos = 0 ist; dh. sZeichen nicht mehr gefunden wurde
        fiZaehleZeichen = fiZaehleZeichen + 1
        lPos = InStr(lPos + Len(sZeichen), sZeile, sZeichen)  'Nchstes Vorkommen von sZeichen suchen
    Loop
End Function

Function fsErsetzeZeichen(sZeile As String, sZeichen1 As String, sZeichen2) As String
    'Die Funktion ersetzt alle sZeichen1 in sString durch sZeichen2
    'sZeichen1 und sZeichen2 knnen ungleich lang sein
    
    Dim lPos As Long
    Dim lPosVon As Long
    Dim lPosBis As Long
    
    fsErsetzeZeichen = sLEER
    If sZeile = sLEER Or sZeichen1 = sLEER Then
        Exit Function
    End If
    
    lPosVon = 1
    lPosBis = 0
    lPos = InStr(1, sZeile, sZeichen1) 'Erstes Vorkommen von sZeichen1 suchen
    Do While lPos > 0 'Solange suchen bis lPosBis = 0 ist; dh. sZeichen1 nicht mehr gefunden wurde
        lPosBis = lPos
        If lPosVon < lPosBis Then
            fsErsetzeZeichen = fsErsetzeZeichen & Mid(sZeile, lPosVon, lPosBis - lPosVon)
        End If
        fsErsetzeZeichen = fsErsetzeZeichen & sZeichen2
        lPosVon = lPosBis + Len(sZeichen1)
        lPos = InStr(lPosVon, sZeile, sZeichen1) 'Nchstes Vorkommen von sZeichen suchen
    Loop
    If lPosVon <= Len(sZeile) Then
        fsErsetzeZeichen = fsErsetzeZeichen & Mid(sZeile, lPosVon)
    End If
    
End Function

Function fsGSParamKonfigName_ermitteln() As String
    'Die Funktion ermittelt den Pfad und Dateinamen der Datei mit den Konfigurations-Parametern von
    'Ghostscript.
    'Wenn keine Ghostscript-Version ermittelt werden kann, wird Version 7 angenommen
    'Global:
    '   gsInstVerzeichnis wird gelesen
    '   gsGSProgrammName wird gelesen
    'Rckgabewert:
    '   Pfad und Dateinamen der Datei mit den Konfigurations-Parameters
    'Effekt
    '   keiner
        
    Dim sGSProgrammVersion As String
    
    sGSProgrammVersion = gsDefaultGhostscriptTabelle(fiGhostscriptDefaultNr_ermitteln(gsGSProgrammName, 1), 3)
        
    If Left(sGSProgrammVersion, 3) = "8.5" Then
        fsGSParamKonfigName_ermitteln = gsInstVerzeichnis & sKONFIGDIR & sGSINIDATEI_85x
    ElseIf Left(sGSProgrammVersion, 3) = "8.1" Then
        fsGSParamKonfigName_ermitteln = gsInstVerzeichnis & sKONFIGDIR & sGSINIDATEI_81x
    ElseIf Left(sGSProgrammVersion, 3) = "8.0" > 0 Then
        fsGSParamKonfigName_ermitteln = gsInstVerzeichnis & sKONFIGDIR & sGSINIDATEI_80x
    ElseIf Left(sGSProgrammVersion, 3) = "8." > 0 Then
        fsGSParamKonfigName_ermitteln = gsInstVerzeichnis & sKONFIGDIR & sGSINIDATEI_80x
    Else
        fsGSParamKonfigName_ermitteln = gsInstVerzeichnis & sKONFIGDIR & sGSINIDATEI_70x
    End If
    
End Function


'===================================================================================================
'Ende.
'===================================================================================================


